/* Check.c generated by valac 0.56.17, the Vala compiler
 * generated from Check.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include "vala-linter.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>
#include <glib-object.h>
#include <vala.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	VALA_LINT_CHECK_0_PROPERTY,
	VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY,
	VALA_LINT_CHECK_TITLE_PROPERTY,
	VALA_LINT_CHECK_DESCRIPTION_PROPERTY,
	VALA_LINT_CHECK_STATE_PROPERTY,
	VALA_LINT_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_check_properties[VALA_LINT_CHECK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _vala_lint_format_mistake_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_format_mistake_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ValaLintCheckPrivate {
	gboolean _single_mistake_in_line;
	gchar* _title;
	gchar* _description;
	ValaLintConfigState _state;
};

static gint ValaLintCheck_private_offset;
static gpointer vala_lint_check_parent_class = NULL;

static void vala_lint_check_real_check (ValaLintCheck* self,
                                 ValaArrayList* parse_result,
                                 ValaArrayList** mistake_list);
static gboolean vala_lint_check_real_apply_fix (ValaLintCheck* self,
                                         ValaSourceLocation* begin,
                                         ValaSourceLocation* end,
                                         gchar** contents);
static void vala_lint_check_finalize (GObject * obj);
static GType vala_lint_check_get_type_once (void);
static void _vala_vala_lint_check_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_vala_lint_check_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
vala_lint_check_get_instance_private (ValaLintCheck* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintCheck_private_offset);
}

/**
     * Checks a given parse result for formatting mistakes.
     *
     * @param parse_result The parsed string.
     * @param mistake_list The list new mistakes should be added to.
     */
static void
vala_lint_check_real_check (ValaLintCheck* self,
                            ValaArrayList* parse_result,
                            ValaArrayList** mistake_list)
{
#line 50 "../lib/Check.vala"
	g_critical ("Type `%s' does not implement abstract method `vala_lint_check_check'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 50 "../lib/Check.vala"
	return;
#line 107 "Check.c"
}

void
vala_lint_check_check (ValaLintCheck* self,
                       ValaArrayList* parse_result,
                       ValaArrayList** mistake_list)
{
	ValaLintCheckClass* _klass_;
#line 50 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 50 "../lib/Check.vala"
	_klass_ = VALA_LINT_CHECK_GET_CLASS (self);
#line 50 "../lib/Check.vala"
	if (_klass_->check) {
#line 50 "../lib/Check.vala"
		_klass_->check (self, parse_result, mistake_list);
#line 124 "Check.c"
	}
}

/**
     * Adds a mistake based on a regex pattern.
     *
     * @param pattern The regex pattern.
     * @param mistake The mistake description.
     * @param parse_result The current parse result element.
     * @param mistakes The mistakes list.
     * @param column_offset The offset between the mistake char position and the regex pattern start.
     */
void
vala_lint_check_add_regex_mistake (ValaLintCheck* self,
                                   const gchar* pattern,
                                   const gchar* mistake,
                                   ParseResult* parse_result,
                                   ValaArrayList** mistakes,
                                   gint length,
                                   gint column_offset,
                                   gboolean return_after_mistake)
{
	GMatchInfo* match_info = NULL;
	GError* _inner_error0_ = NULL;
#line 62 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 62 "../lib/Check.vala"
	g_return_if_fail (pattern != NULL);
#line 62 "../lib/Check.vala"
	g_return_if_fail (mistake != NULL);
#line 62 "../lib/Check.vala"
	g_return_if_fail (parse_result != NULL);
#line 62 "../lib/Check.vala"
	g_return_if_fail (*mistakes != NULL);
#line 159 "Check.c"
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		ParseResult _tmp2_;
		const gchar* _tmp3_;
		GMatchInfo* _tmp4_ = NULL;
#line 72 "../lib/Check.vala"
		_tmp0_ = g_regex_new (pattern, 0, 0, &_inner_error0_);
#line 72 "../lib/Check.vala"
		regex = _tmp0_;
#line 72 "../lib/Check.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "Check.c"
			goto __catch0_g_error;
		}
#line 73 "../lib/Check.vala"
		_tmp1_ = regex;
#line 73 "../lib/Check.vala"
		_tmp2_ = *parse_result;
#line 73 "../lib/Check.vala"
		_tmp3_ = _tmp2_.text;
#line 73 "../lib/Check.vala"
		g_regex_match (_tmp1_, _tmp3_, 0, &_tmp4_);
#line 73 "../lib/Check.vala"
		_g_match_info_unref0 (match_info);
#line 73 "../lib/Check.vala"
		match_info = _tmp4_;
#line 74 "../lib/Check.vala"
		while (TRUE) {
#line 190 "Check.c"
			GMatchInfo* _tmp5_;
			gint pos_start = 0;
			gint pos_end = 0;
			GMatchInfo* _tmp6_;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint pos_mistake = 0;
			ValaSourceLocation begin = {0};
			ParseResult _tmp9_;
			ValaSourceLocation _tmp10_;
			ParseResult _tmp11_;
			const gchar* _tmp12_;
			ValaSourceLocation _tmp13_ = {0};
			ValaSourceLocation end = {0};
			ParseResult _tmp14_;
			ValaSourceLocation _tmp15_;
			ParseResult _tmp16_;
			const gchar* _tmp17_;
			ValaSourceLocation _tmp18_ = {0};
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
			GMatchInfo* _tmp35_;
#line 74 "../lib/Check.vala"
			_tmp5_ = match_info;
#line 74 "../lib/Check.vala"
			if (!g_match_info_matches (_tmp5_)) {
#line 74 "../lib/Check.vala"
				break;
#line 219 "Check.c"
			}
#line 76 "../lib/Check.vala"
			_tmp6_ = match_info;
#line 76 "../lib/Check.vala"
			g_match_info_fetch_pos (_tmp6_, 0, &_tmp7_, &_tmp8_);
#line 76 "../lib/Check.vala"
			pos_start = _tmp7_;
#line 76 "../lib/Check.vala"
			pos_end = _tmp8_;
#line 78 "../lib/Check.vala"
			pos_mistake = pos_start + column_offset;
#line 79 "../lib/Check.vala"
			_tmp9_ = *parse_result;
#line 79 "../lib/Check.vala"
			_tmp10_ = _tmp9_.begin;
#line 79 "../lib/Check.vala"
			_tmp11_ = *parse_result;
#line 79 "../lib/Check.vala"
			_tmp12_ = _tmp11_.text;
#line 79 "../lib/Check.vala"
			vala_lint_utils_get_absolute_location (&_tmp10_, _tmp12_, pos_mistake, &_tmp13_);
#line 79 "../lib/Check.vala"
			begin = _tmp13_;
#line 80 "../lib/Check.vala"
			_tmp14_ = *parse_result;
#line 80 "../lib/Check.vala"
			_tmp15_ = _tmp14_.begin;
#line 80 "../lib/Check.vala"
			_tmp16_ = *parse_result;
#line 80 "../lib/Check.vala"
			_tmp17_ = _tmp16_.text;
#line 80 "../lib/Check.vala"
			vala_lint_utils_get_absolute_location (&_tmp15_, _tmp17_, pos_mistake + length, &_tmp18_);
#line 80 "../lib/Check.vala"
			end = _tmp18_;
#line 83 "../lib/Check.vala"
			_tmp20_ = self->priv->_single_mistake_in_line;
#line 83 "../lib/Check.vala"
			if (!_tmp20_) {
#line 83 "../lib/Check.vala"
				_tmp19_ = TRUE;
#line 261 "Check.c"
			} else {
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_;
				gboolean _tmp24_;
#line 84 "../lib/Check.vala"
				_tmp23_ = vala_collection_get_is_empty ((ValaCollection*) (*mistakes));
#line 84 "../lib/Check.vala"
				_tmp24_ = _tmp23_;
#line 84 "../lib/Check.vala"
				if (_tmp24_) {
#line 84 "../lib/Check.vala"
					_tmp22_ = TRUE;
#line 275 "Check.c"
				} else {
					gpointer _tmp25_;
					ValaLintFormatMistake* _tmp26_;
					ValaLintCheck* _tmp27_;
#line 84 "../lib/Check.vala"
					_tmp25_ = vala_list_last ((ValaList*) (*mistakes));
#line 84 "../lib/Check.vala"
					_tmp26_ = (ValaLintFormatMistake*) _tmp25_;
#line 84 "../lib/Check.vala"
					_tmp27_ = (*_tmp26_).check;
#line 84 "../lib/Check.vala"
					_tmp22_ = _tmp27_ != self;
#line 84 "../lib/Check.vala"
					_vala_lint_format_mistake_free0 (_tmp26_);
#line 290 "Check.c"
				}
#line 84 "../lib/Check.vala"
				if (_tmp22_) {
#line 84 "../lib/Check.vala"
					_tmp21_ = TRUE;
#line 296 "Check.c"
				} else {
					gpointer _tmp28_;
					ValaLintFormatMistake* _tmp29_;
					ValaSourceLocation _tmp30_;
					ValaSourceLocation _tmp31_;
#line 85 "../lib/Check.vala"
					_tmp28_ = vala_list_last ((ValaList*) (*mistakes));
#line 85 "../lib/Check.vala"
					_tmp29_ = (ValaLintFormatMistake*) _tmp28_;
#line 85 "../lib/Check.vala"
					_tmp30_ = (*_tmp29_).begin;
#line 85 "../lib/Check.vala"
					_tmp31_ = begin;
#line 85 "../lib/Check.vala"
					_tmp21_ = _tmp30_.line < _tmp31_.line;
#line 85 "../lib/Check.vala"
					_vala_lint_format_mistake_free0 (_tmp29_);
#line 314 "Check.c"
				}
#line 84 "../lib/Check.vala"
				_tmp19_ = _tmp21_;
#line 318 "Check.c"
			}
#line 83 "../lib/Check.vala"
			if (_tmp19_) {
#line 322 "Check.c"
				ValaSourceLocation _tmp32_;
				ValaSourceLocation _tmp33_;
				ValaLintFormatMistake _tmp34_ = {0};
#line 87 "../lib/Check.vala"
				_tmp32_ = begin;
#line 87 "../lib/Check.vala"
				_tmp33_ = end;
#line 87 "../lib/Check.vala"
				_g_object_unref0 (_tmp34_.check);
#line 87 "../lib/Check.vala"
				_tmp34_.check = self;
#line 87 "../lib/Check.vala"
				_tmp34_.begin = _tmp32_;
#line 87 "../lib/Check.vala"
				_tmp34_.end = _tmp33_;
#line 87 "../lib/Check.vala"
				_g_free0 (_tmp34_.mistake);
#line 87 "../lib/Check.vala"
				_tmp34_.mistake = mistake;
#line 87 "../lib/Check.vala"
				vala_lint_check_add_mistake (self, &_tmp34_, mistakes);
#line 344 "Check.c"
			}
#line 90 "../lib/Check.vala"
			if (return_after_mistake) {
#line 91 "../lib/Check.vala"
				break;
#line 350 "Check.c"
			}
#line 93 "../lib/Check.vala"
			_tmp35_ = match_info;
#line 93 "../lib/Check.vala"
			g_match_info_next (_tmp35_, &_inner_error0_);
#line 93 "../lib/Check.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../lib/Check.vala"
				_g_regex_unref0 (regex);
#line 360 "Check.c"
				goto __catch0_g_error;
			}
		}
#line 71 "../lib/Check.vala"
		_g_regex_unref0 (regex);
#line 366 "Check.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 71 "../lib/Check.vala"
		g_clear_error (&_inner_error0_);
#line 96 "../lib/Check.vala"
		g_critical ("Check.vala:96: %s is not a valid Regex", pattern);
#line 375 "Check.c"
	}
	__finally0:
#line 71 "../lib/Check.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../lib/Check.vala"
		_g_match_info_unref0 (match_info);
#line 71 "../lib/Check.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../lib/Check.vala"
		g_clear_error (&_inner_error0_);
#line 71 "../lib/Check.vala"
		return;
#line 388 "Check.c"
	}
#line 62 "../lib/Check.vala"
	_g_match_info_unref0 (match_info);
#line 392 "Check.c"
}

/**
     * Adds a mistake to the mistake list and checks for duplicates.
     *
     * @param mistake The mistake.
     * @param mistakes The mistakes list.
     */
void
vala_lint_check_add_mistake (ValaLintCheck* self,
                             ValaLintFormatMistake* mistake,
                             ValaArrayList** mistakes)
{
	ValaLintFormatMistake _tmp0_;
#line 106 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/Check.vala"
	g_return_if_fail (mistake != NULL);
#line 106 "../lib/Check.vala"
	g_return_if_fail (*mistakes != NULL);
#line 107 "../lib/Check.vala"
	_tmp0_ = *mistake;
#line 107 "../lib/Check.vala"
	if (!vala_collection_contains ((ValaCollection*) (*mistakes), &_tmp0_)) {
#line 417 "Check.c"
		ValaLintFormatMistake _tmp1_;
#line 108 "../lib/Check.vala"
		_tmp1_ = *mistake;
#line 108 "../lib/Check.vala"
		vala_collection_add ((ValaCollection*) (*mistakes), &_tmp1_);
#line 423 "Check.c"
	}
}

/**
     * Updates the content with the fixed version.
     *
     * @param begin the source location where the mistake begins
     * @param end the source location where the mistake ends
     * @param contents the contents of the file containing the mistake
     *
     * @return whether the mistake was fixed
     */
static gboolean
vala_lint_check_real_apply_fix (ValaLintCheck* self,
                                ValaSourceLocation* begin,
                                ValaSourceLocation* end,
                                gchar** contents)
{
	gboolean result;
#line 121 "../lib/Check.vala"
	g_return_val_if_fail (begin != NULL, FALSE);
#line 121 "../lib/Check.vala"
	g_return_val_if_fail (end != NULL, FALSE);
#line 121 "../lib/Check.vala"
	g_return_val_if_fail (*contents != NULL, FALSE);
#line 122 "../lib/Check.vala"
	result = FALSE;
#line 122 "../lib/Check.vala"
	return result;
#line 453 "Check.c"
}

gboolean
vala_lint_check_apply_fix (ValaLintCheck* self,
                           ValaSourceLocation* begin,
                           ValaSourceLocation* end,
                           gchar** contents)
{
	ValaLintCheckClass* _klass_;
#line 121 "../lib/Check.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../lib/Check.vala"
	_klass_ = VALA_LINT_CHECK_GET_CLASS (self);
#line 121 "../lib/Check.vala"
	if (_klass_->apply_fix) {
#line 121 "../lib/Check.vala"
		return _klass_->apply_fix (self, begin, end, contents);
#line 471 "Check.c"
	}
#line 121 "../lib/Check.vala"
	return FALSE;
#line 475 "Check.c"
}

ValaLintCheck*
vala_lint_check_construct (GType object_type)
{
	ValaLintCheck * self = NULL;
#line 22 "../lib/Check.vala"
	self = (ValaLintCheck*) g_object_new (object_type, NULL);
#line 22 "../lib/Check.vala"
	return self;
#line 486 "Check.c"
}

gboolean
vala_lint_check_get_single_mistake_in_line (ValaLintCheck* self)
{
	gboolean result;
#line 27 "../lib/Check.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../lib/Check.vala"
	result = self->priv->_single_mistake_in_line;
#line 27 "../lib/Check.vala"
	return result;
#line 499 "Check.c"
}

static void
vala_lint_check_set_single_mistake_in_line (ValaLintCheck* self,
                                            gboolean value)
{
	gboolean old_value;
#line 27 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/Check.vala"
	old_value = vala_lint_check_get_single_mistake_in_line (self);
#line 27 "../lib/Check.vala"
	if (old_value != value) {
#line 27 "../lib/Check.vala"
		self->priv->_single_mistake_in_line = value;
#line 27 "../lib/Check.vala"
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY]);
#line 517 "Check.c"
	}
}

const gchar*
vala_lint_check_get_title (ValaLintCheck* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../lib/Check.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../lib/Check.vala"
	_tmp0_ = self->priv->_title;
#line 32 "../lib/Check.vala"
	result = _tmp0_;
#line 32 "../lib/Check.vala"
	return result;
#line 534 "Check.c"
}

static void
vala_lint_check_set_title (ValaLintCheck* self,
                           const gchar* value)
{
	gchar* old_value;
#line 32 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/Check.vala"
	old_value = vala_lint_check_get_title (self);
#line 32 "../lib/Check.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 548 "Check.c"
		gchar* _tmp0_;
#line 32 "../lib/Check.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../lib/Check.vala"
		_g_free0 (self->priv->_title);
#line 32 "../lib/Check.vala"
		self->priv->_title = _tmp0_;
#line 32 "../lib/Check.vala"
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_TITLE_PROPERTY]);
#line 558 "Check.c"
	}
}

const gchar*
vala_lint_check_get_description (ValaLintCheck* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../lib/Check.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../lib/Check.vala"
	_tmp0_ = self->priv->_description;
#line 37 "../lib/Check.vala"
	result = _tmp0_;
#line 37 "../lib/Check.vala"
	return result;
#line 575 "Check.c"
}

static void
vala_lint_check_set_description (ValaLintCheck* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 37 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/Check.vala"
	old_value = vala_lint_check_get_description (self);
#line 37 "../lib/Check.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 589 "Check.c"
		gchar* _tmp0_;
#line 37 "../lib/Check.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../lib/Check.vala"
		_g_free0 (self->priv->_description);
#line 37 "../lib/Check.vala"
		self->priv->_description = _tmp0_;
#line 37 "../lib/Check.vala"
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_DESCRIPTION_PROPERTY]);
#line 599 "Check.c"
	}
}

ValaLintConfigState
vala_lint_check_get_state (ValaLintCheck* self)
{
	ValaLintConfigState result;
#line 42 "../lib/Check.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../lib/Check.vala"
	result = self->priv->_state;
#line 42 "../lib/Check.vala"
	return result;
#line 613 "Check.c"
}

void
vala_lint_check_set_state (ValaLintCheck* self,
                           ValaLintConfigState value)
{
	ValaLintConfigState old_value;
#line 42 "../lib/Check.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/Check.vala"
	old_value = vala_lint_check_get_state (self);
#line 42 "../lib/Check.vala"
	if (old_value != value) {
#line 42 "../lib/Check.vala"
		self->priv->_state = value;
#line 42 "../lib/Check.vala"
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_STATE_PROPERTY]);
#line 631 "Check.c"
	}
}

static void
vala_lint_check_class_init (ValaLintCheckClass * klass,
                            gpointer klass_data)
{
#line 22 "../lib/Check.vala"
	vala_lint_check_parent_class = g_type_class_peek_parent (klass);
#line 22 "../lib/Check.vala"
	g_type_class_adjust_private_offset (klass, &ValaLintCheck_private_offset);
#line 22 "../lib/Check.vala"
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList**)) vala_lint_check_real_check;
#line 22 "../lib/Check.vala"
	((ValaLintCheckClass *) klass)->apply_fix = (gboolean (*) (ValaLintCheck*, ValaSourceLocation*, ValaSourceLocation*, gchar**)) vala_lint_check_real_apply_fix;
#line 22 "../lib/Check.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_vala_lint_check_get_property;
#line 22 "../lib/Check.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_vala_lint_check_set_property;
#line 22 "../lib/Check.vala"
	G_OBJECT_CLASS (klass)->finalize = vala_lint_check_finalize;
#line 653 "Check.c"
	/**
	     * Property whether the check should allow multiple mistakes in a single line.
	     */
#line 22 "../lib/Check.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY] = g_param_spec_boolean ("single-mistake-in-line", "single-mistake-in-line", "single-mistake-in-line", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 659 "Check.c"
	/**
	     * Short but descriptive title of the check.
	     */
#line 22 "../lib/Check.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_TITLE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 665 "Check.c"
	/**
	     * A short description of what this class checks for.
	     */
#line 22 "../lib/Check.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_DESCRIPTION_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 671 "Check.c"
	/**
	     * Property whether the check is enabled in the current linter config.
	     */
#line 22 "../lib/Check.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_STATE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", VALA_LINT_CONFIG_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 677 "Check.c"
}

static void
vala_lint_check_instance_init (ValaLintCheck * self,
                               gpointer klass)
{
#line 22 "../lib/Check.vala"
	self->priv = vala_lint_check_get_instance_private (self);
#line 27 "../lib/Check.vala"
	self->priv->_single_mistake_in_line = FALSE;
#line 688 "Check.c"
}

static void
vala_lint_check_finalize (GObject * obj)
{
	ValaLintCheck * self;
#line 22 "../lib/Check.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_CHECK, ValaLintCheck);
#line 32 "../lib/Check.vala"
	_g_free0 (self->priv->_title);
#line 37 "../lib/Check.vala"
	_g_free0 (self->priv->_description);
#line 22 "../lib/Check.vala"
	G_OBJECT_CLASS (vala_lint_check_parent_class)->finalize (obj);
#line 703 "Check.c"
}

static GType
vala_lint_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintCheck), 0, (GInstanceInitFunc) vala_lint_check_instance_init, NULL };
	GType vala_lint_check_type_id;
	vala_lint_check_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintCheck", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ValaLintCheck_private_offset = g_type_add_instance_private (vala_lint_check_type_id, sizeof (ValaLintCheckPrivate));
	return vala_lint_check_type_id;
}

GType
vala_lint_check_get_type (void)
{
	static volatile gsize vala_lint_check_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_check_type_id__once)) {
		GType vala_lint_check_type_id;
		vala_lint_check_type_id = vala_lint_check_get_type_once ();
		g_once_init_leave (&vala_lint_check_type_id__once, vala_lint_check_type_id);
	}
	return vala_lint_check_type_id__once;
}

static void
_vala_vala_lint_check_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ValaLintCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_TYPE_CHECK, ValaLintCheck);
#line 22 "../lib/Check.vala"
	switch (property_id) {
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY:
#line 22 "../lib/Check.vala"
		g_value_set_boolean (value, vala_lint_check_get_single_mistake_in_line (self));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_TITLE_PROPERTY:
#line 22 "../lib/Check.vala"
		g_value_set_string (value, vala_lint_check_get_title (self));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_DESCRIPTION_PROPERTY:
#line 22 "../lib/Check.vala"
		g_value_set_string (value, vala_lint_check_get_description (self));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_STATE_PROPERTY:
#line 22 "../lib/Check.vala"
		g_value_set_enum (value, vala_lint_check_get_state (self));
#line 22 "../lib/Check.vala"
		break;
#line 762 "Check.c"
		default:
#line 22 "../lib/Check.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../lib/Check.vala"
		break;
#line 768 "Check.c"
	}
}

static void
_vala_vala_lint_check_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ValaLintCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_TYPE_CHECK, ValaLintCheck);
#line 22 "../lib/Check.vala"
	switch (property_id) {
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY:
#line 22 "../lib/Check.vala"
		vala_lint_check_set_single_mistake_in_line (self, g_value_get_boolean (value));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_TITLE_PROPERTY:
#line 22 "../lib/Check.vala"
		vala_lint_check_set_title (self, g_value_get_string (value));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_DESCRIPTION_PROPERTY:
#line 22 "../lib/Check.vala"
		vala_lint_check_set_description (self, g_value_get_string (value));
#line 22 "../lib/Check.vala"
		break;
#line 22 "../lib/Check.vala"
		case VALA_LINT_CHECK_STATE_PROPERTY:
#line 22 "../lib/Check.vala"
		vala_lint_check_set_state (self, g_value_get_enum (value));
#line 22 "../lib/Check.vala"
		break;
#line 806 "Check.c"
		default:
#line 22 "../lib/Check.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../lib/Check.vala"
		break;
#line 812 "Check.c"
	}
}

