/* UnnecessaryStringTemplateCheck.c generated by valac 0.56.17, the Vala compiler
 * generated from UnnecessaryStringTemplateCheck.vala, do not modify */

/*
 * Copyright (c) 2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <vala.h>

#define VALA_LINT_CHECKS_UNNECESSARY_STRING_TEMPLATE_CHECK_MESSAGE _ ("String template can be simplified using a literal")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	VALA_LINT_CHECKS_UNNECESSARY_STRING_TEMPLATE_CHECK_0_PROPERTY,
	VALA_LINT_CHECKS_UNNECESSARY_STRING_TEMPLATE_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_checks_unnecessary_string_template_check_properties[VALA_LINT_CHECKS_UNNECESSARY_STRING_TEMPLATE_CHECK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer vala_lint_checks_unnecessary_string_template_check_parent_class = NULL;

static void vala_lint_checks_unnecessary_string_template_check_real_check (ValaLintCheck* base,
                                                                    ValaArrayList* parse_result,
                                                                    ValaArrayList** mistake_list);
static GType vala_lint_checks_unnecessary_string_template_check_get_type_once (void);

ValaLintChecksUnnecessaryStringTemplateCheck*
vala_lint_checks_unnecessary_string_template_check_construct (GType object_type)
{
	ValaLintChecksUnnecessaryStringTemplateCheck * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 24 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	self = (ValaLintChecksUnnecessaryStringTemplateCheck*) g_object_new (object_type, "title", "unnecessary-string-template", "description", _ ("Checks for templates that could be replaced by a string literal"), NULL);
#line 29 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp0_ = vala_lint_check_get_title ((ValaLintCheck*) self);
#line 29 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp1_ = _tmp0_;
#line 29 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	vala_lint_check_set_state ((ValaLintCheck*) self, vala_lint_config_get_state (_tmp1_));
#line 23 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	return self;
#line 74 "UnnecessaryStringTemplateCheck.c"
}

ValaLintChecksUnnecessaryStringTemplateCheck*
vala_lint_checks_unnecessary_string_template_check_new (void)
{
#line 23 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	return vala_lint_checks_unnecessary_string_template_check_construct (VALA_LINT_CHECKS_TYPE_UNNECESSARY_STRING_TEMPLATE_CHECK);
#line 82 "UnnecessaryStringTemplateCheck.c"
}

static void
vala_lint_checks_unnecessary_string_template_check_real_check (ValaLintCheck* base,
                                                               ValaArrayList* parse_result,
                                                               ValaArrayList** mistake_list)
{
	ValaLintChecksUnnecessaryStringTemplateCheck * self;
#line 32 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	self = (ValaLintChecksUnnecessaryStringTemplateCheck*) base;
#line 32 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	g_return_if_fail (parse_result != NULL);
#line 32 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	g_return_if_fail (*mistake_list != NULL);
#line 97 "UnnecessaryStringTemplateCheck.c"
}

void
vala_lint_checks_unnecessary_string_template_check_check_template (ValaLintChecksUnnecessaryStringTemplateCheck* self,
                                                                   ValaTemplate* tmpl,
                                                                   ValaArrayList** mistake_list)
{
	ValaLintConfigState _tmp0_;
	ValaLintConfigState _tmp1_;
	ValaList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 37 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	g_return_if_fail (tmpl != NULL);
#line 37 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	g_return_if_fail (*mistake_list != NULL);
#line 38 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp0_ = vala_lint_check_get_state ((ValaLintCheck*) self);
#line 38 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp1_ = _tmp0_;
#line 38 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	if (_tmp1_ == VALA_LINT_CONFIG_STATE_OFF) {
#line 39 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		return;
#line 124 "UnnecessaryStringTemplateCheck.c"
	}
#line 42 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp2_ = vala_template_get_expressions (tmpl);
#line 42 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
#line 42 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	_tmp4_ = _tmp3_;
#line 42 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	if (_tmp4_ <= 1) {
#line 134 "UnnecessaryStringTemplateCheck.c"
		ValaSourceReference* _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceLocation _tmp7_ = {0};
		ValaSourceLocation _tmp8_;
		ValaSourceReference* _tmp9_;
		ValaSourceReference* _tmp10_;
		ValaSourceLocation _tmp11_ = {0};
		ValaSourceLocation _tmp12_;
		ValaLintFormatMistake _tmp13_ = {0};
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp5_ = vala_code_node_get_source_reference ((ValaCodeNode*) tmpl);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp6_ = _tmp5_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		vala_source_reference_get_begin (_tmp6_, &_tmp7_);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp8_ = _tmp7_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp9_ = vala_code_node_get_source_reference ((ValaCodeNode*) tmpl);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp10_ = _tmp9_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		vala_source_reference_get_end (_tmp10_, &_tmp11_);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp12_ = _tmp11_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_g_object_unref0 (_tmp13_.check);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp13_.check = (ValaLintCheck*) self;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp13_.begin = _tmp8_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp13_.end = _tmp12_;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_g_free0 (_tmp13_.mistake);
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		_tmp13_.mistake = VALA_LINT_CHECKS_UNNECESSARY_STRING_TEMPLATE_CHECK_MESSAGE;
#line 43 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
		vala_lint_check_add_mistake ((ValaLintCheck*) self, &_tmp13_, mistake_list);
#line 174 "UnnecessaryStringTemplateCheck.c"
	}
}

static void
vala_lint_checks_unnecessary_string_template_check_class_init (ValaLintChecksUnnecessaryStringTemplateCheckClass * klass,
                                                               gpointer klass_data)
{
#line 20 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	vala_lint_checks_unnecessary_string_template_check_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/Checks/UnnecessaryStringTemplateCheck.vala"
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList**)) vala_lint_checks_unnecessary_string_template_check_real_check;
#line 186 "UnnecessaryStringTemplateCheck.c"
}

static void
vala_lint_checks_unnecessary_string_template_check_instance_init (ValaLintChecksUnnecessaryStringTemplateCheck * self,
                                                                  gpointer klass)
{
}

static GType
vala_lint_checks_unnecessary_string_template_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintChecksUnnecessaryStringTemplateCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_checks_unnecessary_string_template_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintChecksUnnecessaryStringTemplateCheck), 0, (GInstanceInitFunc) vala_lint_checks_unnecessary_string_template_check_instance_init, NULL };
	GType vala_lint_checks_unnecessary_string_template_check_type_id;
	vala_lint_checks_unnecessary_string_template_check_type_id = g_type_register_static (VALA_LINT_TYPE_CHECK, "ValaLintChecksUnnecessaryStringTemplateCheck", &g_define_type_info, 0);
	return vala_lint_checks_unnecessary_string_template_check_type_id;
}

GType
vala_lint_checks_unnecessary_string_template_check_get_type (void)
{
	static volatile gsize vala_lint_checks_unnecessary_string_template_check_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_checks_unnecessary_string_template_check_type_id__once)) {
		GType vala_lint_checks_unnecessary_string_template_check_type_id;
		vala_lint_checks_unnecessary_string_template_check_type_id = vala_lint_checks_unnecessary_string_template_check_get_type_once ();
		g_once_init_leave (&vala_lint_checks_unnecessary_string_template_check_type_id__once, vala_lint_checks_unnecessary_string_template_check_type_id);
	}
	return vala_lint_checks_unnecessary_string_template_check_type_id__once;
}

