/* Linter.c generated by valac 0.56.17, the Vala compiler
 * generated from Linter.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include "vala-linter.h"
#include <vala.h>
#include <glib-object.h>
#include <glib.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define VALA_LINT_TYPE_VISITOR (vala_lint_visitor_get_type ())
#define VALA_LINT_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitor))
#define VALA_LINT_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))
#define VALA_LINT_IS_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_IS_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))

typedef struct _ValaLintVisitor ValaLintVisitor;
typedef struct _ValaLintVisitorClass ValaLintVisitorClass;
enum  {
	VALA_LINT_LINTER_0_PROPERTY,
	VALA_LINT_LINTER_NUM_PROPERTIES
};
static GParamSpec* vala_lint_linter_properties[VALA_LINT_LINTER_NUM_PROPERTIES];
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ValaLintVisitorPrivate ValaLintVisitorPrivate;

#define VALA_LINT_TYPE_REPORTER (vala_lint_reporter_get_type ())
#define VALA_LINT_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_REPORTER, ValaLintReporter))
#define VALA_LINT_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_REPORTER, ValaLintReporterClass))
#define VALA_LINT_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_REPORTER))
#define VALA_LINT_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_REPORTER))
#define VALA_LINT_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_REPORTER, ValaLintReporterClass))

typedef struct _ValaLintReporter ValaLintReporter;
typedef struct _ValaLintReporterClass ValaLintReporterClass;
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_report_unref0(var) ((var == NULL) ? NULL : (var = (vala_report_unref (var), NULL)))
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))

struct _ValaLintLinterPrivate {
	ValaLintVisitor* visitor;
};

struct _ValaLintVisitor {
	ValaCodeVisitor parent_instance;
	ValaLintVisitorPrivate * priv;
	ValaArrayList* mistake_list;
	ValaLintChecksDoubleSemicolonCheck* double_semicolon_check;
	ValaLintChecksEllipsisCheck* ellipsis_check;
	ValaLintChecksNamingConventionCheck* naming_convention_check;
	ValaLintChecksUnnecessaryStringTemplateCheck* unnecessary_string_template_check;
	ValaLintChecksNoSpaceCheck* no_space_check;
};

struct _ValaLintVisitorClass {
	ValaCodeVisitorClass parent_class;
};

static gint ValaLintLinter_private_offset;
static gpointer vala_lint_linter_parent_class = NULL;

VALA_EXTERN GType vala_lint_visitor_get_type (void) G_GNUC_CONST ;
static gboolean __lambda7_ (ValaLintLinter* self,
                     ValaLintCheck* c);
static gboolean ___lambda7__vala_lint_utils_filter_function (gconstpointer element,
                                                      gpointer self);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_new (void);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_construct (GType object_type);
static gboolean __lambda8_ (ValaLintFormatMistake* a,
                     ValaLintFormatMistake* b);
static gboolean ___lambda8__gequal_func (gconstpointer a,
                                  gconstpointer b);
VALA_EXTERN GType vala_lint_reporter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ValaLintReporter* vala_lint_reporter_new (ValaArrayList* mistake_list);
VALA_EXTERN ValaLintReporter* vala_lint_reporter_construct (GType object_type,
                                                ValaArrayList* mistake_list);
VALA_EXTERN void vala_lint_visitor_set_mistake_list (ValaLintVisitor* self,
                                         ValaArrayList* mistake_list);
static gint ___lambda9_ (ValaLintLinter* self,
                  ValaLintFormatMistake* a,
                  ValaLintFormatMistake* b);
static gint ____lambda9__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void vala_lint_linter_finalize (GObject * obj);
static GType vala_lint_linter_get_type_once (void);

static inline gpointer
vala_lint_linter_get_instance_private (ValaLintLinter* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintLinter_private_offset);
}

static gboolean
__lambda7_ (ValaLintLinter* self,
            ValaLintCheck* c)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 46 "../lib/Linter.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 46 "../lib/Linter.vala"
	_tmp0_ = vala_lint_check_get_title (c);
#line 46 "../lib/Linter.vala"
	_tmp1_ = _tmp0_;
#line 46 "../lib/Linter.vala"
	result = vala_lint_config_get_state (_tmp1_) != VALA_LINT_CONFIG_STATE_OFF;
#line 46 "../lib/Linter.vala"
	return result;
#line 149 "Linter.c"
}

static gboolean
___lambda7__vala_lint_utils_filter_function (gconstpointer element,
                                             gpointer self)
{
	gboolean result;
	result = __lambda7_ ((ValaLintLinter*) self, (ValaLintCheck*) element);
#line 46 "../lib/Linter.vala"
	return result;
#line 160 "Linter.c"
}

ValaLintLinter*
vala_lint_linter_construct (GType object_type)
{
	ValaLintLinter * self = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	ValaArrayList* _tmp2_;
	ValaLintChecksBlockOpeningBraceSpaceBeforeCheck* _tmp3_;
	ValaLintChecksBlockOpeningBraceSpaceBeforeCheck* _tmp4_;
	ValaArrayList* _tmp5_;
	ValaLintChecksDoubleSpacesCheck* _tmp6_;
	ValaLintChecksDoubleSpacesCheck* _tmp7_;
	ValaArrayList* _tmp8_;
	ValaLintChecksLineLengthCheck* _tmp9_;
	ValaLintChecksLineLengthCheck* _tmp10_;
	ValaArrayList* _tmp11_;
	ValaLintChecksNoteCheck* _tmp12_;
	ValaLintChecksNoteCheck* _tmp13_;
	ValaArrayList* _tmp14_;
	ValaLintChecksSpaceBeforeParenCheck* _tmp15_;
	ValaLintChecksSpaceBeforeParenCheck* _tmp16_;
	ValaArrayList* _tmp17_;
	ValaLintChecksTabCheck* _tmp18_;
	ValaLintChecksTabCheck* _tmp19_;
	ValaArrayList* _tmp20_;
	ValaLintChecksTrailingNewlinesCheck* _tmp21_;
	ValaLintChecksTrailingNewlinesCheck* _tmp22_;
	ValaArrayList* _tmp23_;
	ValaLintChecksTrailingWhitespaceCheck* _tmp24_;
	ValaLintChecksTrailingWhitespaceCheck* _tmp25_;
	ValaArrayList* _tmp26_;
	ValaArrayList* _tmp27_;
	ValaLintVisitor* _tmp28_;
	ValaLintVisitor* _tmp29_;
	ValaLintChecksDoubleSemicolonCheck* _tmp30_;
	ValaLintVisitor* _tmp31_;
	ValaLintChecksEllipsisCheck* _tmp32_;
	ValaLintVisitor* _tmp33_;
	ValaLintChecksNamingConventionCheck* _tmp34_;
	ValaLintVisitor* _tmp35_;
	ValaLintChecksNoSpaceCheck* _tmp36_;
	ValaLintVisitor* _tmp37_;
	ValaLintChecksUnnecessaryStringTemplateCheck* _tmp38_;
#line 33 "../lib/Linter.vala"
	self = (ValaLintLinter*) g_object_new (object_type, NULL);
#line 34 "../lib/Linter.vala"
	self->disable_mistakes = vala_lint_config_get_boolean ("Disabler", "disable-by-inline-comments");
#line 36 "../lib/Linter.vala"
	_tmp0_ = g_direct_equal;
#line 36 "../lib/Linter.vala"
	_tmp1_ = vala_array_list_new (VALA_LINT_TYPE_CHECK, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
#line 36 "../lib/Linter.vala"
	_vala_iterable_unref0 (self->global_checks);
#line 36 "../lib/Linter.vala"
	self->global_checks = _tmp1_;
#line 37 "../lib/Linter.vala"
	_tmp2_ = self->global_checks;
#line 37 "../lib/Linter.vala"
	_tmp3_ = vala_lint_checks_block_opening_brace_space_before_check_new ();
#line 37 "../lib/Linter.vala"
	_tmp4_ = _tmp3_;
#line 37 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp2_, (ValaLintCheck*) _tmp4_);
#line 37 "../lib/Linter.vala"
	_g_object_unref0 (_tmp4_);
#line 38 "../lib/Linter.vala"
	_tmp5_ = self->global_checks;
#line 38 "../lib/Linter.vala"
	_tmp6_ = vala_lint_checks_double_spaces_check_new ();
#line 38 "../lib/Linter.vala"
	_tmp7_ = _tmp6_;
#line 38 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp5_, (ValaLintCheck*) _tmp7_);
#line 38 "../lib/Linter.vala"
	_g_object_unref0 (_tmp7_);
#line 39 "../lib/Linter.vala"
	_tmp8_ = self->global_checks;
#line 39 "../lib/Linter.vala"
	_tmp9_ = vala_lint_checks_line_length_check_new ();
#line 39 "../lib/Linter.vala"
	_tmp10_ = _tmp9_;
#line 39 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp8_, (ValaLintCheck*) _tmp10_);
#line 39 "../lib/Linter.vala"
	_g_object_unref0 (_tmp10_);
#line 40 "../lib/Linter.vala"
	_tmp11_ = self->global_checks;
#line 40 "../lib/Linter.vala"
	_tmp12_ = vala_lint_checks_note_check_new ();
#line 40 "../lib/Linter.vala"
	_tmp13_ = _tmp12_;
#line 40 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp11_, (ValaLintCheck*) _tmp13_);
#line 40 "../lib/Linter.vala"
	_g_object_unref0 (_tmp13_);
#line 41 "../lib/Linter.vala"
	_tmp14_ = self->global_checks;
#line 41 "../lib/Linter.vala"
	_tmp15_ = vala_lint_checks_space_before_paren_check_new ();
#line 41 "../lib/Linter.vala"
	_tmp16_ = _tmp15_;
#line 41 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp14_, (ValaLintCheck*) _tmp16_);
#line 41 "../lib/Linter.vala"
	_g_object_unref0 (_tmp16_);
#line 42 "../lib/Linter.vala"
	_tmp17_ = self->global_checks;
#line 42 "../lib/Linter.vala"
	_tmp18_ = vala_lint_checks_tab_check_new ();
#line 42 "../lib/Linter.vala"
	_tmp19_ = _tmp18_;
#line 42 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp17_, (ValaLintCheck*) _tmp19_);
#line 42 "../lib/Linter.vala"
	_g_object_unref0 (_tmp19_);
#line 43 "../lib/Linter.vala"
	_tmp20_ = self->global_checks;
#line 43 "../lib/Linter.vala"
	_tmp21_ = vala_lint_checks_trailing_newlines_check_new ();
#line 43 "../lib/Linter.vala"
	_tmp22_ = _tmp21_;
#line 43 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp20_, (ValaLintCheck*) _tmp22_);
#line 43 "../lib/Linter.vala"
	_g_object_unref0 (_tmp22_);
#line 44 "../lib/Linter.vala"
	_tmp23_ = self->global_checks;
#line 44 "../lib/Linter.vala"
	_tmp24_ = vala_lint_checks_trailing_whitespace_check_new ();
#line 44 "../lib/Linter.vala"
	_tmp25_ = _tmp24_;
#line 44 "../lib/Linter.vala"
	vala_collection_add ((ValaCollection*) _tmp23_, (ValaLintCheck*) _tmp25_);
#line 44 "../lib/Linter.vala"
	_g_object_unref0 (_tmp25_);
#line 46 "../lib/Linter.vala"
	_tmp26_ = self->global_checks;
#line 46 "../lib/Linter.vala"
	_tmp27_ = vala_lint_utils_filter (VALA_LINT_TYPE_CHECK, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda7__vala_lint_utils_filter_function, self, _tmp26_);
#line 46 "../lib/Linter.vala"
	_vala_iterable_unref0 (self->global_checks);
#line 46 "../lib/Linter.vala"
	self->global_checks = _tmp27_;
#line 48 "../lib/Linter.vala"
	_tmp28_ = vala_lint_visitor_new ();
#line 48 "../lib/Linter.vala"
	_vala_code_visitor_unref0 (self->priv->visitor);
#line 48 "../lib/Linter.vala"
	self->priv->visitor = _tmp28_;
#line 49 "../lib/Linter.vala"
	_tmp29_ = self->priv->visitor;
#line 49 "../lib/Linter.vala"
	_tmp30_ = vala_lint_checks_double_semicolon_check_new ();
#line 49 "../lib/Linter.vala"
	_g_object_unref0 (_tmp29_->double_semicolon_check);
#line 49 "../lib/Linter.vala"
	_tmp29_->double_semicolon_check = _tmp30_;
#line 50 "../lib/Linter.vala"
	_tmp31_ = self->priv->visitor;
#line 50 "../lib/Linter.vala"
	_tmp32_ = vala_lint_checks_ellipsis_check_new ();
#line 50 "../lib/Linter.vala"
	_g_object_unref0 (_tmp31_->ellipsis_check);
#line 50 "../lib/Linter.vala"
	_tmp31_->ellipsis_check = _tmp32_;
#line 51 "../lib/Linter.vala"
	_tmp33_ = self->priv->visitor;
#line 51 "../lib/Linter.vala"
	_tmp34_ = vala_lint_checks_naming_convention_check_new ();
#line 51 "../lib/Linter.vala"
	_g_object_unref0 (_tmp33_->naming_convention_check);
#line 51 "../lib/Linter.vala"
	_tmp33_->naming_convention_check = _tmp34_;
#line 52 "../lib/Linter.vala"
	_tmp35_ = self->priv->visitor;
#line 52 "../lib/Linter.vala"
	_tmp36_ = vala_lint_checks_no_space_check_new ();
#line 52 "../lib/Linter.vala"
	_g_object_unref0 (_tmp35_->no_space_check);
#line 52 "../lib/Linter.vala"
	_tmp35_->no_space_check = _tmp36_;
#line 53 "../lib/Linter.vala"
	_tmp37_ = self->priv->visitor;
#line 53 "../lib/Linter.vala"
	_tmp38_ = vala_lint_checks_unnecessary_string_template_check_new ();
#line 53 "../lib/Linter.vala"
	_g_object_unref0 (_tmp37_->unnecessary_string_template_check);
#line 53 "../lib/Linter.vala"
	_tmp37_->unnecessary_string_template_check = _tmp38_;
#line 33 "../lib/Linter.vala"
	return self;
#line 354 "Linter.c"
}

ValaLintLinter*
vala_lint_linter_new (void)
{
#line 33 "../lib/Linter.vala"
	return vala_lint_linter_construct (VALA_LINT_TYPE_LINTER);
#line 362 "Linter.c"
}

static gboolean
__lambda8_ (ValaLintFormatMistake* a,
            ValaLintFormatMistake* b)
{
	ValaLintFormatMistake _tmp0_;
	gboolean result;
#line 57 "../lib/Linter.vala"
	_tmp0_ = *b;
#line 57 "../lib/Linter.vala"
	result = vala_lint_format_mistake_equal_to (a, &_tmp0_);
#line 57 "../lib/Linter.vala"
	return result;
#line 377 "Linter.c"
}

static gboolean
___lambda8__gequal_func (gconstpointer a,
                         gconstpointer b)
{
	gboolean result;
	result = __lambda8_ ((ValaLintFormatMistake*) a, (ValaLintFormatMistake*) b);
#line 57 "../lib/Linter.vala"
	return result;
#line 388 "Linter.c"
}

static gint
___lambda9_ (ValaLintLinter* self,
             ValaLintFormatMistake* a,
             ValaLintFormatMistake* b)
{
	ValaSourceLocation _tmp0_;
	ValaSourceLocation _tmp1_;
	ValaSourceLocation _tmp4_;
	ValaSourceLocation _tmp5_;
	gint result;
#line 103 "../lib/Linter.vala"
	_tmp0_ = (*a).begin;
#line 103 "../lib/Linter.vala"
	_tmp1_ = (*b).begin;
#line 103 "../lib/Linter.vala"
	if (_tmp0_.line == _tmp1_.line) {
#line 407 "Linter.c"
		ValaSourceLocation _tmp2_;
		ValaSourceLocation _tmp3_;
#line 104 "../lib/Linter.vala"
		_tmp2_ = (*a).begin;
#line 104 "../lib/Linter.vala"
		_tmp3_ = (*b).begin;
#line 104 "../lib/Linter.vala"
		result = _tmp2_.column - _tmp3_.column;
#line 104 "../lib/Linter.vala"
		return result;
#line 418 "Linter.c"
	}
#line 106 "../lib/Linter.vala"
	_tmp4_ = (*a).begin;
#line 106 "../lib/Linter.vala"
	_tmp5_ = (*b).begin;
#line 106 "../lib/Linter.vala"
	result = _tmp4_.line - _tmp5_.line;
#line 106 "../lib/Linter.vala"
	return result;
#line 428 "Linter.c"
}

static gint
____lambda9__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = ___lambda9_ ((ValaLintLinter*) self, (ValaLintFormatMistake*) a, (ValaLintFormatMistake*) b);
#line 102 "../lib/Linter.vala"
	return result;
#line 440 "Linter.c"
}

ValaArrayList*
vala_lint_linter_run_checks_for_file (ValaLintLinter* self,
                                      GFile* file,
                                      GError** error)
{
	ValaArrayList* mistake_list = NULL;
	ValaArrayList* _tmp0_;
	ValaCodeContext* context = NULL;
	ValaCodeContext* _tmp1_;
	ValaLintReporter* reporter = NULL;
	ValaArrayList* _tmp2_;
	ValaLintReporter* _tmp3_;
	ValaCodeContext* _tmp4_;
	ValaLintReporter* _tmp5_;
	ValaCodeContext* _tmp6_;
	gchar* filename = NULL;
	gchar* _tmp7_;
	ValaCodeContext* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result;
#line 56 "../lib/Linter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../lib/Linter.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 57 "../lib/Linter.vala"
	_tmp0_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) vala_lint_format_mistake_dup, (GDestroyNotify) vala_lint_format_mistake_free, ___lambda8__gequal_func);
#line 57 "../lib/Linter.vala"
	mistake_list = _tmp0_;
#line 59 "../lib/Linter.vala"
	_tmp1_ = vala_code_context_new ();
#line 59 "../lib/Linter.vala"
	context = _tmp1_;
#line 60 "../lib/Linter.vala"
	_tmp2_ = mistake_list;
#line 60 "../lib/Linter.vala"
	_tmp3_ = vala_lint_reporter_new (_tmp2_);
#line 60 "../lib/Linter.vala"
	reporter = _tmp3_;
#line 62 "../lib/Linter.vala"
	_tmp4_ = context;
#line 62 "../lib/Linter.vala"
	_tmp5_ = reporter;
#line 62 "../lib/Linter.vala"
	vala_code_context_set_report (_tmp4_, (ValaReport*) _tmp5_);
#line 63 "../lib/Linter.vala"
	_tmp6_ = context;
#line 63 "../lib/Linter.vala"
	vala_code_context_push (_tmp6_);
#line 65 "../lib/Linter.vala"
	_tmp7_ = g_file_get_path (file);
#line 65 "../lib/Linter.vala"
	filename = _tmp7_;
#line 68 "../lib/Linter.vala"
	_tmp8_ = context;
#line 68 "../lib/Linter.vala"
	_tmp9_ = filename;
#line 68 "../lib/Linter.vala"
	if (vala_code_context_add_source_filename (_tmp8_, _tmp9_, FALSE, FALSE)) {
#line 502 "Linter.c"
		ValaParser* parser_ast = NULL;
		ValaParser* _tmp10_;
		ValaParser* _tmp11_;
		ValaCodeContext* _tmp12_;
		ValaLintVisitor* _tmp13_;
		ValaArrayList* _tmp14_;
		gchar* content = NULL;
		const gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		ValaLintParser* parser_code = NULL;
		ValaLintParser* _tmp28_;
		ValaArrayList* parse_result = NULL;
		ValaLintParser* _tmp29_;
		const gchar* _tmp30_;
		ValaArrayList* _tmp31_;
		ValaArrayList* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		ValaLintDisabler* disabler = NULL;
		ValaLintDisabler* _tmp46_;
		ValaArrayList* disable_results = NULL;
		ValaLintDisabler* _tmp47_;
		ValaArrayList* _tmp48_;
		ValaArrayList* _tmp49_;
		ValaArrayList* _tmp54_;
#line 70 "../lib/Linter.vala"
		_tmp10_ = vala_parser_new ();
#line 70 "../lib/Linter.vala"
		parser_ast = _tmp10_;
#line 71 "../lib/Linter.vala"
		_tmp11_ = parser_ast;
#line 71 "../lib/Linter.vala"
		_tmp12_ = context;
#line 71 "../lib/Linter.vala"
		vala_parser_parse (_tmp11_, _tmp12_);
#line 73 "../lib/Linter.vala"
		_tmp13_ = self->priv->visitor;
#line 73 "../lib/Linter.vala"
		_tmp14_ = mistake_list;
#line 73 "../lib/Linter.vala"
		vala_lint_visitor_set_mistake_list (_tmp13_, _tmp14_);
#line 544 "Linter.c"
		{
			ValaList* _vala_source_file_list = NULL;
			ValaCodeContext* _tmp15_;
			ValaList* _tmp16_;
			gint _vala_source_file_size = 0;
			ValaList* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _vala_source_file_index = 0;
#line 74 "../lib/Linter.vala"
			_tmp15_ = context;
#line 74 "../lib/Linter.vala"
			_tmp16_ = vala_code_context_get_source_files (_tmp15_);
#line 74 "../lib/Linter.vala"
			_vala_source_file_list = _tmp16_;
#line 74 "../lib/Linter.vala"
			_tmp17_ = _vala_source_file_list;
#line 74 "../lib/Linter.vala"
			_tmp18_ = vala_collection_get_size ((ValaCollection*) _tmp17_);
#line 74 "../lib/Linter.vala"
			_tmp19_ = _tmp18_;
#line 74 "../lib/Linter.vala"
			_vala_source_file_size = _tmp19_;
#line 74 "../lib/Linter.vala"
			_vala_source_file_index = -1;
#line 74 "../lib/Linter.vala"
			while (TRUE) {
#line 572 "Linter.c"
				gint _tmp20_;
				gint _tmp21_;
				ValaSourceFile* vala_source_file = NULL;
				ValaList* _tmp22_;
				gpointer _tmp23_;
				ValaSourceFile* _tmp24_;
				ValaLintVisitor* _tmp25_;
#line 74 "../lib/Linter.vala"
				_vala_source_file_index = _vala_source_file_index + 1;
#line 74 "../lib/Linter.vala"
				_tmp20_ = _vala_source_file_index;
#line 74 "../lib/Linter.vala"
				_tmp21_ = _vala_source_file_size;
#line 74 "../lib/Linter.vala"
				if (!(_tmp20_ < _tmp21_)) {
#line 74 "../lib/Linter.vala"
					break;
#line 590 "Linter.c"
				}
#line 74 "../lib/Linter.vala"
				_tmp22_ = _vala_source_file_list;
#line 74 "../lib/Linter.vala"
				_tmp23_ = vala_list_get (_tmp22_, _vala_source_file_index);
#line 74 "../lib/Linter.vala"
				vala_source_file = (ValaSourceFile*) _tmp23_;
#line 75 "../lib/Linter.vala"
				_tmp24_ = vala_source_file;
#line 75 "../lib/Linter.vala"
				_tmp25_ = self->priv->visitor;
#line 75 "../lib/Linter.vala"
				vala_source_file_accept (_tmp24_, (ValaCodeVisitor*) _tmp25_);
#line 74 "../lib/Linter.vala"
				_vala_source_file_unref0 (vala_source_file);
#line 606 "Linter.c"
			}
		}
#line 79 "../lib/Linter.vala"
		_tmp26_ = filename;
#line 79 "../lib/Linter.vala"
		g_file_get_contents (_tmp26_, &_tmp27_, NULL, &_inner_error0_);
#line 79 "../lib/Linter.vala"
		_g_free0 (content);
#line 79 "../lib/Linter.vala"
		content = _tmp27_;
#line 79 "../lib/Linter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../lib/Linter.vala"
			g_propagate_error (error, _inner_error0_);
#line 79 "../lib/Linter.vala"
			_g_free0 (content);
#line 79 "../lib/Linter.vala"
			_vala_code_visitor_unref0 (parser_ast);
#line 79 "../lib/Linter.vala"
			_g_free0 (filename);
#line 79 "../lib/Linter.vala"
			_vala_report_unref0 (reporter);
#line 79 "../lib/Linter.vala"
			_vala_code_context_unref0 (context);
#line 79 "../lib/Linter.vala"
			_vala_iterable_unref0 (mistake_list);
#line 79 "../lib/Linter.vala"
			return NULL;
#line 635 "Linter.c"
		}
#line 82 "../lib/Linter.vala"
		_tmp28_ = vala_lint_parser_new ();
#line 82 "../lib/Linter.vala"
		parser_code = _tmp28_;
#line 84 "../lib/Linter.vala"
		_tmp29_ = parser_code;
#line 84 "../lib/Linter.vala"
		_tmp30_ = content;
#line 84 "../lib/Linter.vala"
		_tmp31_ = vala_lint_parser_parse (_tmp29_, _tmp30_);
#line 84 "../lib/Linter.vala"
		parse_result = _tmp31_;
#line 86 "../lib/Linter.vala"
		_tmp32_ = parse_result;
#line 86 "../lib/Linter.vala"
		_tmp33_ = vala_collection_get_size ((ValaCollection*) _tmp32_);
#line 86 "../lib/Linter.vala"
		_tmp34_ = _tmp33_;
#line 86 "../lib/Linter.vala"
		if (_tmp34_ == 0) {
#line 657 "Linter.c"
			const gchar* _tmp35_;
#line 87 "../lib/Linter.vala"
			_tmp35_ = filename;
#line 87 "../lib/Linter.vala"
			g_debug ("Linter.vala:87: No ParseResults after parsing %s.  Ignoring this file", _tmp35_);
#line 88 "../lib/Linter.vala"
			result = mistake_list;
#line 88 "../lib/Linter.vala"
			_vala_iterable_unref0 (parse_result);
#line 88 "../lib/Linter.vala"
			_g_object_unref0 (parser_code);
#line 88 "../lib/Linter.vala"
			_g_free0 (content);
#line 88 "../lib/Linter.vala"
			_vala_code_visitor_unref0 (parser_ast);
#line 88 "../lib/Linter.vala"
			_g_free0 (filename);
#line 88 "../lib/Linter.vala"
			_vala_report_unref0 (reporter);
#line 88 "../lib/Linter.vala"
			_vala_code_context_unref0 (context);
#line 88 "../lib/Linter.vala"
			return result;
#line 681 "Linter.c"
		}
		{
			ValaArrayList* _check_list = NULL;
			ValaArrayList* _tmp36_;
			gint _check_size = 0;
			ValaArrayList* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gint _check_index = 0;
#line 91 "../lib/Linter.vala"
			_tmp36_ = self->global_checks;
#line 91 "../lib/Linter.vala"
			_check_list = _tmp36_;
#line 91 "../lib/Linter.vala"
			_tmp37_ = _check_list;
#line 91 "../lib/Linter.vala"
			_tmp38_ = vala_collection_get_size ((ValaCollection*) _tmp37_);
#line 91 "../lib/Linter.vala"
			_tmp39_ = _tmp38_;
#line 91 "../lib/Linter.vala"
			_check_size = _tmp39_;
#line 91 "../lib/Linter.vala"
			_check_index = -1;
#line 91 "../lib/Linter.vala"
			while (TRUE) {
#line 707 "Linter.c"
				gint _tmp40_;
				gint _tmp41_;
				ValaLintCheck* check = NULL;
				ValaArrayList* _tmp42_;
				gpointer _tmp43_;
				ValaLintCheck* _tmp44_;
				ValaArrayList* _tmp45_;
#line 91 "../lib/Linter.vala"
				_check_index = _check_index + 1;
#line 91 "../lib/Linter.vala"
				_tmp40_ = _check_index;
#line 91 "../lib/Linter.vala"
				_tmp41_ = _check_size;
#line 91 "../lib/Linter.vala"
				if (!(_tmp40_ < _tmp41_)) {
#line 91 "../lib/Linter.vala"
					break;
#line 725 "Linter.c"
				}
#line 91 "../lib/Linter.vala"
				_tmp42_ = _check_list;
#line 91 "../lib/Linter.vala"
				_tmp43_ = vala_list_get ((ValaList*) _tmp42_, _check_index);
#line 91 "../lib/Linter.vala"
				check = (ValaLintCheck*) _tmp43_;
#line 92 "../lib/Linter.vala"
				_tmp44_ = check;
#line 92 "../lib/Linter.vala"
				_tmp45_ = parse_result;
#line 92 "../lib/Linter.vala"
				vala_lint_check_check (_tmp44_, _tmp45_, &mistake_list);
#line 91 "../lib/Linter.vala"
				_g_object_unref0 (check);
#line 741 "Linter.c"
			}
		}
#line 95 "../lib/Linter.vala"
		_tmp46_ = vala_lint_disabler_new ();
#line 95 "../lib/Linter.vala"
		disabler = _tmp46_;
#line 96 "../lib/Linter.vala"
		_tmp47_ = disabler;
#line 96 "../lib/Linter.vala"
		_tmp48_ = parse_result;
#line 96 "../lib/Linter.vala"
		_tmp49_ = vala_lint_disabler_parse (_tmp47_, _tmp48_);
#line 96 "../lib/Linter.vala"
		disable_results = _tmp49_;
#line 98 "../lib/Linter.vala"
		if (self->disable_mistakes) {
#line 758 "Linter.c"
			ValaLintDisabler* _tmp50_;
			ValaArrayList* _tmp51_;
			ValaArrayList* _tmp52_;
			ValaArrayList* _tmp53_;
#line 99 "../lib/Linter.vala"
			_tmp50_ = disabler;
#line 99 "../lib/Linter.vala"
			_tmp51_ = mistake_list;
#line 99 "../lib/Linter.vala"
			_tmp52_ = disable_results;
#line 99 "../lib/Linter.vala"
			_tmp53_ = vala_lint_disabler_filter_mistakes (_tmp50_, _tmp51_, _tmp52_);
#line 99 "../lib/Linter.vala"
			_vala_iterable_unref0 (mistake_list);
#line 99 "../lib/Linter.vala"
			mistake_list = _tmp53_;
#line 775 "Linter.c"
		}
#line 102 "../lib/Linter.vala"
		_tmp54_ = mistake_list;
#line 102 "../lib/Linter.vala"
		vala_list_sort ((ValaList*) _tmp54_, ____lambda9__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 68 "../lib/Linter.vala"
		_vala_iterable_unref0 (disable_results);
#line 68 "../lib/Linter.vala"
		_g_object_unref0 (disabler);
#line 68 "../lib/Linter.vala"
		_vala_iterable_unref0 (parse_result);
#line 68 "../lib/Linter.vala"
		_g_object_unref0 (parser_code);
#line 68 "../lib/Linter.vala"
		_g_free0 (content);
#line 68 "../lib/Linter.vala"
		_vala_code_visitor_unref0 (parser_ast);
#line 793 "Linter.c"
	}
#line 110 "../lib/Linter.vala"
	result = mistake_list;
#line 110 "../lib/Linter.vala"
	_g_free0 (filename);
#line 110 "../lib/Linter.vala"
	_vala_report_unref0 (reporter);
#line 110 "../lib/Linter.vala"
	_vala_code_context_unref0 (context);
#line 110 "../lib/Linter.vala"
	return result;
#line 805 "Linter.c"
}

static void
vala_lint_linter_class_init (ValaLintLinterClass * klass,
                             gpointer klass_data)
{
#line 22 "../lib/Linter.vala"
	vala_lint_linter_parent_class = g_type_class_peek_parent (klass);
#line 22 "../lib/Linter.vala"
	g_type_class_adjust_private_offset (klass, &ValaLintLinter_private_offset);
#line 22 "../lib/Linter.vala"
	G_OBJECT_CLASS (klass)->finalize = vala_lint_linter_finalize;
#line 818 "Linter.c"
}

static void
vala_lint_linter_instance_init (ValaLintLinter * self,
                                gpointer klass)
{
#line 22 "../lib/Linter.vala"
	self->priv = vala_lint_linter_get_instance_private (self);
#line 827 "Linter.c"
}

static void
vala_lint_linter_finalize (GObject * obj)
{
	ValaLintLinter * self;
#line 22 "../lib/Linter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_LINTER, ValaLintLinter);
#line 28 "../lib/Linter.vala"
	_vala_iterable_unref0 (self->global_checks);
#line 31 "../lib/Linter.vala"
	_vala_code_visitor_unref0 (self->priv->visitor);
#line 22 "../lib/Linter.vala"
	G_OBJECT_CLASS (vala_lint_linter_parent_class)->finalize (obj);
#line 842 "Linter.c"
}

static GType
vala_lint_linter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintLinterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_linter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintLinter), 0, (GInstanceInitFunc) vala_lint_linter_instance_init, NULL };
	GType vala_lint_linter_type_id;
	vala_lint_linter_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintLinter", &g_define_type_info, 0);
	ValaLintLinter_private_offset = g_type_add_instance_private (vala_lint_linter_type_id, sizeof (ValaLintLinterPrivate));
	return vala_lint_linter_type_id;
}

GType
vala_lint_linter_get_type (void)
{
	static volatile gsize vala_lint_linter_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_linter_type_id__once)) {
		GType vala_lint_linter_type_id;
		vala_lint_linter_type_id = vala_lint_linter_get_type_once ();
		g_once_init_leave (&vala_lint_linter_type_id__once, vala_lint_linter_type_id);
	}
	return vala_lint_linter_type_id__once;
}

