/* Parser.c generated by valac 0.56.17, the Vala compiler
 * generated from Parser.vala, do not modify */

/*
 * Copyright (c) 2018 elementary LLC. (https://github.com/elementary/Vala-Lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <vala.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	VALA_LINT_PARSER_0_PROPERTY,
	VALA_LINT_PARSER_NUM_PROPERTIES
};
static GParamSpec* vala_lint_parser_properties[VALA_LINT_PARSER_NUM_PROPERTIES];

#define VALA_LINT_PARSER_TYPE_MATCH_TYPE_INFO (vala_lint_parser_match_type_info_get_type ())
typedef struct _ValaLintParserMatchTypeInfo ValaLintParserMatchTypeInfo;
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaLintParserPrivate {
	gchar** start_patterns;
	gint start_patterns_length1;
	gint _start_patterns_size_;
	gchar** close_patterns;
	gint close_patterns_length1;
	gint _close_patterns_size_;
	ParseType* parse_types;
	gint parse_types_length1;
	gint _parse_types_size_;
};

struct _ValaLintParserMatchTypeInfo {
	GMatchInfo* match_info;
	ParseDetailType type;
	gint start_pos;
	gint end_pos;
};

static gint ValaLintParser_private_offset;
static gpointer vala_lint_parser_parent_class = NULL;

static GType vala_lint_parser_match_type_info_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static ValaLintParserMatchTypeInfo* vala_lint_parser_match_type_info_dup (const ValaLintParserMatchTypeInfo* self);
static void vala_lint_parser_match_type_info_free (ValaLintParserMatchTypeInfo* self);
static void vala_lint_parser_match_type_info_copy (const ValaLintParserMatchTypeInfo* self,
                                            ValaLintParserMatchTypeInfo* dest);
static void vala_lint_parser_match_type_info_destroy (ValaLintParserMatchTypeInfo* self);
static void vala_lint_parser_match_type (ValaLintParser* self,
                                  const gchar* input,
                                  gchar** patterns,
                                  gint patterns_length1,
                                  gint start_search_pos,
                                  ValaLintParserMatchTypeInfo* result);
static void vala_lint_parser_add_result (ValaLintParser* self,
                                  const gchar* input,
                                  gint start_pos,
                                  gint end_pos,
                                  ParseDetailType detail_type,
                                  ValaArrayList* _result_,
                                  gint* current_line);
static void vala_lint_parser_finalize (GObject * obj);
static GType vala_lint_parser_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
vala_lint_parser_get_instance_private (ValaLintParser* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintParser_private_offset);
}

ValaArrayList*
vala_lint_parser_parse (ValaLintParser* self,
                        const gchar* input)
{
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	gint search_pos = 0;
	gint current_line = 0;
	ValaLintParserMatchTypeInfo info = {0};
	gchar** _tmp2_;
	gint _tmp2__length1;
	ValaLintParserMatchTypeInfo _tmp3_ = {0};
	gint _tmp34_;
	gint _tmp35_;
	ValaArrayList* result;
#line 56 "../lib/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../lib/Parser.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 57 "../lib/Parser.vala"
	_tmp0_ = g_direct_equal;
#line 57 "../lib/Parser.vala"
	_tmp1_ = vala_array_list_new (TYPE_PARSE_RESULT, (GBoxedCopyFunc) parse_result_dup, (GDestroyNotify) parse_result_free, _tmp0_);
#line 57 "../lib/Parser.vala"
	_result_ = _tmp1_;
#line 59 "../lib/Parser.vala"
	search_pos = 0;
#line 60 "../lib/Parser.vala"
	current_line = 0;
#line 62 "../lib/Parser.vala"
	_tmp2_ = self->priv->start_patterns;
#line 62 "../lib/Parser.vala"
	_tmp2__length1 = self->priv->start_patterns_length1;
#line 62 "../lib/Parser.vala"
	vala_lint_parser_match_type (self, input, _tmp2_, (gint) _tmp2__length1, search_pos, &_tmp3_);
#line 62 "../lib/Parser.vala"
	info = _tmp3_;
#line 63 "../lib/Parser.vala"
	while (TRUE) {
#line 149 "Parser.c"
		ValaLintParserMatchTypeInfo _tmp4_;
		GMatchInfo* _tmp5_;
		ValaLintParserMatchTypeInfo _tmp6_;
		ValaLintParserMatchTypeInfo _tmp9_;
		ValaLintParserMatchTypeInfo info_close = {0};
		gchar** _tmp10_;
		gint _tmp10__length1;
		ValaLintParserMatchTypeInfo _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		ValaLintParserMatchTypeInfo _tmp16_;
		ValaLintParserMatchTypeInfo _tmp17_ = {0};
		ValaLintParserMatchTypeInfo _tmp18_;
		ValaLintParserMatchTypeInfo _tmp19_;
		GMatchInfo* _tmp20_;
		ValaLintParserMatchTypeInfo _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		ValaLintParserMatchTypeInfo _tmp32_;
		ValaLintParserMatchTypeInfo _tmp33_ = {0};
#line 63 "../lib/Parser.vala"
		_tmp4_ = info;
#line 63 "../lib/Parser.vala"
		_tmp5_ = _tmp4_.match_info;
#line 63 "../lib/Parser.vala"
		if (!g_match_info_matches (_tmp5_)) {
#line 63 "../lib/Parser.vala"
			break;
#line 181 "Parser.c"
		}
#line 64 "../lib/Parser.vala"
		_tmp6_ = info;
#line 64 "../lib/Parser.vala"
		if (_tmp6_.start_pos > search_pos) {
#line 187 "Parser.c"
			ValaLintParserMatchTypeInfo _tmp7_;
			ValaArrayList* _tmp8_;
#line 65 "../lib/Parser.vala"
			_tmp7_ = info;
#line 65 "../lib/Parser.vala"
			_tmp8_ = _result_;
#line 65 "../lib/Parser.vala"
			vala_lint_parser_add_result (self, input, search_pos, _tmp7_.start_pos, PARSE_DETAIL_TYPE_CODE, _tmp8_, &current_line);
#line 196 "Parser.c"
		}
#line 67 "../lib/Parser.vala"
		_tmp9_ = info;
#line 67 "../lib/Parser.vala"
		search_pos = _tmp9_.start_pos;
#line 69 "../lib/Parser.vala"
		_tmp10_ = self->priv->close_patterns;
#line 69 "../lib/Parser.vala"
		_tmp10__length1 = self->priv->close_patterns_length1;
#line 69 "../lib/Parser.vala"
		_tmp11_ = info;
#line 69 "../lib/Parser.vala"
		_tmp12_ = _tmp10_[_tmp11_.type];
#line 69 "../lib/Parser.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 69 "../lib/Parser.vala"
		_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 69 "../lib/Parser.vala"
		_tmp14_[0] = _tmp13_;
#line 69 "../lib/Parser.vala"
		_tmp15_ = _tmp14_;
#line 69 "../lib/Parser.vala"
		_tmp15__length1 = 1;
#line 69 "../lib/Parser.vala"
		_tmp16_ = info;
#line 69 "../lib/Parser.vala"
		vala_lint_parser_match_type (self, input, _tmp15_, (gint) 1, _tmp16_.end_pos, &_tmp17_);
#line 69 "../lib/Parser.vala"
		_tmp18_ = _tmp17_;
#line 69 "../lib/Parser.vala"
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 69 "../lib/Parser.vala"
		info_close = _tmp18_;
#line 70 "../lib/Parser.vala"
		_tmp19_ = info_close;
#line 70 "../lib/Parser.vala"
		_tmp20_ = _tmp19_.match_info;
#line 70 "../lib/Parser.vala"
		if (g_match_info_matches (_tmp20_)) {
#line 236 "Parser.c"
			ValaLintParserMatchTypeInfo _tmp21_;
			ValaLintParserMatchTypeInfo _tmp22_;
			ValaArrayList* _tmp23_;
#line 71 "../lib/Parser.vala"
			_tmp21_ = info_close;
#line 71 "../lib/Parser.vala"
			_tmp22_ = info;
#line 71 "../lib/Parser.vala"
			_tmp23_ = _result_;
#line 71 "../lib/Parser.vala"
			vala_lint_parser_add_result (self, input, search_pos, _tmp21_.end_pos, _tmp22_.type, _tmp23_, &current_line);
#line 248 "Parser.c"
		} else {
			gint _tmp24_;
			gint _tmp25_;
			ValaLintParserMatchTypeInfo _tmp26_;
			ValaArrayList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
#line 73 "../lib/Parser.vala"
			_tmp24_ = strlen (input);
#line 73 "../lib/Parser.vala"
			_tmp25_ = _tmp24_;
#line 73 "../lib/Parser.vala"
			_tmp26_ = info;
#line 73 "../lib/Parser.vala"
			_tmp27_ = _result_;
#line 73 "../lib/Parser.vala"
			vala_lint_parser_add_result (self, input, search_pos, _tmp25_, _tmp26_.type, _tmp27_, &current_line);
#line 74 "../lib/Parser.vala"
			_tmp28_ = strlen (input);
#line 74 "../lib/Parser.vala"
			_tmp29_ = _tmp28_;
#line 74 "../lib/Parser.vala"
			search_pos = _tmp29_;
#line 75 "../lib/Parser.vala"
			vala_lint_parser_match_type_info_destroy (&info_close);
#line 75 "../lib/Parser.vala"
			break;
#line 276 "Parser.c"
		}
#line 78 "../lib/Parser.vala"
		_tmp30_ = info_close;
#line 78 "../lib/Parser.vala"
		search_pos = _tmp30_.end_pos;
#line 79 "../lib/Parser.vala"
		_tmp31_ = self->priv->start_patterns;
#line 79 "../lib/Parser.vala"
		_tmp31__length1 = self->priv->start_patterns_length1;
#line 79 "../lib/Parser.vala"
		_tmp32_ = info_close;
#line 79 "../lib/Parser.vala"
		vala_lint_parser_match_type (self, input, _tmp31_, (gint) _tmp31__length1, _tmp32_.end_pos, &_tmp33_);
#line 79 "../lib/Parser.vala"
		vala_lint_parser_match_type_info_destroy (&info);
#line 79 "../lib/Parser.vala"
		info = _tmp33_;
#line 63 "../lib/Parser.vala"
		vala_lint_parser_match_type_info_destroy (&info_close);
#line 296 "Parser.c"
	}
#line 82 "../lib/Parser.vala"
	_tmp34_ = strlen (input);
#line 82 "../lib/Parser.vala"
	_tmp35_ = _tmp34_;
#line 82 "../lib/Parser.vala"
	if (_tmp35_ > search_pos) {
#line 304 "Parser.c"
		gint _tmp36_;
		gint _tmp37_;
		ValaArrayList* _tmp38_;
#line 83 "../lib/Parser.vala"
		_tmp36_ = strlen (input);
#line 83 "../lib/Parser.vala"
		_tmp37_ = _tmp36_;
#line 83 "../lib/Parser.vala"
		_tmp38_ = _result_;
#line 83 "../lib/Parser.vala"
		vala_lint_parser_add_result (self, input, search_pos, _tmp37_, PARSE_DETAIL_TYPE_CODE, _tmp38_, &current_line);
#line 316 "Parser.c"
	}
#line 85 "../lib/Parser.vala"
	result = _result_;
#line 85 "../lib/Parser.vala"
	vala_lint_parser_match_type_info_destroy (&info);
#line 85 "../lib/Parser.vala"
	return result;
#line 324 "Parser.c"
}

/**
     * Matches one of multiple regex patterns.
     *
     * @param input The input string.
     * @param patterns The array of regex patterns.
     * @param start_search_pos The start position for searching in the input string.
     * @param info The output, including which pattern was matched and the exact position.
     */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 346 "Parser.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 350 "Parser.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 356 "Parser.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 361 "Parser.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 367 "Parser.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 371 "Parser.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 375 "Parser.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 379 "Parser.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 383 "Parser.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 387 "Parser.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 402 "Parser.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 411 "Parser.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 418 "Parser.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 424 "Parser.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 432 "Parser.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 436 "Parser.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 442 "Parser.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 447 "Parser.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 453 "Parser.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 457 "Parser.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 461 "Parser.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 467 "Parser.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 473 "Parser.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 485 "Parser.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 489 "Parser.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 493 "Parser.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 498 "Parser.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 506 "Parser.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 524 "Parser.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 530 "Parser.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 534 "Parser.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 542 "Parser.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 551 "Parser.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 560 "Parser.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 566 "Parser.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 574 "Parser.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 586 "Parser.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 592 "Parser.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 596 "Parser.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 604 "Parser.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 615 "Parser.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 624 "Parser.c"
	}
}

static void
vala_lint_parser_match_type (ValaLintParser* self,
                             const gchar* input,
                             gchar** patterns,
                             gint patterns_length1,
                             gint start_search_pos,
                             ValaLintParserMatchTypeInfo* result)
{
	gchar* entire_pattern = NULL;
	gchar* _tmp0_;
	ValaLintParserMatchTypeInfo info = {0};
	GError* _inner_error0_ = NULL;
#line 96 "../lib/Parser.vala"
	g_return_if_fail (self != NULL);
#line 96 "../lib/Parser.vala"
	g_return_if_fail (input != NULL);
#line 97 "../lib/Parser.vala"
	_tmp0_ = _vala_g_strjoinv ("|", patterns, (gint) patterns_length1);
#line 97 "../lib/Parser.vala"
	entire_pattern = _tmp0_;
#line 98 "../lib/Parser.vala"
	memset (&info, 0, sizeof (ValaLintParserMatchTypeInfo));
#line 650 "Parser.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp1_;
		GRegex* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GRegex* _tmp4_;
		GMatchInfo* _tmp5_ = NULL;
		gboolean _tmp6_;
#line 101 "../lib/Parser.vala"
		_tmp1_ = entire_pattern;
#line 101 "../lib/Parser.vala"
		_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error0_);
#line 101 "../lib/Parser.vala"
		regex = _tmp2_;
#line 101 "../lib/Parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "Parser.c"
			goto __catch0_g_error;
		}
#line 102 "../lib/Parser.vala"
		_tmp4_ = regex;
#line 102 "../lib/Parser.vala"
		_tmp6_ = g_regex_match_full (_tmp4_, input, (gssize) -1, start_search_pos, 0, &_tmp5_, &_inner_error0_);
#line 102 "../lib/Parser.vala"
		_g_match_info_unref0 (info.match_info);
#line 102 "../lib/Parser.vala"
		info.match_info = _tmp5_;
#line 102 "../lib/Parser.vala"
		_tmp3_ = _tmp6_;
#line 102 "../lib/Parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../lib/Parser.vala"
			_g_regex_unref0 (regex);
#line 684 "Parser.c"
			goto __catch0_g_error;
		}
#line 102 "../lib/Parser.vala"
		if (_tmp3_) {
#line 689 "Parser.c"
			ValaLintParserMatchTypeInfo _tmp7_;
			GMatchInfo* _tmp8_;
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
#line 103 "../lib/Parser.vala"
			_tmp7_ = info;
#line 103 "../lib/Parser.vala"
			_tmp8_ = _tmp7_.match_info;
#line 103 "../lib/Parser.vala"
			g_match_info_fetch_pos (_tmp8_, 0, &_tmp9_, &_tmp10_);
#line 103 "../lib/Parser.vala"
			info.start_pos = _tmp9_;
#line 103 "../lib/Parser.vala"
			info.end_pos = _tmp10_;
#line 704 "Parser.c"
			{
				gint i = 0;
#line 104 "../lib/Parser.vala"
				i = 0;
#line 709 "Parser.c"
				{
					gboolean _tmp11_ = FALSE;
#line 104 "../lib/Parser.vala"
					_tmp11_ = TRUE;
#line 104 "../lib/Parser.vala"
					while (TRUE) {
#line 716 "Parser.c"
						ValaLintParserMatchTypeInfo _tmp13_;
						GMatchInfo* _tmp14_;
						ValaLintParserMatchTypeInfo _tmp15_;
						GMatchInfo* _tmp16_;
						gchar* _tmp17_;
						gchar* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						gboolean _tmp21_;
#line 104 "../lib/Parser.vala"
						if (!_tmp11_) {
#line 728 "Parser.c"
							gint _tmp12_;
#line 104 "../lib/Parser.vala"
							_tmp12_ = i;
#line 104 "../lib/Parser.vala"
							i = _tmp12_ + 1;
#line 734 "Parser.c"
						}
#line 104 "../lib/Parser.vala"
						_tmp11_ = FALSE;
#line 104 "../lib/Parser.vala"
						_tmp13_ = info;
#line 104 "../lib/Parser.vala"
						_tmp14_ = _tmp13_.match_info;
#line 104 "../lib/Parser.vala"
						if (!(i < g_match_info_get_match_count (_tmp14_))) {
#line 104 "../lib/Parser.vala"
							break;
#line 746 "Parser.c"
						}
#line 105 "../lib/Parser.vala"
						_tmp15_ = info;
#line 105 "../lib/Parser.vala"
						_tmp16_ = _tmp15_.match_info;
#line 105 "../lib/Parser.vala"
						_tmp17_ = g_match_info_fetch (_tmp16_, i + 1);
#line 105 "../lib/Parser.vala"
						_tmp18_ = _tmp17_;
#line 105 "../lib/Parser.vala"
						_tmp19_ = strlen (_tmp18_);
#line 105 "../lib/Parser.vala"
						_tmp20_ = _tmp19_;
#line 105 "../lib/Parser.vala"
						_tmp21_ = _tmp20_ > 0;
#line 105 "../lib/Parser.vala"
						_g_free0 (_tmp18_);
#line 105 "../lib/Parser.vala"
						if (_tmp21_) {
#line 106 "../lib/Parser.vala"
							info.type = (ParseDetailType) i;
#line 107 "../lib/Parser.vala"
							*result = info;
#line 107 "../lib/Parser.vala"
							_g_regex_unref0 (regex);
#line 107 "../lib/Parser.vala"
							_g_free0 (entire_pattern);
#line 107 "../lib/Parser.vala"
							return;
#line 776 "Parser.c"
						}
					}
				}
			}
		}
#line 100 "../lib/Parser.vala"
		_g_regex_unref0 (regex);
#line 784 "Parser.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp22_;
#line 100 "../lib/Parser.vala"
		g_clear_error (&_inner_error0_);
#line 112 "../lib/Parser.vala"
		_tmp22_ = entire_pattern;
#line 112 "../lib/Parser.vala"
		g_error ("Parser.vala:112: Regex error in parser: %s", _tmp22_);
#line 796 "Parser.c"
	}
	__finally0:
#line 100 "../lib/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../lib/Parser.vala"
		vala_lint_parser_match_type_info_destroy (&info);
#line 100 "../lib/Parser.vala"
		_g_free0 (entire_pattern);
#line 100 "../lib/Parser.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../lib/Parser.vala"
		g_clear_error (&_inner_error0_);
#line 100 "../lib/Parser.vala"
		return;
#line 811 "Parser.c"
	}
#line 114 "../lib/Parser.vala"
	*result = info;
#line 114 "../lib/Parser.vala"
	_g_free0 (entire_pattern);
#line 114 "../lib/Parser.vala"
	return;
#line 819 "Parser.c"
}

/**
     * Adds a parse result entry.
     *
     * @param input The input string.
     * @param start_pos The start character position in the input string of the entry.
     * @param end_pos The end character position in the input string of the entry.
     * @param type The general type of the parsed entry.
     * @param result The final parsed result array.
     * @param result The current line of the entry in the input string.
     */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 856 "Parser.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 862 "Parser.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 868 "Parser.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 872 "Parser.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 880 "Parser.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 884 "Parser.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 896 "Parser.c"
}

static void
vala_lint_parser_add_result (ValaLintParser* self,
                             const gchar* input,
                             gint start_pos,
                             gint end_pos,
                             ParseDetailType detail_type,
                             ValaArrayList* _result_,
                             gint* current_line)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	ValaSourceLocation loc = {0};
	ParseType* _tmp1_;
	gint _tmp1__length1;
	ParseType _tmp2_;
	ValaSourceLocation _tmp3_;
	ParseResult _tmp4_ = {0};
#line 127 "../lib/Parser.vala"
	g_return_if_fail (self != NULL);
#line 127 "../lib/Parser.vala"
	g_return_if_fail (input != NULL);
#line 127 "../lib/Parser.vala"
	g_return_if_fail (_result_ != NULL);
#line 129 "../lib/Parser.vala"
	_tmp0_ = string_slice (input, (glong) start_pos, (glong) end_pos);
#line 129 "../lib/Parser.vala"
	text = _tmp0_;
#line 130 "../lib/Parser.vala"
	vala_source_location_init (&loc, (gchar*) text, (*current_line) + 1, vala_lint_utils_get_column_in_line (input, start_pos) + 1);
#line 131 "../lib/Parser.vala"
	_tmp1_ = self->priv->parse_types;
#line 131 "../lib/Parser.vala"
	_tmp1__length1 = self->priv->parse_types_length1;
#line 131 "../lib/Parser.vala"
	_tmp2_ = _tmp1_[detail_type];
#line 131 "../lib/Parser.vala"
	_tmp3_ = loc;
#line 131 "../lib/Parser.vala"
	_g_free0 (_tmp4_.text);
#line 131 "../lib/Parser.vala"
	_tmp4_.text = text;
#line 131 "../lib/Parser.vala"
	_tmp4_.type = _tmp2_;
#line 131 "../lib/Parser.vala"
	_tmp4_.detail_type = detail_type;
#line 131 "../lib/Parser.vala"
	_tmp4_.begin = _tmp3_;
#line 131 "../lib/Parser.vala"
	vala_collection_add ((ValaCollection*) _result_, &_tmp4_);
#line 132 "../lib/Parser.vala"
	*current_line = (*current_line) + vala_lint_utils_get_line_count (text);
#line 127 "../lib/Parser.vala"
	_g_free0 (text);
#line 952 "Parser.c"
}

ValaLintParser*
vala_lint_parser_construct (GType object_type)
{
	ValaLintParser * self = NULL;
#line 20 "../lib/Parser.vala"
	self = (ValaLintParser*) g_object_new (object_type, NULL);
#line 20 "../lib/Parser.vala"
	return self;
#line 963 "Parser.c"
}

ValaLintParser*
vala_lint_parser_new (void)
{
#line 20 "../lib/Parser.vala"
	return vala_lint_parser_construct (VALA_LINT_TYPE_PARSER);
#line 971 "Parser.c"
}

static gpointer
_g_match_info_ref0 (gpointer self)
{
#line 49 "../lib/Parser.vala"
	return self ? g_match_info_ref (self) : NULL;
#line 979 "Parser.c"
}

static void
vala_lint_parser_match_type_info_copy (const ValaLintParserMatchTypeInfo* self,
                                       ValaLintParserMatchTypeInfo* dest)
{
	GMatchInfo* _tmp0_;
	GMatchInfo* _tmp1_;
#line 49 "../lib/Parser.vala"
	_tmp0_ = (*self).match_info;
#line 49 "../lib/Parser.vala"
	_tmp1_ = _g_match_info_ref0 (_tmp0_);
#line 49 "../lib/Parser.vala"
	_g_match_info_unref0 ((*dest).match_info);
#line 49 "../lib/Parser.vala"
	(*dest).match_info = _tmp1_;
#line 49 "../lib/Parser.vala"
	(*dest).type = (*self).type;
#line 49 "../lib/Parser.vala"
	(*dest).start_pos = (*self).start_pos;
#line 49 "../lib/Parser.vala"
	(*dest).end_pos = (*self).end_pos;
#line 1002 "Parser.c"
}

static void
vala_lint_parser_match_type_info_destroy (ValaLintParserMatchTypeInfo* self)
{
#line 50 "../lib/Parser.vala"
	_g_match_info_unref0 ((*self).match_info);
#line 1010 "Parser.c"
}

static ValaLintParserMatchTypeInfo*
vala_lint_parser_match_type_info_dup (const ValaLintParserMatchTypeInfo* self)
{
	ValaLintParserMatchTypeInfo* dup;
#line 49 "../lib/Parser.vala"
	dup = g_new0 (ValaLintParserMatchTypeInfo, 1);
#line 49 "../lib/Parser.vala"
	vala_lint_parser_match_type_info_copy (self, dup);
#line 49 "../lib/Parser.vala"
	return dup;
#line 1023 "Parser.c"
}

static void
vala_lint_parser_match_type_info_free (ValaLintParserMatchTypeInfo* self)
{
#line 49 "../lib/Parser.vala"
	vala_lint_parser_match_type_info_destroy (self);
#line 49 "../lib/Parser.vala"
	g_free (self);
#line 1033 "Parser.c"
}

static GType
vala_lint_parser_match_type_info_get_type_once (void)
{
	GType vala_lint_parser_match_type_info_type_id;
	vala_lint_parser_match_type_info_type_id = g_boxed_type_register_static ("ValaLintParserMatchTypeInfo", (GBoxedCopyFunc) vala_lint_parser_match_type_info_dup, (GBoxedFreeFunc) vala_lint_parser_match_type_info_free);
	return vala_lint_parser_match_type_info_type_id;
}

static GType
vala_lint_parser_match_type_info_get_type (void)
{
	static volatile gsize vala_lint_parser_match_type_info_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_parser_match_type_info_type_id__once)) {
		GType vala_lint_parser_match_type_info_type_id;
		vala_lint_parser_match_type_info_type_id = vala_lint_parser_match_type_info_get_type_once ();
		g_once_init_leave (&vala_lint_parser_match_type_info_type_id__once, vala_lint_parser_match_type_info_type_id);
	}
	return vala_lint_parser_match_type_info_type_id__once;
}

static void
vala_lint_parser_class_init (ValaLintParserClass * klass,
                             gpointer klass_data)
{
#line 20 "../lib/Parser.vala"
	vala_lint_parser_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/Parser.vala"
	g_type_class_adjust_private_offset (klass, &ValaLintParser_private_offset);
#line 20 "../lib/Parser.vala"
	G_OBJECT_CLASS (klass)->finalize = vala_lint_parser_finalize;
#line 1066 "Parser.c"
}

static void
vala_lint_parser_instance_init (ValaLintParser * self,
                                gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	ParseType* _tmp14_;
#line 20 "../lib/Parser.vala"
	self->priv = vala_lint_parser_get_instance_private (self);
#line 23 "../lib/Parser.vala"
	_tmp0_ = g_strdup ("(\\/\\/)");
#line 23 "../lib/Parser.vala"
	_tmp1_ = g_strdup ("(\\/\\*)");
#line 23 "../lib/Parser.vala"
	_tmp2_ = g_strdup ("(\\\"\\\"\\\")");
#line 23 "../lib/Parser.vala"
	_tmp3_ = g_strdup ("(@\")");
#line 23 "../lib/Parser.vala"
	_tmp4_ = g_strdup ("(\")");
#line 23 "../lib/Parser.vala"
	_tmp5_ = g_strdup ("(')");
#line 23 "../lib/Parser.vala"
	_tmp6_ = g_new0 (gchar*, 6 + 1);
#line 23 "../lib/Parser.vala"
	_tmp6_[0] = _tmp0_;
#line 23 "../lib/Parser.vala"
	_tmp6_[1] = _tmp1_;
#line 23 "../lib/Parser.vala"
	_tmp6_[2] = _tmp2_;
#line 23 "../lib/Parser.vala"
	_tmp6_[3] = _tmp3_;
#line 23 "../lib/Parser.vala"
	_tmp6_[4] = _tmp4_;
#line 23 "../lib/Parser.vala"
	_tmp6_[5] = _tmp5_;
#line 23 "../lib/Parser.vala"
	self->priv->start_patterns = _tmp6_;
#line 23 "../lib/Parser.vala"
	self->priv->start_patterns_length1 = 6;
#line 23 "../lib/Parser.vala"
	self->priv->_start_patterns_size_ = self->priv->start_patterns_length1;
#line 31 "../lib/Parser.vala"
	_tmp7_ = g_strdup ("(\\n)");
#line 31 "../lib/Parser.vala"
	_tmp8_ = g_strdup ("(\\*\\/)");
#line 31 "../lib/Parser.vala"
	_tmp9_ = g_strdup ("((?<!\\\\)(\\\\\\\\)*\\\"\\\"\\\")");
#line 31 "../lib/Parser.vala"
	_tmp10_ = g_strdup ("((?<!\\\\)(\\\\\\\\)*\")");
#line 31 "../lib/Parser.vala"
	_tmp11_ = g_strdup ("((?<!\\\\)(\\\\\\\\)*\")");
#line 31 "../lib/Parser.vala"
	_tmp12_ = g_strdup ("((?<!\\\\)(\\\\\\\\)*')");
#line 31 "../lib/Parser.vala"
	_tmp13_ = g_new0 (gchar*, 6 + 1);
#line 31 "../lib/Parser.vala"
	_tmp13_[0] = _tmp7_;
#line 31 "../lib/Parser.vala"
	_tmp13_[1] = _tmp8_;
#line 31 "../lib/Parser.vala"
	_tmp13_[2] = _tmp9_;
#line 31 "../lib/Parser.vala"
	_tmp13_[3] = _tmp10_;
#line 31 "../lib/Parser.vala"
	_tmp13_[4] = _tmp11_;
#line 31 "../lib/Parser.vala"
	_tmp13_[5] = _tmp12_;
#line 31 "../lib/Parser.vala"
	self->priv->close_patterns = _tmp13_;
#line 31 "../lib/Parser.vala"
	self->priv->close_patterns_length1 = 6;
#line 31 "../lib/Parser.vala"
	self->priv->_close_patterns_size_ = self->priv->close_patterns_length1;
#line 39 "../lib/Parser.vala"
	_tmp14_ = g_new0 (ParseType, 7);
#line 39 "../lib/Parser.vala"
	_tmp14_[0] = PARSE_TYPE_COMMENT;
#line 39 "../lib/Parser.vala"
	_tmp14_[1] = PARSE_TYPE_COMMENT;
#line 39 "../lib/Parser.vala"
	_tmp14_[2] = PARSE_TYPE_STRING;
#line 39 "../lib/Parser.vala"
	_tmp14_[3] = PARSE_TYPE_STRING;
#line 39 "../lib/Parser.vala"
	_tmp14_[4] = PARSE_TYPE_STRING;
#line 39 "../lib/Parser.vala"
	_tmp14_[5] = PARSE_TYPE_STRING;
#line 39 "../lib/Parser.vala"
	_tmp14_[6] = PARSE_TYPE_DEFAULT;
#line 39 "../lib/Parser.vala"
	self->priv->parse_types = _tmp14_;
#line 39 "../lib/Parser.vala"
	self->priv->parse_types_length1 = 7;
#line 39 "../lib/Parser.vala"
	self->priv->_parse_types_size_ = self->priv->parse_types_length1;
#line 1176 "Parser.c"
}

static void
vala_lint_parser_finalize (GObject * obj)
{
	ValaLintParser * self;
#line 20 "../lib/Parser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_PARSER, ValaLintParser);
#line 23 "../lib/Parser.vala"
	self->priv->start_patterns = (_vala_array_free (self->priv->start_patterns, self->priv->start_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 31 "../lib/Parser.vala"
	self->priv->close_patterns = (_vala_array_free (self->priv->close_patterns, self->priv->close_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 39 "../lib/Parser.vala"
	self->priv->parse_types = (g_free (self->priv->parse_types), NULL);
#line 20 "../lib/Parser.vala"
	G_OBJECT_CLASS (vala_lint_parser_parent_class)->finalize (obj);
#line 1193 "Parser.c"
}

static GType
vala_lint_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintParser), 0, (GInstanceInitFunc) vala_lint_parser_instance_init, NULL };
	GType vala_lint_parser_type_id;
	vala_lint_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintParser", &g_define_type_info, 0);
	ValaLintParser_private_offset = g_type_add_instance_private (vala_lint_parser_type_id, sizeof (ValaLintParserPrivate));
	return vala_lint_parser_type_id;
}

GType
vala_lint_parser_get_type (void)
{
	static volatile gsize vala_lint_parser_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_parser_type_id__once)) {
		GType vala_lint_parser_type_id;
		vala_lint_parser_type_id = vala_lint_parser_get_type_once ();
		g_once_init_leave (&vala_lint_parser_type_id__once, vala_lint_parser_type_id);
	}
	return vala_lint_parser_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

