/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/Vala-Lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>
#include <glib-object.h>
#include <valagee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	VALA_LINT_UTILS_0_PROPERTY,
	VALA_LINT_UTILS_NUM_PROPERTIES
};
static GParamSpec* vala_lint_utils_properties[VALA_LINT_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer vala_lint_utils_parent_class = NULL;

static GType vala_lint_utils_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
     * Method to get the position within an input string. Similar to index_of, but for non-null terminated strings using char pointers.
     *
     * @return The position of first index, otherwise null.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 78 "Utils.c"
}

gchar*
vala_lint_utils_get_pos_of (const gchar* needle,
                            gchar* begin,
                            gchar* end)
{
	gchar* pos = NULL;
	gchar* result;
#line 27 "../lib/Utils.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 28 "../lib/Utils.vala"
	pos = begin;
#line 29 "../lib/Utils.vala"
	while (TRUE) {
#line 94 "Utils.c"
		gchar* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gboolean equal = FALSE;
		gchar* _tmp10_;
#line 29 "../lib/Utils.vala"
		_tmp0_ = pos;
#line 29 "../lib/Utils.vala"
		_tmp1_ = strlen (needle);
#line 29 "../lib/Utils.vala"
		_tmp2_ = _tmp1_;
#line 29 "../lib/Utils.vala"
		if (!(_tmp0_ <= (end - _tmp2_))) {
#line 29 "../lib/Utils.vala"
			break;
#line 110 "Utils.c"
		}
#line 30 "../lib/Utils.vala"
		equal = TRUE;
#line 114 "Utils.c"
		{
			gint i = 0;
#line 31 "../lib/Utils.vala"
			i = 0;
#line 119 "Utils.c"
			{
				gboolean _tmp3_ = FALSE;
#line 31 "../lib/Utils.vala"
				_tmp3_ = TRUE;
#line 31 "../lib/Utils.vala"
				while (TRUE) {
#line 126 "Utils.c"
					gint _tmp5_;
					gint _tmp6_;
					gchar* _tmp7_;
					gchar _tmp8_;
#line 31 "../lib/Utils.vala"
					if (!_tmp3_) {
#line 133 "Utils.c"
						gint _tmp4_;
#line 31 "../lib/Utils.vala"
						_tmp4_ = i;
#line 31 "../lib/Utils.vala"
						i = _tmp4_ + 1;
#line 139 "Utils.c"
					}
#line 31 "../lib/Utils.vala"
					_tmp3_ = FALSE;
#line 31 "../lib/Utils.vala"
					_tmp5_ = strlen (needle);
#line 31 "../lib/Utils.vala"
					_tmp6_ = _tmp5_;
#line 31 "../lib/Utils.vala"
					if (!(i < _tmp6_)) {
#line 31 "../lib/Utils.vala"
						break;
#line 151 "Utils.c"
					}
#line 32 "../lib/Utils.vala"
					_tmp7_ = pos;
#line 32 "../lib/Utils.vala"
					_tmp8_ = _tmp7_[i];
#line 32 "../lib/Utils.vala"
					if (_tmp8_ != string_get (needle, (glong) i)) {
#line 33 "../lib/Utils.vala"
						equal = FALSE;
#line 34 "../lib/Utils.vala"
						break;
#line 163 "Utils.c"
					}
				}
			}
		}
#line 38 "../lib/Utils.vala"
		if (equal) {
#line 170 "Utils.c"
			gchar* _tmp9_;
#line 39 "../lib/Utils.vala"
			_tmp9_ = pos;
#line 39 "../lib/Utils.vala"
			result = _tmp9_;
#line 39 "../lib/Utils.vala"
			return result;
#line 178 "Utils.c"
		}
#line 42 "../lib/Utils.vala"
		_tmp10_ = pos;
#line 42 "../lib/Utils.vala"
		pos = _tmp10_ + 1;
#line 184 "Utils.c"
	}
#line 45 "../lib/Utils.vala"
	result = NULL;
#line 45 "../lib/Utils.vala"
	return result;
#line 190 "Utils.c"
}

/**
     * Method to get the line count of a string.
     *
     * @return The number of lines in the input string.
     */
gint
vala_lint_utils_get_line_count (const gchar* input)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result;
#line 53 "../lib/Utils.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 54 "../lib/Utils.vala"
	_tmp1_ = _tmp0_ = g_strsplit (input, "\n", 0);
#line 54 "../lib/Utils.vala"
	_tmp2_ = _tmp1_;
#line 54 "../lib/Utils.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 54 "../lib/Utils.vala"
	_tmp3_ = MAX (_vala_array_length (_tmp0_) - 1, 0);
#line 54 "../lib/Utils.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 54 "../lib/Utils.vala"
	result = _tmp3_;
#line 54 "../lib/Utils.vala"
	return result;
#line 223 "Utils.c"
}

/**
     * Method to get the char position in the current line of the input string.
     *
     * @return The char column.
     */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 255 "Utils.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 261 "Utils.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 267 "Utils.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 271 "Utils.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 279 "Utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 283 "Utils.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 295 "Utils.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1214 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1215 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1215 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1217 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1217 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 317 "Utils.c"
		gchar* _tmp2_;
#line 1218 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1218 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1218 "glib-2.0.vapi"
		return result;
#line 325 "Utils.c"
	} else {
#line 1220 "glib-2.0.vapi"
		result = -1;
#line 1220 "glib-2.0.vapi"
		return result;
#line 331 "Utils.c"
	}
}

gint
vala_lint_utils_get_column_in_line (const gchar* input,
                                    gint pos)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint result;
#line 62 "../lib/Utils.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 63 "../lib/Utils.vala"
	_tmp0_ = string_slice (input, (glong) 0, (glong) pos);
#line 63 "../lib/Utils.vala"
	_tmp1_ = _tmp0_;
#line 63 "../lib/Utils.vala"
	_tmp2_ = (pos - string_last_index_of_char (_tmp1_, (gunichar) '\n', 0)) - 1;
#line 63 "../lib/Utils.vala"
	_g_free0 (_tmp1_);
#line 63 "../lib/Utils.vala"
	result = _tmp2_;
#line 63 "../lib/Utils.vala"
	return result;
#line 357 "Utils.c"
}

/**
     * Method to get the char position in the current line of the input string using char pointers.
     *
     * @return The char column.
     */
gint
vala_lint_utils_get_column_of (gchar* begin,
                               gchar* pos)
{
	gint i = 0;
	gint result;
#line 72 "../lib/Utils.vala"
	i = 0;
#line 73 "../lib/Utils.vala"
	while (TRUE) {
#line 375 "Utils.c"
		gboolean _tmp0_ = FALSE;
		gchar _tmp1_;
#line 73 "../lib/Utils.vala"
		_tmp1_ = (pos - i)[-1];
#line 73 "../lib/Utils.vala"
		if (_tmp1_ != '\n') {
#line 73 "../lib/Utils.vala"
			_tmp0_ = (pos - i) > begin;
#line 384 "Utils.c"
		} else {
#line 73 "../lib/Utils.vala"
			_tmp0_ = FALSE;
#line 388 "Utils.c"
		}
#line 73 "../lib/Utils.vala"
		if (!_tmp0_) {
#line 73 "../lib/Utils.vala"
			break;
#line 394 "Utils.c"
		}
#line 74 "../lib/Utils.vala"
		i += 1;
#line 398 "Utils.c"
	}
#line 76 "../lib/Utils.vala"
	result = i + 1;
#line 76 "../lib/Utils.vala"
	return result;
#line 404 "Utils.c"
}

/**
     * Method to calculate an absolute location given a reference location and an offset column.
     * 
     * @return The absolute location.
     */
void
vala_lint_utils_get_absolute_location (ValaSourceLocation* reference,
                                       const gchar* text,
                                       gint offset,
                                       ValaSourceLocation* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint line_count = 0;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint line = 0;
	ValaSourceLocation _tmp5_;
	gint column = 0;
	ValaSourceLocation _tmp7_;
	gchar* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
#line 84 "../lib/Utils.vala"
	g_return_if_fail (reference != NULL);
#line 84 "../lib/Utils.vala"
	g_return_if_fail (text != NULL);
#line 86 "../lib/Utils.vala"
	_tmp0_ = strlen (text);
#line 86 "../lib/Utils.vala"
	_tmp1_ = _tmp0_;
#line 86 "../lib/Utils.vala"
	offset = MIN (offset, _tmp1_);
#line 88 "../lib/Utils.vala"
	_tmp2_ = string_slice (text, (glong) 0, (glong) offset);
#line 88 "../lib/Utils.vala"
	_tmp3_ = _tmp2_;
#line 88 "../lib/Utils.vala"
	_tmp4_ = vala_lint_utils_get_line_count (_tmp3_);
#line 88 "../lib/Utils.vala"
	_g_free0 (_tmp3_);
#line 88 "../lib/Utils.vala"
	line_count = _tmp4_;
#line 89 "../lib/Utils.vala"
	_tmp5_ = *reference;
#line 89 "../lib/Utils.vala"
	line = _tmp5_.line + line_count;
#line 90 "../lib/Utils.vala"
	column = vala_lint_utils_get_column_in_line (text, offset);
#line 91 "../lib/Utils.vala"
	if (line_count == 0) {
#line 458 "Utils.c"
		ValaSourceLocation _tmp6_;
#line 92 "../lib/Utils.vala"
		_tmp6_ = *reference;
#line 92 "../lib/Utils.vala"
		column += _tmp6_.column;
#line 464 "Utils.c"
	}
#line 95 "../lib/Utils.vala"
	_tmp7_ = *reference;
#line 95 "../lib/Utils.vala"
	_tmp8_ = _tmp7_.pos;
#line 95 "../lib/Utils.vala"
	vala_source_location_init (&_tmp9_, _tmp8_ + offset, line, column);
#line 95 "../lib/Utils.vala"
	*result = _tmp9_;
#line 95 "../lib/Utils.vala"
	return;
#line 476 "Utils.c"
}

ValaArrayList*
vala_lint_utils_filter (GType g_type,
                        GBoxedCopyFunc g_dup_func,
                        GDestroyNotify g_destroy_func,
                        ValaLintUtilsFilterFunction func,
                        gpointer func_target,
                        ValaArrayList* source)
{
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	ValaArrayList* result;
#line 104 "../lib/Utils.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 105 "../lib/Utils.vala"
	_tmp0_ = g_direct_equal;
#line 105 "../lib/Utils.vala"
	_tmp1_ = vala_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, _tmp0_);
#line 105 "../lib/Utils.vala"
	_result_ = _tmp1_;
#line 499 "Utils.c"
	{
		ValaArrayList* _elem_list = NULL;
		gint _elem_size = 0;
		ValaArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _elem_index = 0;
#line 107 "../lib/Utils.vala"
		_elem_list = source;
#line 107 "../lib/Utils.vala"
		_tmp2_ = _elem_list;
#line 107 "../lib/Utils.vala"
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
#line 107 "../lib/Utils.vala"
		_tmp4_ = _tmp3_;
#line 107 "../lib/Utils.vala"
		_elem_size = _tmp4_;
#line 107 "../lib/Utils.vala"
		_elem_index = -1;
#line 107 "../lib/Utils.vala"
		while (TRUE) {
#line 521 "Utils.c"
			gint _tmp5_;
			gint _tmp6_;
			gpointer elem = NULL;
			ValaArrayList* _tmp7_;
			gpointer _tmp8_;
			gconstpointer _tmp9_;
#line 107 "../lib/Utils.vala"
			_elem_index = _elem_index + 1;
#line 107 "../lib/Utils.vala"
			_tmp5_ = _elem_index;
#line 107 "../lib/Utils.vala"
			_tmp6_ = _elem_size;
#line 107 "../lib/Utils.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 107 "../lib/Utils.vala"
				break;
#line 538 "Utils.c"
			}
#line 107 "../lib/Utils.vala"
			_tmp7_ = _elem_list;
#line 107 "../lib/Utils.vala"
			_tmp8_ = vala_list_get ((ValaList*) _tmp7_, _elem_index);
#line 107 "../lib/Utils.vala"
			elem = _tmp8_;
#line 108 "../lib/Utils.vala"
			_tmp9_ = elem;
#line 108 "../lib/Utils.vala"
			if (func (_tmp9_, func_target)) {
#line 550 "Utils.c"
				ValaArrayList* _tmp10_;
				gconstpointer _tmp11_;
#line 109 "../lib/Utils.vala"
				_tmp10_ = _result_;
#line 109 "../lib/Utils.vala"
				_tmp11_ = elem;
#line 109 "../lib/Utils.vala"
				vala_collection_add ((ValaCollection*) _tmp10_, _tmp11_);
#line 559 "Utils.c"
			}
#line 107 "../lib/Utils.vala"
			((elem == NULL) || (g_destroy_func == NULL)) ? NULL : (elem = (g_destroy_func (elem), NULL));
#line 563 "Utils.c"
		}
	}
#line 113 "../lib/Utils.vala"
	result = _result_;
#line 113 "../lib/Utils.vala"
	return result;
#line 570 "Utils.c"
}

/**
     * Method to return a new Vala.SourceLocation from a reference shifted by a given offset.
     * 
     * @return The new Vala.SourceLocation
     */
void
vala_lint_utils_shift_location (ValaSourceLocation* reference,
                                gint offset,
                                ValaSourceLocation* result)
{
	ValaSourceLocation _result_ = {0};
	ValaSourceLocation _tmp0_;
	gchar* _tmp1_;
#line 121 "../lib/Utils.vala"
	g_return_if_fail (reference != NULL);
#line 122 "../lib/Utils.vala"
	_tmp0_ = *reference;
#line 122 "../lib/Utils.vala"
	_result_ = _tmp0_;
#line 123 "../lib/Utils.vala"
	_tmp1_ = _result_.pos;
#line 123 "../lib/Utils.vala"
	_result_.pos = _tmp1_ + offset;
#line 124 "../lib/Utils.vala"
	_result_.column = _result_.column + offset;
#line 125 "../lib/Utils.vala"
	*result = _result_;
#line 125 "../lib/Utils.vala"
	return;
#line 602 "Utils.c"
}

ValaLintUtils*
vala_lint_utils_construct (GType object_type)
{
	ValaLintUtils * self = NULL;
#line 20 "../lib/Utils.vala"
	self = (ValaLintUtils*) g_object_new (object_type, NULL);
#line 20 "../lib/Utils.vala"
	return self;
#line 613 "Utils.c"
}

ValaLintUtils*
vala_lint_utils_new (void)
{
#line 20 "../lib/Utils.vala"
	return vala_lint_utils_construct (VALA_LINT_TYPE_UTILS);
#line 621 "Utils.c"
}

static void
vala_lint_utils_class_init (ValaLintUtilsClass * klass,
                            gpointer klass_data)
{
#line 20 "../lib/Utils.vala"
	vala_lint_utils_parent_class = g_type_class_peek_parent (klass);
#line 630 "Utils.c"
}

static void
vala_lint_utils_instance_init (ValaLintUtils * self,
                               gpointer klass)
{
}

static GType
vala_lint_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintUtils), 0, (GInstanceInitFunc) vala_lint_utils_instance_init, NULL };
	GType vala_lint_utils_type_id;
	vala_lint_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintUtils", &g_define_type_info, 0);
	return vala_lint_utils_type_id;
}

GType
vala_lint_utils_get_type (void)
{
	static volatile gsize vala_lint_utils_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_utils_type_id__once)) {
		GType vala_lint_utils_type_id;
		vala_lint_utils_type_id = vala_lint_utils_get_type_once ();
		g_once_init_leave (&vala_lint_utils_type_id__once, vala_lint_utils_type_id);
	}
	return vala_lint_utils_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

