/* ValaReporter.c generated by valac 0.56.17, the Vala compiler
 * generated from ValaReporter.vala, do not modify */

/*
 * Copyright (c) 2018 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <vala.h>
#include <glib-object.h>
#include <valagee.h>
#include "vala-linter.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define VALA_LINT_TYPE_REPORTER (vala_lint_reporter_get_type ())
#define VALA_LINT_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_REPORTER, ValaLintReporter))
#define VALA_LINT_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_REPORTER, ValaLintReporterClass))
#define VALA_LINT_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_REPORTER))
#define VALA_LINT_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_REPORTER))
#define VALA_LINT_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_REPORTER, ValaLintReporterClass))

typedef struct _ValaLintReporter ValaLintReporter;
typedef struct _ValaLintReporterClass ValaLintReporterClass;
typedef struct _ValaLintReporterPrivate ValaLintReporterPrivate;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValaLintReporter {
	ValaReport parent_instance;
	ValaLintReporterPrivate * priv;
};

struct _ValaLintReporterClass {
	ValaReportClass parent_class;
};

struct _ValaLintReporterPrivate {
	ValaArrayList* mistake_list;
};

static gint ValaLintReporter_private_offset;
static gpointer vala_lint_reporter_parent_class = NULL;

VALA_EXTERN GType vala_lint_reporter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ValaLintReporter* vala_lint_reporter_new (ValaArrayList* mistake_list);
VALA_EXTERN ValaLintReporter* vala_lint_reporter_construct (GType object_type,
                                                ValaArrayList* mistake_list);
static void vala_lint_reporter_real_note (ValaReport* base,
                                   ValaSourceReference* reference,
                                   const gchar* message);
static void vala_lint_reporter_real_depr (ValaReport* base,
                                   ValaSourceReference* reference,
                                   const gchar* message);
static void vala_lint_reporter_real_warn (ValaReport* base,
                                   ValaSourceReference* reference,
                                   const gchar* message);
static void vala_lint_reporter_real_err (ValaReport* base,
                                  ValaSourceReference* reference,
                                  const gchar* message);
static void vala_lint_reporter_finalize (ValaReport * obj);
static GType vala_lint_reporter_get_type_once (void);

static inline gpointer
vala_lint_reporter_get_instance_private (ValaLintReporter* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintReporter_private_offset);
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
#line 25 "../lib/ValaReporter.vala"
	return self ? vala_iterable_ref (self) : NULL;
#line 99 "ValaReporter.c"
}

ValaLintReporter*
vala_lint_reporter_construct (GType object_type,
                              ValaArrayList* mistake_list)
{
	ValaLintReporter* self = NULL;
	ValaArrayList* _tmp0_;
#line 24 "../lib/ValaReporter.vala"
	g_return_val_if_fail (mistake_list != NULL, NULL);
#line 24 "../lib/ValaReporter.vala"
	self = (ValaLintReporter*) vala_report_construct (object_type);
#line 25 "../lib/ValaReporter.vala"
	_tmp0_ = _vala_iterable_ref0 (mistake_list);
#line 25 "../lib/ValaReporter.vala"
	_vala_iterable_unref0 (self->priv->mistake_list);
#line 25 "../lib/ValaReporter.vala"
	self->priv->mistake_list = _tmp0_;
#line 24 "../lib/ValaReporter.vala"
	return self;
#line 120 "ValaReporter.c"
}

ValaLintReporter*
vala_lint_reporter_new (ValaArrayList* mistake_list)
{
#line 24 "../lib/ValaReporter.vala"
	return vala_lint_reporter_construct (VALA_LINT_TYPE_REPORTER, mistake_list);
#line 128 "ValaReporter.c"
}

static void
vala_lint_reporter_real_note (ValaReport* base,
                              ValaSourceReference* reference,
                              const gchar* message)
{
	ValaLintReporter * self;
#line 28 "../lib/ValaReporter.vala"
	self = (ValaLintReporter*) base;
#line 28 "../lib/ValaReporter.vala"
	g_return_if_fail (message != NULL);
#line 141 "ValaReporter.c"
}

static void
vala_lint_reporter_real_depr (ValaReport* base,
                              ValaSourceReference* reference,
                              const gchar* message)
{
	ValaLintReporter * self;
#line 30 "../lib/ValaReporter.vala"
	self = (ValaLintReporter*) base;
#line 30 "../lib/ValaReporter.vala"
	g_return_if_fail (message != NULL);
#line 154 "ValaReporter.c"
}

static void
vala_lint_reporter_real_warn (ValaReport* base,
                              ValaSourceReference* reference,
                              const gchar* message)
{
	ValaLintReporter * self;
#line 32 "../lib/ValaReporter.vala"
	self = (ValaLintReporter*) base;
#line 32 "../lib/ValaReporter.vala"
	g_return_if_fail (message != NULL);
#line 167 "ValaReporter.c"
}

static void
vala_lint_reporter_real_err (ValaReport* base,
                             ValaSourceReference* reference,
                             const gchar* message)
{
	ValaLintReporter * self;
#line 34 "../lib/ValaReporter.vala"
	self = (ValaLintReporter*) base;
#line 34 "../lib/ValaReporter.vala"
	g_return_if_fail (message != NULL);
#line 180 "ValaReporter.c"
}

static void
vala_lint_reporter_class_init (ValaLintReporterClass * klass,
                               gpointer klass_data)
{
#line 20 "../lib/ValaReporter.vala"
	vala_lint_reporter_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/ValaReporter.vala"
	((ValaReportClass *) klass)->finalize = vala_lint_reporter_finalize;
#line 20 "../lib/ValaReporter.vala"
	g_type_class_adjust_private_offset (klass, &ValaLintReporter_private_offset);
#line 20 "../lib/ValaReporter.vala"
	((ValaReportClass *) klass)->note = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vala_lint_reporter_real_note;
#line 20 "../lib/ValaReporter.vala"
	((ValaReportClass *) klass)->depr = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vala_lint_reporter_real_depr;
#line 20 "../lib/ValaReporter.vala"
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vala_lint_reporter_real_warn;
#line 20 "../lib/ValaReporter.vala"
	((ValaReportClass *) klass)->err = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vala_lint_reporter_real_err;
#line 201 "ValaReporter.c"
}

static void
vala_lint_reporter_instance_init (ValaLintReporter * self,
                                  gpointer klass)
{
#line 20 "../lib/ValaReporter.vala"
	self->priv = vala_lint_reporter_get_instance_private (self);
#line 210 "ValaReporter.c"
}

static void
vala_lint_reporter_finalize (ValaReport * obj)
{
	ValaLintReporter * self;
#line 20 "../lib/ValaReporter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_REPORTER, ValaLintReporter);
#line 21 "../lib/ValaReporter.vala"
	_vala_iterable_unref0 (self->priv->mistake_list);
#line 20 "../lib/ValaReporter.vala"
	VALA_REPORT_CLASS (vala_lint_reporter_parent_class)->finalize (obj);
#line 223 "ValaReporter.c"
}

static GType
vala_lint_reporter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintReporterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_reporter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintReporter), 0, (GInstanceInitFunc) vala_lint_reporter_instance_init, NULL };
	GType vala_lint_reporter_type_id;
	vala_lint_reporter_type_id = g_type_register_static (VALA_TYPE_REPORT, "ValaLintReporter", &g_define_type_info, 0);
	ValaLintReporter_private_offset = g_type_add_instance_private (vala_lint_reporter_type_id, sizeof (ValaLintReporterPrivate));
	return vala_lint_reporter_type_id;
}

GType
vala_lint_reporter_get_type (void)
{
	static volatile gsize vala_lint_reporter_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_reporter_type_id__once)) {
		GType vala_lint_reporter_type_id;
		vala_lint_reporter_type_id = vala_lint_reporter_get_type_once ();
		g_once_init_leave (&vala_lint_reporter_type_id__once, vala_lint_reporter_type_id);
	}
	return vala_lint_reporter_type_id__once;
}

