/* ValaVisitor.c generated by valac 0.56.17, the Vala compiler
 * generated from ValaVisitor.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <vala.h>
#include <glib-object.h>
#include <valagee.h>
#include "vala-linter.h"
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define VALA_LINT_TYPE_VISITOR (vala_lint_visitor_get_type ())
#define VALA_LINT_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitor))
#define VALA_LINT_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))
#define VALA_LINT_IS_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_IS_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))

typedef struct _ValaLintVisitor ValaLintVisitor;
typedef struct _ValaLintVisitorClass ValaLintVisitorClass;
typedef struct _ValaLintVisitorPrivate ValaLintVisitorPrivate;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValaLintVisitor {
	ValaCodeVisitor parent_instance;
	ValaLintVisitorPrivate * priv;
	ValaArrayList* mistake_list;
	ValaLintChecksDoubleSemicolonCheck* double_semicolon_check;
	ValaLintChecksEllipsisCheck* ellipsis_check;
	ValaLintChecksNamingConventionCheck* naming_convention_check;
	ValaLintChecksUnnecessaryStringTemplateCheck* unnecessary_string_template_check;
	ValaLintChecksNoSpaceCheck* no_space_check;
};

struct _ValaLintVisitorClass {
	ValaCodeVisitorClass parent_class;
};

static gpointer vala_lint_visitor_parent_class = NULL;

VALA_EXTERN GType vala_lint_visitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void vala_lint_visitor_set_mistake_list (ValaLintVisitor* self,
                                         ValaArrayList* mistake_list);
static void vala_lint_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                               ValaSourceFile* sf);
static void vala_lint_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                             ValaNamespace* ns);
static void vala_lint_visitor_real_visit_class (ValaCodeVisitor* base,
                                         ValaClass* cl);
static void vala_lint_visitor_real_visit_struct (ValaCodeVisitor* base,
                                          ValaStruct* st);
static void vala_lint_visitor_real_visit_interface (ValaCodeVisitor* base,
                                             ValaInterface* iface);
static void vala_lint_visitor_real_visit_enum (ValaCodeVisitor* base,
                                        ValaEnum* en);
static void vala_lint_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                              ValaEnumValue* ev);
static void vala_lint_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                                ValaErrorDomain* edomain);
static void vala_lint_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                              ValaErrorCode* ecode);
static void vala_lint_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                            ValaDelegate* d);
static void vala_lint_visitor_real_visit_constant (ValaCodeVisitor* base,
                                            ValaConstant* c);
static void vala_lint_visitor_real_visit_field (ValaCodeVisitor* base,
                                         ValaField* f);
static void vala_lint_visitor_real_visit_method (ValaCodeVisitor* base,
                                          ValaMethod* m);
static void vala_lint_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                                   ValaCreationMethod* m);
static void vala_lint_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                    ValaParameter* p);
static void vala_lint_visitor_real_visit_property (ValaCodeVisitor* base,
                                            ValaProperty* prop);
static void vala_lint_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                     ValaPropertyAccessor* acc);
static void vala_lint_visitor_real_visit_signal (ValaCodeVisitor* base,
                                          ValaSignal* sig);
static void vala_lint_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                               ValaConstructor* c);
static void vala_lint_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                              ValaDestructor* d);
static void vala_lint_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                                  ValaTypeParameter* p);
static void vala_lint_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                                   ValaUsingDirective* ns);
static void vala_lint_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                             ValaDataType* type);
static void vala_lint_visitor_real_visit_block (ValaCodeVisitor* base,
                                         ValaBlock* b);
static void vala_lint_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                                   ValaEmptyStatement* stmt);
static void vala_lint_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                         ValaDeclarationStatement* stmt);
static void vala_lint_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                                  ValaLocalVariable* local);
static void vala_lint_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                                    ValaInitializerList* list);
static void vala_lint_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                        ValaExpressionStatement* stmt);
static void vala_lint_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                                ValaIfStatement* stmt);
static void vala_lint_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                                    ValaSwitchStatement* stmt);
static void vala_lint_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                                  ValaSwitchSection* section);
static void vala_lint_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                                ValaSwitchLabel* label);
static void vala_lint_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                                  ValaLoopStatement* stmt);
static void vala_lint_visitor_real_visit_while_statement (ValaCodeVisitor* base,
                                                   ValaWhileStatement* stmt);
static void vala_lint_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                                ValaDoStatement* stmt);
static void vala_lint_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                                 ValaForStatement* stmt);
static void vala_lint_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                     ValaForeachStatement* stmt);
static void vala_lint_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                                   ValaBreakStatement* stmt);
static void vala_lint_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                      ValaContinueStatement* stmt);
static void vala_lint_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                                    ValaReturnStatement* stmt);
static void vala_lint_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                                   ValaYieldStatement* y);
static void vala_lint_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                                   ValaThrowStatement* stmt);
static void vala_lint_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                                 ValaTryStatement* stmt);
static void vala_lint_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                                ValaCatchClause* clause);
static void vala_lint_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                                  ValaLockStatement* stmt);
static void vala_lint_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                    ValaUnlockStatement* stmt);
static void vala_lint_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                                  ValaWithStatement* stmt);
static void vala_lint_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                                    ValaDeleteStatement* stmt);
static void vala_lint_visitor_real_visit_expression (ValaCodeVisitor* base,
                                              ValaExpression* expr);
static void vala_lint_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                             ValaArrayCreationExpression* expr);
static void vala_lint_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                                   ValaBooleanLiteral* lit);
static void vala_lint_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                     ValaCharacterLiteral* lit);
static void vala_lint_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                                   ValaIntegerLiteral* lit);
static void vala_lint_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                                ValaRealLiteral* lit);
static void vala_lint_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                                 ValaRegexLiteral* lit);
static void vala_lint_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                                  ValaStringLiteral* lit);
static void vala_lint_visitor_real_visit_template (ValaCodeVisitor* base,
                                            ValaTemplate* tmpl);
static void vala_lint_visitor_real_visit_tuple (ValaCodeVisitor* base,
                                         ValaTuple* tuple);
static void vala_lint_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                                ValaNullLiteral* lit);
static void vala_lint_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                                 ValaMemberAccess* expr);
static void vala_lint_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                               ValaMethodCall* expr);
static void vala_lint_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                                  ValaElementAccess* expr);
static void vala_lint_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                                    ValaSliceExpression* expr);
static void vala_lint_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                               ValaBaseAccess* expr);
static void vala_lint_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                      ValaPostfixExpression* expr);
static void vala_lint_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                              ValaObjectCreationExpression* expr);
static void vala_lint_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                     ValaSizeofExpression* expr);
static void vala_lint_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                     ValaTypeofExpression* expr);
static void vala_lint_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                                    ValaUnaryExpression* expr);
static void vala_lint_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                                   ValaCastExpression* expr);
static void vala_lint_visitor_real_visit_named_argument (ValaCodeVisitor* base,
                                                  ValaNamedArgument* expr);
static void vala_lint_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                       ValaPointerIndirection* expr);
static void vala_lint_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                        ValaAddressofExpression* expr);
static void vala_lint_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                                 ValaReferenceTransferExpression* expr);
static void vala_lint_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                     ValaBinaryExpression* expr);
static void vala_lint_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                              ValaTypeCheck* expr);
static void vala_lint_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                          ValaConditionalExpression* expr);
static void vala_lint_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                     ValaLambdaExpression* expr);
static void vala_lint_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                              ValaAssignment* a);
static void vala_lint_visitor_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                       ValaExpression* expr);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_new (void);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_construct (GType object_type);
static void vala_lint_visitor_finalize (ValaCodeVisitor * obj);
static GType vala_lint_visitor_get_type_once (void);

static gpointer
_vala_iterable_ref0 (gpointer self)
{
#line 30 "../lib/ValaVisitor.vala"
	return self ? vala_iterable_ref (self) : NULL;
#line 244 "ValaVisitor.c"
}

void
vala_lint_visitor_set_mistake_list (ValaLintVisitor* self,
                                    ValaArrayList* mistake_list)
{
	ValaArrayList* _tmp0_;
#line 29 "../lib/ValaVisitor.vala"
	g_return_if_fail (self != NULL);
#line 29 "../lib/ValaVisitor.vala"
	g_return_if_fail (mistake_list != NULL);
#line 30 "../lib/ValaVisitor.vala"
	_tmp0_ = _vala_iterable_ref0 (mistake_list);
#line 30 "../lib/ValaVisitor.vala"
	_vala_iterable_unref0 (self->mistake_list);
#line 30 "../lib/ValaVisitor.vala"
	self->mistake_list = _tmp0_;
#line 262 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                          ValaSourceFile* sf)
{
	ValaLintVisitor * self;
#line 33 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 33 "../lib/ValaVisitor.vala"
	g_return_if_fail (sf != NULL);
#line 34 "../lib/ValaVisitor.vala"
	vala_source_file_accept_children (sf, (ValaCodeVisitor*) self);
#line 276 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                        ValaNamespace* ns)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 37 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 37 "../lib/ValaVisitor.vala"
	g_return_if_fail (ns != NULL);
#line 39 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 39 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) ns, &self->mistake_list);
#line 41 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
#line 295 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_class (ValaCodeVisitor* base,
                                    ValaClass* cl)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 44 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 44 "../lib/ValaVisitor.vala"
	g_return_if_fail (cl != NULL);
#line 45 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 45 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) cl, &self->mistake_list);
#line 46 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
#line 314 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_struct (ValaCodeVisitor* base,
                                     ValaStruct* st)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 49 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 49 "../lib/ValaVisitor.vala"
	g_return_if_fail (st != NULL);
#line 50 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 50 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) st, &self->mistake_list);
#line 51 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
#line 333 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_interface (ValaCodeVisitor* base,
                                        ValaInterface* iface)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 54 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 54 "../lib/ValaVisitor.vala"
	g_return_if_fail (iface != NULL);
#line 55 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 55 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) iface, &self->mistake_list);
#line 56 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
#line 352 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_enum (ValaCodeVisitor* base,
                                   ValaEnum* en)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 59 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 59 "../lib/ValaVisitor.vala"
	g_return_if_fail (en != NULL);
#line 60 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 60 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) en, &self->mistake_list);
#line 61 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
#line 371 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                         ValaEnumValue* ev)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 64 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 64 "../lib/ValaVisitor.vala"
	g_return_if_fail (ev != NULL);
#line 65 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 65 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_all_caps (_tmp0_, (ValaSymbol*) ev, &self->mistake_list);
#line 66 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) ev, (ValaCodeVisitor*) self);
#line 390 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                           ValaErrorDomain* edomain)
{
	ValaLintVisitor * self;
#line 69 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 69 "../lib/ValaVisitor.vala"
	g_return_if_fail (edomain != NULL);
#line 70 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) edomain, (ValaCodeVisitor*) self);
#line 404 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                         ValaErrorCode* ecode)
{
	ValaLintVisitor * self;
#line 73 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 73 "../lib/ValaVisitor.vala"
	g_return_if_fail (ecode != NULL);
#line 74 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) ecode, (ValaCodeVisitor*) self);
#line 418 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                       ValaDelegate* d)
{
	ValaLintVisitor * self;
#line 77 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 77 "../lib/ValaVisitor.vala"
	g_return_if_fail (d != NULL);
#line 78 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
#line 432 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_constant (ValaCodeVisitor* base,
                                       ValaConstant* c)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 81 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 81 "../lib/ValaVisitor.vala"
	g_return_if_fail (c != NULL);
#line 82 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 82 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_all_caps (_tmp0_, (ValaSymbol*) c, &self->mistake_list);
#line 84 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
#line 451 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_field (ValaCodeVisitor* base,
                                    ValaField* f)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 87 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 87 "../lib/ValaVisitor.vala"
	g_return_if_fail (f != NULL);
#line 88 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 88 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) f, &self->mistake_list);
#line 90 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
#line 470 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_method (ValaCodeVisitor* base,
                                     ValaMethod* m)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	ValaLintChecksNoSpaceCheck* _tmp1_;
	ValaList* _tmp2_;
#line 93 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 93 "../lib/ValaVisitor.vala"
	g_return_if_fail (m != NULL);
#line 95 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 95 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) m, &self->mistake_list);
#line 97 "../lib/ValaVisitor.vala"
	_tmp1_ = self->no_space_check;
#line 97 "../lib/ValaVisitor.vala"
	_tmp2_ = vala_callable_get_parameters ((ValaCallable*) m);
#line 97 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_list (_tmp1_, _tmp2_, &self->mistake_list);
#line 104 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
#line 497 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                              ValaCreationMethod* m)
{
	ValaLintVisitor * self;
#line 107 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 107 "../lib/ValaVisitor.vala"
	g_return_if_fail (m != NULL);
#line 108 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
#line 511 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                               ValaParameter* p)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 111 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 111 "../lib/ValaVisitor.vala"
	g_return_if_fail (p != NULL);
#line 112 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 112 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) p, &self->mistake_list);
#line 114 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
#line 530 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_property (ValaCodeVisitor* base,
                                       ValaProperty* prop)
{
	ValaLintVisitor * self;
#line 117 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 117 "../lib/ValaVisitor.vala"
	g_return_if_fail (prop != NULL);
#line 118 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
#line 544 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                ValaPropertyAccessor* acc)
{
	ValaLintVisitor * self;
#line 121 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 121 "../lib/ValaVisitor.vala"
	g_return_if_fail (acc != NULL);
#line 122 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
#line 558 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_signal (ValaCodeVisitor* base,
                                     ValaSignal* sig)
{
	ValaLintVisitor * self;
#line 125 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 125 "../lib/ValaVisitor.vala"
	g_return_if_fail (sig != NULL);
#line 126 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
#line 572 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                          ValaConstructor* c)
{
	ValaLintVisitor * self;
#line 129 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 129 "../lib/ValaVisitor.vala"
	g_return_if_fail (c != NULL);
#line 130 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
#line 586 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                         ValaDestructor* d)
{
	ValaLintVisitor * self;
#line 133 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 133 "../lib/ValaVisitor.vala"
	g_return_if_fail (d != NULL);
#line 134 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
#line 600 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                             ValaTypeParameter* p)
{
	ValaLintVisitor * self;
#line 137 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 137 "../lib/ValaVisitor.vala"
	g_return_if_fail (p != NULL);
#line 138 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
#line 614 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                              ValaUsingDirective* ns)
{
	ValaLintVisitor * self;
#line 141 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 141 "../lib/ValaVisitor.vala"
	g_return_if_fail (ns != NULL);
#line 142 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
#line 628 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                        ValaDataType* type)
{
	ValaLintVisitor * self;
#line 145 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 145 "../lib/ValaVisitor.vala"
	g_return_if_fail (type != NULL);
#line 146 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
#line 642 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_block (ValaCodeVisitor* base,
                                    ValaBlock* b)
{
	ValaLintVisitor * self;
#line 149 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 149 "../lib/ValaVisitor.vala"
	g_return_if_fail (b != NULL);
#line 150 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
#line 656 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                              ValaEmptyStatement* stmt)
{
	ValaLintVisitor * self;
#line 153 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 153 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 668 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                    ValaDeclarationStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
#line 156 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 156 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 157 "../lib/ValaVisitor.vala"
	_tmp0_ = self->double_semicolon_check;
#line 157 "../lib/ValaVisitor.vala"
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
#line 159 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 687 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                             ValaLocalVariable* local)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
#line 162 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 162 "../lib/ValaVisitor.vala"
	g_return_if_fail (local != NULL);
#line 163 "../lib/ValaVisitor.vala"
	_tmp0_ = self->naming_convention_check;
#line 163 "../lib/ValaVisitor.vala"
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) local, &self->mistake_list);
#line 165 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
#line 706 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                               ValaInitializerList* list)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
#line 168 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 168 "../lib/ValaVisitor.vala"
	g_return_if_fail (list != NULL);
#line 169 "../lib/ValaVisitor.vala"
	_tmp0_ = self->no_space_check;
#line 169 "../lib/ValaVisitor.vala"
	_tmp1_ = vala_initializer_list_get_initializers (list);
#line 169 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
#line 171 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
#line 728 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                   ValaExpressionStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
#line 174 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 174 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 175 "../lib/ValaVisitor.vala"
	_tmp0_ = self->double_semicolon_check;
#line 175 "../lib/ValaVisitor.vala"
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
#line 177 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 747 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                           ValaIfStatement* stmt)
{
	ValaLintVisitor * self;
#line 180 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 180 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 181 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 761 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                               ValaSwitchStatement* stmt)
{
	ValaLintVisitor * self;
#line 184 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 184 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 185 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 775 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                             ValaSwitchSection* section)
{
	ValaLintVisitor * self;
#line 188 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 188 "../lib/ValaVisitor.vala"
	g_return_if_fail (section != NULL);
#line 189 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
#line 789 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                           ValaSwitchLabel* label)
{
	ValaLintVisitor * self;
#line 192 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 192 "../lib/ValaVisitor.vala"
	g_return_if_fail (label != NULL);
#line 193 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
#line 803 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                             ValaLoopStatement* stmt)
{
	ValaLintVisitor * self;
#line 197 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 197 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 201 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 817 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_while_statement (ValaCodeVisitor* base,
                                              ValaWhileStatement* stmt)
{
	ValaLintVisitor * self;
#line 204 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 204 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 205 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 831 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                           ValaDoStatement* stmt)
{
	ValaLintVisitor * self;
#line 208 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 208 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 209 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 845 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                            ValaForStatement* stmt)
{
	ValaLintVisitor * self;
#line 212 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 212 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 213 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 859 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                ValaForeachStatement* stmt)
{
	ValaLintVisitor * self;
#line 216 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 216 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 217 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 873 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                              ValaBreakStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
#line 220 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 220 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 221 "../lib/ValaVisitor.vala"
	_tmp0_ = self->double_semicolon_check;
#line 221 "../lib/ValaVisitor.vala"
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
#line 223 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 892 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                 ValaContinueStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
#line 226 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 226 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 227 "../lib/ValaVisitor.vala"
	_tmp0_ = self->double_semicolon_check;
#line 227 "../lib/ValaVisitor.vala"
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
#line 229 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 911 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                               ValaReturnStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
#line 232 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 232 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 233 "../lib/ValaVisitor.vala"
	_tmp0_ = self->double_semicolon_check;
#line 233 "../lib/ValaVisitor.vala"
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
#line 235 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 930 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                              ValaYieldStatement* y)
{
	ValaLintVisitor * self;
#line 238 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 238 "../lib/ValaVisitor.vala"
	g_return_if_fail (y != NULL);
#line 239 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) y, (ValaCodeVisitor*) self);
#line 944 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                              ValaThrowStatement* stmt)
{
	ValaLintVisitor * self;
#line 242 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 242 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 243 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 958 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                            ValaTryStatement* stmt)
{
	ValaLintVisitor * self;
#line 246 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 246 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 247 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 972 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                           ValaCatchClause* clause)
{
	ValaLintVisitor * self;
#line 250 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 250 "../lib/ValaVisitor.vala"
	g_return_if_fail (clause != NULL);
#line 251 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
#line 986 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                             ValaLockStatement* stmt)
{
	ValaLintVisitor * self;
#line 254 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 254 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 255 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 1000 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                               ValaUnlockStatement* stmt)
{
	ValaLintVisitor * self;
#line 258 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 258 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 259 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 1014 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                             ValaWithStatement* stmt)
{
	ValaLintVisitor * self;
#line 263 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 263 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 264 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 1028 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                               ValaDeleteStatement* stmt)
{
	ValaLintVisitor * self;
#line 268 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 268 "../lib/ValaVisitor.vala"
	g_return_if_fail (stmt != NULL);
#line 269 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 1042 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_expression (ValaCodeVisitor* base,
                                         ValaExpression* expr)
{
	ValaLintVisitor * self;
#line 272 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 272 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 1054 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                        ValaArrayCreationExpression* expr)
{
	ValaLintVisitor * self;
#line 277 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 277 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 278 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1068 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                              ValaBooleanLiteral* lit)
{
	ValaLintVisitor * self;
#line 281 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 281 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 282 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1082 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                ValaCharacterLiteral* lit)
{
	ValaLintVisitor * self;
#line 285 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 285 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 286 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1096 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                              ValaIntegerLiteral* lit)
{
	ValaLintVisitor * self;
#line 289 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 289 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 290 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1110 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                           ValaRealLiteral* lit)
{
	ValaLintVisitor * self;
#line 293 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 293 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 294 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1124 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                            ValaRegexLiteral* lit)
{
	ValaLintVisitor * self;
#line 297 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 297 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 298 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1138 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                             ValaStringLiteral* lit)
{
	ValaLintVisitor * self;
	ValaLintChecksEllipsisCheck* _tmp0_;
#line 301 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 301 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 302 "../lib/ValaVisitor.vala"
	_tmp0_ = self->ellipsis_check;
#line 302 "../lib/ValaVisitor.vala"
	vala_lint_checks_ellipsis_check_check_string_literal (_tmp0_, lit, &self->mistake_list);
#line 303 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1157 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_template (ValaCodeVisitor* base,
                                       ValaTemplate* tmpl)
{
	ValaLintVisitor * self;
	ValaLintChecksUnnecessaryStringTemplateCheck* _tmp0_;
#line 306 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 306 "../lib/ValaVisitor.vala"
	g_return_if_fail (tmpl != NULL);
#line 307 "../lib/ValaVisitor.vala"
	_tmp0_ = self->unnecessary_string_template_check;
#line 307 "../lib/ValaVisitor.vala"
	vala_lint_checks_unnecessary_string_template_check_check_template (_tmp0_, tmpl, &self->mistake_list);
#line 308 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
#line 1176 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_tuple (ValaCodeVisitor* base,
                                    ValaTuple* tuple)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
#line 311 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 311 "../lib/ValaVisitor.vala"
	g_return_if_fail (tuple != NULL);
#line 312 "../lib/ValaVisitor.vala"
	_tmp0_ = self->no_space_check;
#line 312 "../lib/ValaVisitor.vala"
	_tmp1_ = vala_tuple_get_expressions (tuple);
#line 312 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
#line 314 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) tuple, (ValaCodeVisitor*) self);
#line 1198 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                           ValaNullLiteral* lit)
{
	ValaLintVisitor * self;
#line 317 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 317 "../lib/ValaVisitor.vala"
	g_return_if_fail (lit != NULL);
#line 318 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
#line 1212 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                            ValaMemberAccess* expr)
{
	ValaLintVisitor * self;
#line 321 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 321 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 322 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1226 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                          ValaMethodCall* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
#line 325 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 325 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 326 "../lib/ValaVisitor.vala"
	_tmp0_ = self->no_space_check;
#line 326 "../lib/ValaVisitor.vala"
	_tmp1_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) expr);
#line 326 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
#line 328 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1248 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                             ValaElementAccess* expr)
{
	ValaLintVisitor * self;
#line 331 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 331 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 332 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1262 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                               ValaSliceExpression* expr)
{
	ValaLintVisitor * self;
#line 335 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 335 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 336 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1276 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                          ValaBaseAccess* expr)
{
	ValaLintVisitor * self;
#line 339 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 339 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 340 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1290 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                 ValaPostfixExpression* expr)
{
	ValaLintVisitor * self;
#line 343 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 343 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 344 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1304 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                         ValaObjectCreationExpression* expr)
{
	ValaLintVisitor * self;
#line 347 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 347 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 348 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1318 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                ValaSizeofExpression* expr)
{
	ValaLintVisitor * self;
#line 351 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 351 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 352 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1332 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                ValaTypeofExpression* expr)
{
	ValaLintVisitor * self;
#line 355 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 355 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 356 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1346 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                               ValaUnaryExpression* expr)
{
	ValaLintVisitor * self;
#line 359 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 359 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 360 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1360 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                              ValaCastExpression* expr)
{
	ValaLintVisitor * self;
#line 363 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 363 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 364 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1374 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_named_argument (ValaCodeVisitor* base,
                                             ValaNamedArgument* expr)
{
	ValaLintVisitor * self;
#line 367 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 367 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 368 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1388 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                  ValaPointerIndirection* expr)
{
	ValaLintVisitor * self;
#line 371 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 371 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 372 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1402 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                   ValaAddressofExpression* expr)
{
	ValaLintVisitor * self;
#line 375 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 375 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 376 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1416 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                            ValaReferenceTransferExpression* expr)
{
	ValaLintVisitor * self;
#line 379 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 379 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 380 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1430 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                ValaBinaryExpression* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
#line 383 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 383 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 384 "../lib/ValaVisitor.vala"
	_tmp0_ = self->no_space_check;
#line 384 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_binary_expression (_tmp0_, expr, &self->mistake_list);
#line 386 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1449 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                         ValaTypeCheck* expr)
{
	ValaLintVisitor * self;
#line 389 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 389 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 390 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1463 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                     ValaConditionalExpression* expr)
{
	ValaLintVisitor * self;
#line 393 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 393 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 394 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1477 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                ValaLambdaExpression* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
#line 397 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 397 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 398 "../lib/ValaVisitor.vala"
	_tmp0_ = self->no_space_check;
#line 398 "../lib/ValaVisitor.vala"
	_tmp1_ = vala_lambda_expression_get_parameters (expr);
#line 398 "../lib/ValaVisitor.vala"
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
#line 400 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
#line 1499 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                         ValaAssignment* a)
{
	ValaLintVisitor * self;
#line 403 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 403 "../lib/ValaVisitor.vala"
	g_return_if_fail (a != NULL);
#line 404 "../lib/ValaVisitor.vala"
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
#line 1513 "ValaVisitor.c"
}

static void
vala_lint_visitor_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                  ValaExpression* expr)
{
	ValaLintVisitor * self;
#line 407 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) base;
#line 407 "../lib/ValaVisitor.vala"
	g_return_if_fail (expr != NULL);
#line 1525 "ValaVisitor.c"
}

ValaLintVisitor*
vala_lint_visitor_construct (GType object_type)
{
	ValaLintVisitor* self = NULL;
#line 20 "../lib/ValaVisitor.vala"
	self = (ValaLintVisitor*) vala_code_visitor_construct (object_type);
#line 20 "../lib/ValaVisitor.vala"
	return self;
#line 1536 "ValaVisitor.c"
}

ValaLintVisitor*
vala_lint_visitor_new (void)
{
#line 20 "../lib/ValaVisitor.vala"
	return vala_lint_visitor_construct (VALA_LINT_TYPE_VISITOR);
#line 1544 "ValaVisitor.c"
}

static void
vala_lint_visitor_class_init (ValaLintVisitorClass * klass,
                              gpointer klass_data)
{
#line 20 "../lib/ValaVisitor.vala"
	vala_lint_visitor_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->finalize = vala_lint_visitor_finalize;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vala_lint_visitor_real_visit_source_file;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) vala_lint_visitor_real_visit_namespace;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) vala_lint_visitor_real_visit_class;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) vala_lint_visitor_real_visit_struct;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) vala_lint_visitor_real_visit_interface;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor*, ValaEnum*)) vala_lint_visitor_real_visit_enum;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_enum_value = (void (*) (ValaCodeVisitor*, ValaEnumValue*)) vala_lint_visitor_real_visit_enum_value;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor*, ValaErrorDomain*)) vala_lint_visitor_real_visit_error_domain;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_error_code = (void (*) (ValaCodeVisitor*, ValaErrorCode*)) vala_lint_visitor_real_visit_error_code;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor*, ValaDelegate*)) vala_lint_visitor_real_visit_delegate;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor*, ValaConstant*)) vala_lint_visitor_real_visit_constant;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor*, ValaField*)) vala_lint_visitor_real_visit_field;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) vala_lint_visitor_real_visit_method;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) vala_lint_visitor_real_visit_creation_method;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor*, ValaParameter*)) vala_lint_visitor_real_visit_formal_parameter;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) vala_lint_visitor_real_visit_property;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) vala_lint_visitor_real_visit_property_accessor;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor*, ValaSignal*)) vala_lint_visitor_real_visit_signal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) vala_lint_visitor_real_visit_constructor;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) vala_lint_visitor_real_visit_destructor;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_type_parameter = (void (*) (ValaCodeVisitor*, ValaTypeParameter*)) vala_lint_visitor_real_visit_type_parameter;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor*, ValaUsingDirective*)) vala_lint_visitor_real_visit_using_directive;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) vala_lint_visitor_real_visit_data_type;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) vala_lint_visitor_real_visit_block;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_empty_statement = (void (*) (ValaCodeVisitor*, ValaEmptyStatement*)) vala_lint_visitor_real_visit_empty_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) vala_lint_visitor_real_visit_declaration_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) vala_lint_visitor_real_visit_local_variable;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor*, ValaInitializerList*)) vala_lint_visitor_real_visit_initializer_list;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) vala_lint_visitor_real_visit_expression_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) vala_lint_visitor_real_visit_if_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) vala_lint_visitor_real_visit_switch_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) vala_lint_visitor_real_visit_switch_section;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor*, ValaSwitchLabel*)) vala_lint_visitor_real_visit_switch_label;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_loop_statement = (void (*) (ValaCodeVisitor*, ValaLoopStatement*)) vala_lint_visitor_real_visit_loop_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor*, ValaWhileStatement*)) vala_lint_visitor_real_visit_while_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) vala_lint_visitor_real_visit_do_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) vala_lint_visitor_real_visit_for_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) vala_lint_visitor_real_visit_foreach_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_break_statement = (void (*) (ValaCodeVisitor*, ValaBreakStatement*)) vala_lint_visitor_real_visit_break_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_continue_statement = (void (*) (ValaCodeVisitor*, ValaContinueStatement*)) vala_lint_visitor_real_visit_continue_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor*, ValaReturnStatement*)) vala_lint_visitor_real_visit_return_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor*, ValaYieldStatement*)) vala_lint_visitor_real_visit_yield_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor*, ValaThrowStatement*)) vala_lint_visitor_real_visit_throw_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) vala_lint_visitor_real_visit_try_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) vala_lint_visitor_real_visit_catch_clause;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) vala_lint_visitor_real_visit_lock_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_unlock_statement = (void (*) (ValaCodeVisitor*, ValaUnlockStatement*)) vala_lint_visitor_real_visit_unlock_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_with_statement = (void (*) (ValaCodeVisitor*, ValaWithStatement*)) vala_lint_visitor_real_visit_with_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor*, ValaDeleteStatement*)) vala_lint_visitor_real_visit_delete_statement;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vala_lint_visitor_real_visit_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor*, ValaArrayCreationExpression*)) vala_lint_visitor_real_visit_array_creation_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_boolean_literal = (void (*) (ValaCodeVisitor*, ValaBooleanLiteral*)) vala_lint_visitor_real_visit_boolean_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_character_literal = (void (*) (ValaCodeVisitor*, ValaCharacterLiteral*)) vala_lint_visitor_real_visit_character_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_integer_literal = (void (*) (ValaCodeVisitor*, ValaIntegerLiteral*)) vala_lint_visitor_real_visit_integer_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_real_literal = (void (*) (ValaCodeVisitor*, ValaRealLiteral*)) vala_lint_visitor_real_visit_real_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_regex_literal = (void (*) (ValaCodeVisitor*, ValaRegexLiteral*)) vala_lint_visitor_real_visit_regex_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_string_literal = (void (*) (ValaCodeVisitor*, ValaStringLiteral*)) vala_lint_visitor_real_visit_string_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor*, ValaTemplate*)) vala_lint_visitor_real_visit_template;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_tuple = (void (*) (ValaCodeVisitor*, ValaTuple*)) vala_lint_visitor_real_visit_tuple;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_null_literal = (void (*) (ValaCodeVisitor*, ValaNullLiteral*)) vala_lint_visitor_real_visit_null_literal;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) vala_lint_visitor_real_visit_member_access;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) vala_lint_visitor_real_visit_method_call;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor*, ValaElementAccess*)) vala_lint_visitor_real_visit_element_access;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor*, ValaSliceExpression*)) vala_lint_visitor_real_visit_slice_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_base_access = (void (*) (ValaCodeVisitor*, ValaBaseAccess*)) vala_lint_visitor_real_visit_base_access;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor*, ValaPostfixExpression*)) vala_lint_visitor_real_visit_postfix_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) vala_lint_visitor_real_visit_object_creation_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor*, ValaSizeofExpression*)) vala_lint_visitor_real_visit_sizeof_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor*, ValaTypeofExpression*)) vala_lint_visitor_real_visit_typeof_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor*, ValaUnaryExpression*)) vala_lint_visitor_real_visit_unary_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor*, ValaCastExpression*)) vala_lint_visitor_real_visit_cast_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_named_argument = (void (*) (ValaCodeVisitor*, ValaNamedArgument*)) vala_lint_visitor_real_visit_named_argument;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_pointer_indirection = (void (*) (ValaCodeVisitor*, ValaPointerIndirection*)) vala_lint_visitor_real_visit_pointer_indirection;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor*, ValaAddressofExpression*)) vala_lint_visitor_real_visit_addressof_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor*, ValaReferenceTransferExpression*)) vala_lint_visitor_real_visit_reference_transfer_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor*, ValaBinaryExpression*)) vala_lint_visitor_real_visit_binary_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor*, ValaTypeCheck*)) vala_lint_visitor_real_visit_type_check;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor*, ValaConditionalExpression*)) vala_lint_visitor_real_visit_conditional_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor*, ValaLambdaExpression*)) vala_lint_visitor_real_visit_lambda_expression;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) vala_lint_visitor_real_visit_assignment;
#line 20 "../lib/ValaVisitor.vala"
	((ValaCodeVisitorClass *) klass)->visit_end_full_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vala_lint_visitor_real_visit_end_full_expression;
#line 1717 "ValaVisitor.c"
}

static void
vala_lint_visitor_instance_init (ValaLintVisitor * self,
                                 gpointer klass)
{
}

static void
vala_lint_visitor_finalize (ValaCodeVisitor * obj)
{
	ValaLintVisitor * self;
#line 20 "../lib/ValaVisitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_VISITOR, ValaLintVisitor);
#line 21 "../lib/ValaVisitor.vala"
	_vala_iterable_unref0 (self->mistake_list);
#line 23 "../lib/ValaVisitor.vala"
	_g_object_unref0 (self->double_semicolon_check);
#line 24 "../lib/ValaVisitor.vala"
	_g_object_unref0 (self->ellipsis_check);
#line 25 "../lib/ValaVisitor.vala"
	_g_object_unref0 (self->naming_convention_check);
#line 26 "../lib/ValaVisitor.vala"
	_g_object_unref0 (self->unnecessary_string_template_check);
#line 27 "../lib/ValaVisitor.vala"
	_g_object_unref0 (self->no_space_check);
#line 20 "../lib/ValaVisitor.vala"
	VALA_CODE_VISITOR_CLASS (vala_lint_visitor_parent_class)->finalize (obj);
#line 1746 "ValaVisitor.c"
}

static GType
vala_lint_visitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintVisitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_visitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintVisitor), 0, (GInstanceInitFunc) vala_lint_visitor_instance_init, NULL };
	GType vala_lint_visitor_type_id;
	vala_lint_visitor_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "ValaLintVisitor", &g_define_type_info, 0);
	return vala_lint_visitor_type_id;
}

GType
vala_lint_visitor_get_type (void)
{
	static volatile gsize vala_lint_visitor_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_visitor_type_id__once)) {
		GType vala_lint_visitor_type_id;
		vala_lint_visitor_type_id = vala_lint_visitor_get_type_once ();
		g_once_init_leave (&vala_lint_visitor_type_id__once, vala_lint_visitor_type_id);
	}
	return vala_lint_visitor_type_id__once;
}

