/* Application.c generated by valac 0.56.17, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#define _GNU_SOURCE

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <fnmatch.h>
#include <glib/gi18n-lib.h>
#include "vala-linter.h"
#include <glib/gstdio.h>
#include <valagee.h>
#include <glob.h>
#include <vala.h>
#include <json-glib/json-glib.h>

#define VALA_LINT_APPLICATION_VERSION "0.1"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VALA_LINT_TYPE_APPLICATION (vala_lint_application_get_type ())
#define VALA_LINT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplication))
#define VALA_LINT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))
#define VALA_LINT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))

typedef struct _ValaLintApplication ValaLintApplication;
typedef struct _ValaLintApplicationClass ValaLintApplicationClass;
typedef struct _ValaLintApplicationPrivate ValaLintApplicationPrivate;
enum  {
	VALA_LINT_APPLICATION_0_PROPERTY,
	VALA_LINT_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* vala_lint_application_properties[VALA_LINT_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define VALA_LINT_TYPE_FILE_DATA (vala_lint_file_data_get_type ())
typedef struct _ValaLintFileData ValaLintFileData;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_lint_file_data_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_file_data_free (var), NULL)))
#define __vala_ValaLintFormatMistake_free0(var) ((var == NULL) ? NULL : (var = (_vala_ValaLintFormatMistake_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

struct _ValaLintApplication {
	GApplication parent_instance;
	ValaLintApplicationPrivate * priv;
};

struct _ValaLintApplicationClass {
	GApplicationClass parent_class;
};

struct _ValaLintApplicationPrivate {
	GApplicationCommandLine* application_command_line;
};

struct _ValaLintFileData {
	GFile* file;
	gchar* name;
	ValaArrayList* mistakes;
};

static gint ValaLintApplication_private_offset;
static gpointer vala_lint_application_parent_class = NULL;
static gboolean vala_lint_application_print_version;
static gchar* vala_lint_application_lint_directory;
static gboolean vala_lint_application_print_mistakes_end;
static gchar* vala_lint_application_config_file;
static gboolean vala_lint_application_exit_with_zero;
static gboolean vala_lint_application_generate_config_file;
static gboolean vala_lint_application_auto_fix;
static gboolean vala_lint_application_json_output;
static gchar* vala_lint_application_lint_directory = NULL;
static gboolean vala_lint_application_print_version = FALSE;
static gboolean vala_lint_application_print_mistakes_end = FALSE;
static gboolean vala_lint_application_exit_with_zero = FALSE;
static gboolean vala_lint_application_generate_config_file = FALSE;
static gboolean vala_lint_application_auto_fix = FALSE;
static gboolean vala_lint_application_json_output = FALSE;
static gchar* vala_lint_application_config_file = NULL;
static gchar* vala_lint_application_ignore_pattern_list;
static gchar* vala_lint_application_ignore_pattern_list = NULL;
static gint vala_lint_application_fnmatch_flags;
static gint vala_lint_application_fnmatch_flags = (FNM_EXTMATCH | FNM_PERIOD) | FNM_PATHNAME;
static GFile* vala_lint_application_root_dir;
static GFile* vala_lint_application_root_dir = NULL;

VALA_EXTERN GType vala_lint_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ValaLintApplication, g_object_unref)
static ValaLintApplication* vala_lint_application_new (void);
static ValaLintApplication* vala_lint_application_construct (GType object_type);
static gint vala_lint_application_real_command_line (GApplication* base,
                                              GApplicationCommandLine* command_line);
static gint vala_lint_application_handle_command_line (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GType vala_lint_file_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ValaLintFileData* vala_lint_file_data_dup (const ValaLintFileData* self);
VALA_EXTERN void vala_lint_file_data_free (ValaLintFileData* self);
VALA_EXTERN void vala_lint_file_data_copy (const ValaLintFileData* self,
                               ValaLintFileData* dest);
VALA_EXTERN void vala_lint_file_data_destroy (ValaLintFileData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ValaLintFileData, vala_lint_file_data_destroy)
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static ValaArrayList* vala_lint_application_get_files (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line,
                                                gchar** patterns,
                                                gint patterns_length1,
                                                gchar** ignore_patterns,
                                                gint ignore_patterns_length1,
                                                GError** error);
static gboolean vala_lint_application_print_mistakes_json (ValaLintApplication* self,
                                                    ValaArrayList* file_data_list);
static gboolean vala_lint_application_print_mistakes (ValaLintApplication* self,
                                               ValaArrayList* file_data_list);
static void _vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self);
static ValaLintFormatMistake* _vala_lint_format_mistake_dup (ValaLintFormatMistake* self);
static ValaArrayList* vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                               GFile* dir,
                                                               GError** error);
static gchar* vala_lint_application_apply_color_for_state (ValaLintApplication* self,
                                                    const gchar* str,
                                                    ValaLintConfigState state);
static void _vala_JsonNode_free (JsonNode* self);
static gint vala_lint_application_main (gchar** args,
                                 gint args_length1);
static void vala_lint_application_finalize (GObject * obj);
static GType vala_lint_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GOptionEntry VALA_LINT_APPLICATION_OPTIONS[9] = {{"version", 'v', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_print_version, "Display version number."}, {"directory", 'd', (gint) G_OPTION_FLAG_HIDDEN, G_OPTION_ARG_STRING, &vala_lint_application_lint_directory, "Lint all Vala files in the given directory. (DEPRECEATED)"}, {"print-end", 'e', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_print_mistakes_end, "Show end of mistakes."}, {"config", 'c', (gint) 0, G_OPTION_ARG_STRING, &vala_lint_application_config_file, "Specify a configuration file."}, {"exit-zero", 'z', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_exit_with_zero, "Always return a 0 (non-error) status code, even if lint errors are fou" \
"nd."}, {"generate-config", 'g', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_generate_config_file, "Generate a sample configuration file with default values."}, {"fix", 'f', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_auto_fix, "Fix any auto-fixable mistakes."}, {"json-output", 'j', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_json_output, "Output in JSON format."}, {NULL}};

static inline gpointer
vala_lint_application_get_instance_private (ValaLintApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintApplication_private_offset);
}

static ValaLintApplication*
vala_lint_application_construct (GType object_type)
{
	ValaLintApplication * self = NULL;
#line 60 "../src/Application.vala"
	self = (ValaLintApplication*) g_object_new (object_type, "application-id", "io.elementary.vala-lint", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 59 "../src/Application.vala"
	return self;
#line 206 "Application.c"
}

static ValaLintApplication*
vala_lint_application_new (void)
{
#line 59 "../src/Application.vala"
	return vala_lint_application_construct (VALA_LINT_TYPE_APPLICATION);
#line 214 "Application.c"
}

static gint
vala_lint_application_real_command_line (GApplication* base,
                                         GApplicationCommandLine* command_line)
{
	ValaLintApplication * self;
	gint res = 0;
	gint result;
#line 66 "../src/Application.vala"
	self = (ValaLintApplication*) base;
#line 66 "../src/Application.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 67 "../src/Application.vala"
	g_application_hold ((GApplication*) self);
#line 69 "../src/Application.vala"
	res = vala_lint_application_handle_command_line (self, command_line);
#line 71 "../src/Application.vala"
	g_application_release ((GApplication*) self);
#line 72 "../src/Application.vala"
	result = res;
#line 72 "../src/Application.vala"
	return result;
#line 238 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 246 "Application.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 273 "Application.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 279 "Application.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 285 "Application.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 289 "Application.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 297 "Application.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 301 "Application.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 313 "Application.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 170 "../src/Application.vala"
	if ((*length) == (*size)) {
#line 170 "../src/Application.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 170 "../src/Application.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 328 "Application.c"
	}
#line 170 "../src/Application.vala"
	(*array)[(*length)++] = value;
#line 170 "../src/Application.vala"
	(*array)[*length] = NULL;
#line 334 "Application.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 180 "../src/Application.vala"
	if (length >= 0) {
#line 343 "Application.c"
		gchar** result;
		gssize i;
#line 180 "../src/Application.vala"
		result = g_new0 (gchar*, length + 1);
#line 180 "../src/Application.vala"
		for (i = 0; i < length; i++) {
#line 350 "Application.c"
			gchar* _tmp0_;
#line 180 "../src/Application.vala"
			_tmp0_ = g_strdup (self[i]);
#line 180 "../src/Application.vala"
			result[i] = _tmp0_;
#line 356 "Application.c"
		}
#line 180 "../src/Application.vala"
		return result;
#line 360 "Application.c"
	}
#line 180 "../src/Application.vala"
	return NULL;
#line 364 "Application.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 182 "../src/Application.vala"
	if ((*length) == (*size)) {
#line 182 "../src/Application.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 182 "../src/Application.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 379 "Application.c"
	}
#line 182 "../src/Application.vala"
	(*array)[(*length)++] = value;
#line 182 "../src/Application.vala"
	(*array)[*length] = NULL;
#line 385 "Application.c"
}

static void
_vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self)
{
#line 225 "../src/Application.vala"
	vala_lint_format_mistake_destroy (self);
#line 225 "../src/Application.vala"
	g_free (self);
#line 395 "Application.c"
}

static gint
vala_lint_application_handle_command_line (ValaLintApplication* self,
                                           GApplicationCommandLine* command_line)
{
	gchar** args = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** tmp = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint tmp_length1;
	gint _tmp_size_;
	GApplicationCommandLine* _tmp29_;
	gchar** ignore_patterns = NULL;
	gchar** _tmp30_;
	gint ignore_patterns_length1;
	gint _ignore_patterns_size_;
	const gchar* _tmp31_ = NULL;
	const gchar* _tmp32_;
	gchar* ignore_root = NULL;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp41_;
	gchar* ignore_filepath = NULL;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* fallback_path = NULL;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp55_;
	gchar* contents = NULL;
	gsize size = 0UL;
	ValaArrayList* file_data_list = NULL;
	GEqualFunc _tmp94_;
	ValaArrayList* _tmp95_;
	const gchar* _tmp112_;
	ValaLintLinter* linter = NULL;
	ValaLintLinter* _tmp113_;
	ValaLintFixer* fixer = NULL;
	ValaLintFixer* _tmp114_;
	gboolean has_errors = FALSE;
	gboolean _tmp148_ = FALSE;
	GError* _inner_error0_ = NULL;
	gint result;
#line 75 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../src/Application.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 76 "../src/Application.vala"
	_tmp1_ = g_application_command_line_get_arguments (command_line, &_tmp0_);
#line 76 "../src/Application.vala"
	args = _tmp1_;
#line 76 "../src/Application.vala"
	args_length1 = _tmp0_;
#line 76 "../src/Application.vala"
	_args_size_ = args_length1;
#line 78 "../src/Application.vala"
	_tmp2_ = args;
#line 78 "../src/Application.vala"
	_tmp2__length1 = args_length1;
#line 78 "../src/Application.vala"
	if (_tmp2__length1 == 1) {
#line 465 "Application.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar** _tmp7_;
#line 79 "../src/Application.vala"
		_tmp3_ = args;
#line 79 "../src/Application.vala"
		_tmp3__length1 = args_length1;
#line 79 "../src/Application.vala"
		_tmp4_ = _tmp3_[0];
#line 79 "../src/Application.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 79 "../src/Application.vala"
		_tmp6_ = g_strdup (".");
#line 79 "../src/Application.vala"
		_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 79 "../src/Application.vala"
		_tmp7_[0] = _tmp5_;
#line 79 "../src/Application.vala"
		_tmp7_[1] = _tmp6_;
#line 79 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/Application.vala"
		args = _tmp7_;
#line 79 "../src/Application.vala"
		args_length1 = 2;
#line 79 "../src/Application.vala"
		_args_size_ = args_length1;
#line 496 "Application.c"
	}
#line 82 "../src/Application.vala"
	_tmp8_ = args;
#line 82 "../src/Application.vala"
	_tmp8__length1 = args_length1;
#line 82 "../src/Application.vala"
	tmp = _tmp8_;
#line 82 "../src/Application.vala"
	tmp_length1 = _tmp8__length1;
#line 82 "../src/Application.vala"
	_tmp_size_ = tmp_length1;
#line 508 "Application.c"
	{
		GOptionContext* option_context = NULL;
		GOptionContext* _tmp9_;
		GOptionContext* _tmp10_;
		GOptionContext* _tmp11_;
		GOptionContext* _tmp12_;
#line 85 "../src/Application.vala"
		_tmp9_ = g_option_context_new ("- Vala-Lint");
#line 85 "../src/Application.vala"
		option_context = _tmp9_;
#line 86 "../src/Application.vala"
		_tmp10_ = option_context;
#line 86 "../src/Application.vala"
		g_option_context_set_help_enabled (_tmp10_, TRUE);
#line 87 "../src/Application.vala"
		_tmp11_ = option_context;
#line 87 "../src/Application.vala"
		g_option_context_add_main_entries (_tmp11_, VALA_LINT_APPLICATION_OPTIONS, NULL);
#line 89 "../src/Application.vala"
		_tmp12_ = option_context;
#line 89 "../src/Application.vala"
		g_option_context_parse (_tmp12_, (gint*) (&tmp_length1), &tmp, &_inner_error0_);
#line 89 "../src/Application.vala"
		_tmp_size_ = tmp_length1;
#line 89 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 535 "Application.c"
			gint _tmp13_ = -1;
#line 89 "../src/Application.vala"
			_g_option_context_free0 (option_context);
#line 89 "../src/Application.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 541 "Application.c"
				goto __catch0_g_option_error;
			}
#line 89 "../src/Application.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/Application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/Application.vala"
			g_clear_error (&_inner_error0_);
#line 89 "../src/Application.vala"
			return _tmp13_;
#line 552 "Application.c"
		}
#line 84 "../src/Application.vala"
		_g_option_context_free0 (option_context);
#line 556 "Application.c"
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
#line 84 "../src/Application.vala"
		e = _inner_error0_;
#line 84 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 91 "../src/Application.vala"
		_tmp14_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
#line 91 "../src/Application.vala"
		_tmp15_ = _tmp14_;
#line 91 "../src/Application.vala"
		_tmp16_ = e;
#line 91 "../src/Application.vala"
		_tmp17_ = _tmp16_->message;
#line 91 "../src/Application.vala"
		g_application_command_line_print (command_line, _tmp15_, _tmp17_);
#line 91 "../src/Application.vala"
		_g_free0 (_tmp15_);
#line 92 "../src/Application.vala"
		_tmp18_ = g_strconcat (_ ("Run '%s --help' to see a full list of available options."), "\n", NULL);
#line 92 "../src/Application.vala"
		_tmp19_ = _tmp18_;
#line 92 "../src/Application.vala"
		_tmp20_ = args;
#line 92 "../src/Application.vala"
		_tmp20__length1 = args_length1;
#line 92 "../src/Application.vala"
		_tmp21_ = _tmp20_[0];
#line 92 "../src/Application.vala"
		g_application_command_line_print (command_line, _tmp19_, _tmp21_);
#line 92 "../src/Application.vala"
		_g_free0 (_tmp19_);
#line 93 "../src/Application.vala"
		result = 1;
#line 93 "../src/Application.vala"
		_g_error_free0 (e);
#line 93 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 93 "../src/Application.vala"
		return result;
#line 609 "Application.c"
	}
	__finally0:
#line 84 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "Application.c"
		gint _tmp22_ = -1;
#line 84 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 84 "../src/Application.vala"
		return _tmp22_;
#line 624 "Application.c"
	}
#line 96 "../src/Application.vala"
	if (vala_lint_application_print_version) {
#line 628 "Application.c"
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 97 "../src/Application.vala"
		_tmp23_ = g_strconcat (_ ("Version: %s"), "\n", NULL);
#line 97 "../src/Application.vala"
		_tmp24_ = _tmp23_;
#line 97 "../src/Application.vala"
		g_application_command_line_print (command_line, _tmp24_, VALA_LINT_APPLICATION_VERSION);
#line 97 "../src/Application.vala"
		_g_free0 (_tmp24_);
#line 98 "../src/Application.vala"
		result = 0;
#line 98 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/Application.vala"
		return result;
#line 645 "Application.c"
	}
#line 101 "../src/Application.vala"
	if (vala_lint_application_generate_config_file) {
#line 649 "Application.c"
		GKeyFile* default_config = NULL;
		GKeyFile* _tmp25_;
		GKeyFile* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 102 "../src/Application.vala"
		_tmp25_ = vala_lint_config_get_default_config ();
#line 102 "../src/Application.vala"
		default_config = _tmp25_;
#line 103 "../src/Application.vala"
		_tmp26_ = default_config;
#line 103 "../src/Application.vala"
		_tmp27_ = g_key_file_to_data (_tmp26_, NULL, NULL);
#line 103 "../src/Application.vala"
		_tmp28_ = _tmp27_;
#line 103 "../src/Application.vala"
		g_application_command_line_print (command_line, "%s", _tmp28_);
#line 103 "../src/Application.vala"
		_g_free0 (_tmp28_);
#line 104 "../src/Application.vala"
		result = 0;
#line 104 "../src/Application.vala"
		_g_key_file_unref0 (default_config);
#line 104 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/Application.vala"
		return result;
#line 677 "Application.c"
	}
#line 107 "../src/Application.vala"
	_tmp29_ = _g_object_ref0 (command_line);
#line 107 "../src/Application.vala"
	_g_object_unref0 (self->priv->application_command_line);
#line 107 "../src/Application.vala"
	self->priv->application_command_line = _tmp29_;
#line 109 "../src/Application.vala"
	_tmp30_ = g_new0 (gchar*, 0 + 1);
#line 109 "../src/Application.vala"
	ignore_patterns = _tmp30_;
#line 109 "../src/Application.vala"
	ignore_patterns_length1 = 0;
#line 109 "../src/Application.vala"
	_ignore_patterns_size_ = ignore_patterns_length1;
#line 110 "../src/Application.vala"
	_tmp32_ = vala_lint_application_lint_directory;
#line 110 "../src/Application.vala"
	if (_tmp32_ != NULL) {
#line 697 "Application.c"
		const gchar* _tmp33_;
#line 110 "../src/Application.vala"
		_tmp33_ = vala_lint_application_lint_directory;
#line 110 "../src/Application.vala"
		_tmp31_ = _tmp33_;
#line 703 "Application.c"
	} else {
		gchar** _tmp34_;
		gint _tmp34__length1;
		const gchar* _tmp35_;
#line 110 "../src/Application.vala"
		_tmp34_ = args;
#line 110 "../src/Application.vala"
		_tmp34__length1 = args_length1;
#line 110 "../src/Application.vala"
		_tmp35_ = _tmp34_[1];
#line 110 "../src/Application.vala"
		_tmp31_ = _tmp35_;
#line 716 "Application.c"
	}
#line 110 "../src/Application.vala"
	_tmp36_ = g_strdup (_tmp31_);
#line 110 "../src/Application.vala"
	ignore_root = _tmp36_;
#line 111 "../src/Application.vala"
	_tmp37_ = ignore_root;
#line 111 "../src/Application.vala"
	if (_tmp37_ == NULL) {
#line 726 "Application.c"
		gchar** _tmp38_;
		gint _tmp38__length1;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 112 "../src/Application.vala"
		_tmp38_ = tmp;
#line 112 "../src/Application.vala"
		_tmp38__length1 = tmp_length1;
#line 112 "../src/Application.vala"
		_tmp39_ = g_strdup (".");
#line 112 "../src/Application.vala"
		_g_free0 (_tmp38_[1]);
#line 112 "../src/Application.vala"
		_tmp38_[1] = _tmp39_;
#line 112 "../src/Application.vala"
		_tmp40_ = g_strdup (_tmp38_[1]);
#line 112 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 112 "../src/Application.vala"
		ignore_root = _tmp40_;
#line 113 "../src/Application.vala"
		tmp_length1 = tmp_length1 + 1;
#line 749 "Application.c"
	}
#line 115 "../src/Application.vala"
	_tmp41_ = ignore_root;
#line 115 "../src/Application.vala"
	if (g_str_has_suffix (_tmp41_, G_DIR_SEPARATOR_S)) {
#line 755 "Application.c"
		const gchar* _tmp42_;
		gchar* _tmp43_;
#line 116 "../src/Application.vala"
		_tmp42_ = ignore_root;
#line 116 "../src/Application.vala"
		_tmp43_ = string_slice (_tmp42_, (glong) 0, (glong) -1);
#line 116 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 116 "../src/Application.vala"
		ignore_root = _tmp43_;
#line 766 "Application.c"
	}
#line 119 "../src/Application.vala"
	_tmp44_ = ignore_root;
#line 119 "../src/Application.vala"
	_tmp45_ = g_build_filename (_tmp44_, ".valalintignore", NULL);
#line 119 "../src/Application.vala"
	ignore_filepath = _tmp45_;
#line 123 "../src/Application.vala"
	_tmp46_ = g_get_home_dir ();
#line 123 "../src/Application.vala"
	_tmp47_ = g_build_filename (_tmp46_, ".valalintignore", NULL);
#line 123 "../src/Application.vala"
	fallback_path = _tmp47_;
#line 127 "../src/Application.vala"
	_tmp48_ = ignore_filepath;
#line 127 "../src/Application.vala"
	if (!g_path_is_absolute (_tmp48_)) {
#line 784 "Application.c"
		GFile* ignore_file = NULL;
		const gchar* _tmp49_;
		GApplicationCommandLine* _tmp50_;
		const gchar* _tmp51_;
		GFile* _tmp52_;
		GFile* _tmp53_;
		gchar* _tmp54_;
#line 128 "../src/Application.vala"
		_tmp49_ = ignore_filepath;
#line 128 "../src/Application.vala"
		_tmp50_ = self->priv->application_command_line;
#line 128 "../src/Application.vala"
		_tmp51_ = g_application_command_line_get_cwd (_tmp50_);
#line 128 "../src/Application.vala"
		_tmp52_ = g_file_new_for_commandline_arg_and_cwd (_tmp49_, _tmp51_);
#line 128 "../src/Application.vala"
		ignore_file = _tmp52_;
#line 132 "../src/Application.vala"
		_tmp53_ = ignore_file;
#line 132 "../src/Application.vala"
		_tmp54_ = g_file_get_path (_tmp53_);
#line 132 "../src/Application.vala"
		_g_free0 (ignore_filepath);
#line 132 "../src/Application.vala"
		ignore_filepath = _tmp54_;
#line 127 "../src/Application.vala"
		_g_object_unref0 (ignore_file);
#line 812 "Application.c"
	}
#line 135 "../src/Application.vala"
	_tmp55_ = ignore_filepath;
#line 135 "../src/Application.vala"
	g_debug ("Application.vala:135: Absolute ignore file path %s", _tmp55_);
#line 138 "../src/Application.vala"
	size = (gsize) 0;
#line 820 "Application.c"
	{
		const gchar* _tmp56_;
		gchar* _tmp57_ = NULL;
		gsize _tmp58_ = 0UL;
#line 140 "../src/Application.vala"
		_tmp56_ = ignore_filepath;
#line 140 "../src/Application.vala"
		g_file_get_contents (_tmp56_, &_tmp57_, &_tmp58_, &_inner_error0_);
#line 140 "../src/Application.vala"
		_g_free0 (contents);
#line 140 "../src/Application.vala"
		contents = _tmp57_;
#line 140 "../src/Application.vala"
		size = _tmp58_;
#line 140 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 837 "Application.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
#line 139 "../src/Application.vala"
		e = _inner_error0_;
#line 139 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 142 "../src/Application.vala"
		_tmp59_ = e;
#line 142 "../src/Application.vala"
		_tmp60_ = _tmp59_->message;
#line 142 "../src/Application.vala"
		g_debug ("Application.vala:142: Error loading ignore file contents: %s", _tmp60_);
#line 143 "../src/Application.vala"
		_tmp61_ = g_strdup ("");
#line 143 "../src/Application.vala"
		_g_free0 (contents);
#line 143 "../src/Application.vala"
		contents = _tmp61_;
#line 144 "../src/Application.vala"
		size = (gsize) 0;
#line 139 "../src/Application.vala"
		_g_error_free0 (e);
#line 868 "Application.c"
	}
	__finally1:
#line 139 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 873 "Application.c"
		gint _tmp62_ = -1;
#line 139 "../src/Application.vala"
		_g_free0 (contents);
#line 139 "../src/Application.vala"
		_g_free0 (fallback_path);
#line 139 "../src/Application.vala"
		_g_free0 (ignore_filepath);
#line 139 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 139 "../src/Application.vala"
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 139 "../src/Application.vala"
		return _tmp62_;
#line 893 "Application.c"
	}
#line 147 "../src/Application.vala"
	if (size == ((gsize) 0)) {
#line 897 "Application.c"
		{
			const gchar* _tmp63_;
			gchar* _tmp64_ = NULL;
			gsize _tmp65_ = 0UL;
#line 149 "../src/Application.vala"
			_tmp63_ = fallback_path;
#line 149 "../src/Application.vala"
			g_file_get_contents (_tmp63_, &_tmp64_, &_tmp65_, &_inner_error0_);
#line 149 "../src/Application.vala"
			_g_free0 (contents);
#line 149 "../src/Application.vala"
			contents = _tmp64_;
#line 149 "../src/Application.vala"
			size = _tmp65_;
#line 149 "../src/Application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 914 "Application.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp66_;
			const gchar* _tmp67_;
			gchar* _tmp68_;
#line 148 "../src/Application.vala"
			e = _inner_error0_;
#line 148 "../src/Application.vala"
			_inner_error0_ = NULL;
#line 151 "../src/Application.vala"
			_tmp66_ = e;
#line 151 "../src/Application.vala"
			_tmp67_ = _tmp66_->message;
#line 151 "../src/Application.vala"
			g_debug ("Application.vala:151: Error loading ignore file contents: %s", _tmp67_);
#line 152 "../src/Application.vala"
			_tmp68_ = g_strdup ("");
#line 152 "../src/Application.vala"
			_g_free0 (contents);
#line 152 "../src/Application.vala"
			contents = _tmp68_;
#line 153 "../src/Application.vala"
			size = (gsize) 0;
#line 148 "../src/Application.vala"
			_g_error_free0 (e);
#line 945 "Application.c"
		}
		__finally2:
#line 148 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 950 "Application.c"
			gint _tmp69_ = -1;
#line 148 "../src/Application.vala"
			_g_free0 (contents);
#line 148 "../src/Application.vala"
			_g_free0 (fallback_path);
#line 148 "../src/Application.vala"
			_g_free0 (ignore_filepath);
#line 148 "../src/Application.vala"
			_g_free0 (ignore_root);
#line 148 "../src/Application.vala"
			ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../src/Application.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../src/Application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/Application.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/Application.vala"
			return _tmp69_;
#line 970 "Application.c"
		}
	}
#line 158 "../src/Application.vala"
	if (size > ((gsize) 10000UL)) {
#line 975 "Application.c"
		gchar* _tmp70_;
		gchar* _tmp71_;
		const gchar* _tmp72_;
#line 160 "../src/Application.vala"
		_tmp70_ = g_strconcat (_ ("%s is too large and will not be used."), "\n", NULL);
#line 160 "../src/Application.vala"
		_tmp71_ = _tmp70_;
#line 160 "../src/Application.vala"
		_tmp72_ = ignore_filepath;
#line 160 "../src/Application.vala"
		g_application_command_line_print (command_line, _tmp71_, _tmp72_);
#line 160 "../src/Application.vala"
		_g_free0 (_tmp71_);
#line 989 "Application.c"
	} else {
#line 161 "../src/Application.vala"
		if (size > ((gsize) 0)) {
#line 993 "Application.c"
			gchar** ignore_split = NULL;
			const gchar* _tmp73_;
			gchar** _tmp74_;
			gchar** _tmp75_;
			gint ignore_split_length1;
			gint _ignore_split_size_;
			gchar** _tmp76_;
			gint _tmp76__length1;
#line 162 "../src/Application.vala"
			_tmp73_ = contents;
#line 162 "../src/Application.vala"
			_tmp75_ = _tmp74_ = g_strsplit (_tmp73_, "\n", -1);
#line 162 "../src/Application.vala"
			ignore_split = _tmp75_;
#line 162 "../src/Application.vala"
			ignore_split_length1 = _vala_array_length (_tmp74_);
#line 162 "../src/Application.vala"
			_ignore_split_size_ = ignore_split_length1;
#line 163 "../src/Application.vala"
			_tmp76_ = ignore_split;
#line 163 "../src/Application.vala"
			_tmp76__length1 = ignore_split_length1;
#line 1016 "Application.c"
			{
				gchar** ignore_collection = NULL;
				gint ignore_collection_length1 = 0;
				gint _ignore_collection_size_ = 0;
				gint ignore_it = 0;
#line 163 "../src/Application.vala"
				ignore_collection = _tmp76_;
#line 163 "../src/Application.vala"
				ignore_collection_length1 = _tmp76__length1;
#line 163 "../src/Application.vala"
				for (ignore_it = 0; ignore_it < ignore_collection_length1; ignore_it = ignore_it + 1) {
#line 1028 "Application.c"
					gchar* _tmp77_;
					gchar* ignore = NULL;
#line 163 "../src/Application.vala"
					_tmp77_ = g_strdup (ignore_collection[ignore_it]);
#line 163 "../src/Application.vala"
					ignore = _tmp77_;
#line 1035 "Application.c"
					{
						gboolean _tmp78_ = FALSE;
						const gchar* _tmp79_;
#line 164 "../src/Application.vala"
						_tmp79_ = ignore;
#line 164 "../src/Application.vala"
						if (g_strcmp0 (_tmp79_, "") != 0) {
#line 1043 "Application.c"
							const gchar* _tmp80_;
							gint _tmp81_;
							gint _tmp82_;
#line 164 "../src/Application.vala"
							_tmp80_ = ignore;
#line 164 "../src/Application.vala"
							_tmp81_ = strlen (_tmp80_);
#line 164 "../src/Application.vala"
							_tmp82_ = _tmp81_;
#line 164 "../src/Application.vala"
							_tmp78_ = _tmp82_ <= 255;
#line 1055 "Application.c"
						} else {
#line 164 "../src/Application.vala"
							_tmp78_ = FALSE;
#line 1059 "Application.c"
						}
#line 164 "../src/Application.vala"
						if (_tmp78_) {
#line 1063 "Application.c"
							const gchar* _tmp83_;
							const gchar* _tmp86_;
							gchar* _tmp87_;
#line 166 "../src/Application.vala"
							_tmp83_ = ignore;
#line 166 "../src/Application.vala"
							if (g_str_has_suffix (_tmp83_, G_DIR_SEPARATOR_S)) {
#line 1071 "Application.c"
								const gchar* _tmp84_;
								gchar* _tmp85_;
#line 167 "../src/Application.vala"
								_tmp84_ = ignore;
#line 167 "../src/Application.vala"
								_tmp85_ = string_slice (_tmp84_, (glong) 0, (glong) -1);
#line 167 "../src/Application.vala"
								_g_free0 (ignore);
#line 167 "../src/Application.vala"
								ignore = _tmp85_;
#line 1082 "Application.c"
							}
#line 170 "../src/Application.vala"
							_tmp86_ = ignore;
#line 170 "../src/Application.vala"
							_tmp87_ = g_strdup (_tmp86_);
#line 170 "../src/Application.vala"
							_vala_array_add1 (&ignore_patterns, &ignore_patterns_length1, &_ignore_patterns_size_, _tmp87_);
#line 1090 "Application.c"
						} else {
							const gchar* _tmp88_;
							gint _tmp89_;
							gint _tmp90_;
#line 171 "../src/Application.vala"
							_tmp88_ = ignore;
#line 171 "../src/Application.vala"
							_tmp89_ = strlen (_tmp88_);
#line 171 "../src/Application.vala"
							_tmp90_ = _tmp89_;
#line 171 "../src/Application.vala"
							if (_tmp90_ > 255) {
#line 1103 "Application.c"
								gchar* _tmp91_;
								gchar* _tmp92_;
								const gchar* _tmp93_;
#line 172 "../src/Application.vala"
								_tmp91_ = g_strconcat (_ ("The pattern %s is too long and will not be used."), "\n", NULL);
#line 172 "../src/Application.vala"
								_tmp92_ = _tmp91_;
#line 172 "../src/Application.vala"
								_tmp93_ = ignore;
#line 172 "../src/Application.vala"
								g_application_command_line_print (command_line, _tmp92_, _tmp93_);
#line 172 "../src/Application.vala"
								_g_free0 (_tmp92_);
#line 1117 "Application.c"
							}
						}
#line 163 "../src/Application.vala"
						_g_free0 (ignore);
#line 1122 "Application.c"
					}
				}
			}
#line 161 "../src/Application.vala"
			ignore_split = (_vala_array_free (ignore_split, ignore_split_length1, (GDestroyNotify) g_free), NULL);
#line 1128 "Application.c"
		}
	}
#line 178 "../src/Application.vala"
	_tmp94_ = g_direct_equal;
#line 178 "../src/Application.vala"
	_tmp95_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp94_);
#line 178 "../src/Application.vala"
	file_data_list = _tmp95_;
#line 1137 "Application.c"
	{
		gchar** file_name_list = NULL;
		gchar** _tmp96_;
		gint _tmp96__length1;
		gchar** _tmp97_;
		gint _tmp97__length1;
		gchar** _tmp98_;
		gint _tmp98__length1;
		gint file_name_list_length1;
		gint _file_name_list_size_;
		const gchar* _tmp99_;
		ValaArrayList* _tmp102_ = NULL;
		gchar** _tmp103_;
		gint _tmp103__length1;
		gchar** _tmp104_;
		gint _tmp104__length1;
		ValaArrayList* _tmp105_;
		ValaArrayList* _tmp106_;
#line 180 "../src/Application.vala"
		_tmp96_ = tmp;
#line 180 "../src/Application.vala"
		_tmp96__length1 = tmp_length1;
#line 180 "../src/Application.vala"
		_tmp97_ = tmp;
#line 180 "../src/Application.vala"
		_tmp97__length1 = tmp_length1;
#line 180 "../src/Application.vala"
		_tmp98_ = (_tmp96_ != NULL) ? _vala_array_dup1 (_tmp96_ + 1, _tmp97__length1 - 1) : _tmp96_;
#line 180 "../src/Application.vala"
		_tmp98__length1 = _tmp97__length1 - 1;
#line 180 "../src/Application.vala"
		file_name_list = _tmp98_;
#line 180 "../src/Application.vala"
		file_name_list_length1 = _tmp98__length1;
#line 180 "../src/Application.vala"
		_file_name_list_size_ = file_name_list_length1;
#line 181 "../src/Application.vala"
		_tmp99_ = vala_lint_application_lint_directory;
#line 181 "../src/Application.vala"
		if (_tmp99_ != NULL) {
#line 1178 "Application.c"
			const gchar* _tmp100_;
			gchar* _tmp101_;
#line 182 "../src/Application.vala"
			_tmp100_ = vala_lint_application_lint_directory;
#line 182 "../src/Application.vala"
			_tmp101_ = g_strdup (_tmp100_);
#line 182 "../src/Application.vala"
			_vala_array_add2 (&file_name_list, &file_name_list_length1, &_file_name_list_size_, _tmp101_);
#line 1187 "Application.c"
		}
#line 185 "../src/Application.vala"
		_tmp103_ = file_name_list;
#line 185 "../src/Application.vala"
		_tmp103__length1 = file_name_list_length1;
#line 185 "../src/Application.vala"
		_tmp104_ = ignore_patterns;
#line 185 "../src/Application.vala"
		_tmp104__length1 = ignore_patterns_length1;
#line 185 "../src/Application.vala"
		_tmp105_ = vala_lint_application_get_files (self, command_line, _tmp103_, (gint) _tmp103__length1, _tmp104_, (gint) _tmp104__length1, &_inner_error0_);
#line 185 "../src/Application.vala"
		_tmp102_ = _tmp105_;
#line 185 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/Application.vala"
			file_name_list = (_vala_array_free (file_name_list, file_name_list_length1, (GDestroyNotify) g_free), NULL);
#line 1205 "Application.c"
			goto __catch3_g_error;
		}
#line 185 "../src/Application.vala"
		_tmp106_ = _tmp102_;
#line 185 "../src/Application.vala"
		_tmp102_ = NULL;
#line 185 "../src/Application.vala"
		_vala_iterable_unref0 (file_data_list);
#line 185 "../src/Application.vala"
		file_data_list = _tmp106_;
#line 179 "../src/Application.vala"
		_vala_iterable_unref0 (_tmp102_);
#line 179 "../src/Application.vala"
		file_name_list = (_vala_array_free (file_name_list, file_name_list_length1, (GDestroyNotify) g_free), NULL);
#line 1220 "Application.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		gchar* _tmp107_;
		gchar* _tmp108_;
		GError* _tmp109_;
		const gchar* _tmp110_;
#line 179 "../src/Application.vala"
		e = _inner_error0_;
#line 179 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 187 "../src/Application.vala"
		_tmp107_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
#line 187 "../src/Application.vala"
		_tmp108_ = _tmp107_;
#line 187 "../src/Application.vala"
		_tmp109_ = e;
#line 187 "../src/Application.vala"
		_tmp110_ = _tmp109_->message;
#line 187 "../src/Application.vala"
		g_critical (_tmp108_, _tmp110_);
#line 187 "../src/Application.vala"
		_g_free0 (_tmp108_);
#line 179 "../src/Application.vala"
		_g_error_free0 (e);
#line 1248 "Application.c"
	}
	__finally3:
#line 179 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1253 "Application.c"
		gint _tmp111_ = -1;
#line 179 "../src/Application.vala"
		_vala_iterable_unref0 (file_data_list);
#line 179 "../src/Application.vala"
		_g_free0 (contents);
#line 179 "../src/Application.vala"
		_g_free0 (fallback_path);
#line 179 "../src/Application.vala"
		_g_free0 (ignore_filepath);
#line 179 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 179 "../src/Application.vala"
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 179 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 179 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 179 "../src/Application.vala"
		return _tmp111_;
#line 1275 "Application.c"
	}
#line 191 "../src/Application.vala"
	_tmp112_ = vala_lint_application_config_file;
#line 191 "../src/Application.vala"
	vala_lint_config_load_file (_tmp112_);
#line 194 "../src/Application.vala"
	_tmp113_ = vala_lint_linter_new ();
#line 194 "../src/Application.vala"
	linter = _tmp113_;
#line 195 "../src/Application.vala"
	_tmp114_ = vala_lint_fixer_new ();
#line 195 "../src/Application.vala"
	fixer = _tmp114_;
#line 1289 "Application.c"
	{
		ValaArrayList* _data_list = NULL;
		ValaArrayList* _tmp115_;
		gint _data_size = 0;
		ValaArrayList* _tmp116_;
		gint _tmp117_;
		gint _tmp118_;
		gint _data_index = 0;
#line 196 "../src/Application.vala"
		_tmp115_ = file_data_list;
#line 196 "../src/Application.vala"
		_data_list = _tmp115_;
#line 196 "../src/Application.vala"
		_tmp116_ = _data_list;
#line 196 "../src/Application.vala"
		_tmp117_ = vala_collection_get_size ((ValaCollection*) _tmp116_);
#line 196 "../src/Application.vala"
		_tmp118_ = _tmp117_;
#line 196 "../src/Application.vala"
		_data_size = _tmp118_;
#line 196 "../src/Application.vala"
		_data_index = -1;
#line 196 "../src/Application.vala"
		while (TRUE) {
#line 1314 "Application.c"
			gint _tmp119_;
			gint _tmp120_;
			ValaLintFileData data = {0};
			ValaArrayList* _tmp121_;
			gpointer _tmp122_;
			ValaLintFileData* _tmp123_;
			ValaLintFileData _tmp124_;
			ValaLintFileData _tmp125_ = {0};
			ValaLintFileData _tmp126_;
#line 196 "../src/Application.vala"
			_data_index = _data_index + 1;
#line 196 "../src/Application.vala"
			_tmp119_ = _data_index;
#line 196 "../src/Application.vala"
			_tmp120_ = _data_size;
#line 196 "../src/Application.vala"
			if (!(_tmp119_ < _tmp120_)) {
#line 196 "../src/Application.vala"
				break;
#line 1334 "Application.c"
			}
#line 196 "../src/Application.vala"
			_tmp121_ = _data_list;
#line 196 "../src/Application.vala"
			_tmp122_ = vala_list_get ((ValaList*) _tmp121_, _data_index);
#line 196 "../src/Application.vala"
			_tmp123_ = (ValaLintFileData*) _tmp122_;
#line 196 "../src/Application.vala"
			_tmp124_ = *_tmp123_;
#line 196 "../src/Application.vala"
			vala_lint_file_data_copy (&_tmp124_, &_tmp125_);
#line 196 "../src/Application.vala"
			_tmp126_ = _tmp125_;
#line 196 "../src/Application.vala"
			_vala_lint_file_data_free0 (_tmp123_);
#line 196 "../src/Application.vala"
			data = _tmp126_;
#line 1352 "Application.c"
			{
				ValaArrayList* mistakes = NULL;
				ValaLintLinter* _tmp127_;
				ValaLintFileData _tmp128_;
				GFile* _tmp129_;
				ValaArrayList* _tmp130_;
				ValaLintFileData _tmp134_;
				ValaArrayList* _tmp135_;
				ValaArrayList* _tmp136_;
#line 198 "../src/Application.vala"
				_tmp127_ = linter;
#line 198 "../src/Application.vala"
				_tmp128_ = data;
#line 198 "../src/Application.vala"
				_tmp129_ = _tmp128_.file;
#line 198 "../src/Application.vala"
				_tmp130_ = vala_lint_linter_run_checks_for_file (_tmp127_, _tmp129_, &_inner_error0_);
#line 198 "../src/Application.vala"
				mistakes = _tmp130_;
#line 198 "../src/Application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1374 "Application.c"
					goto __catch4_g_error;
				}
#line 199 "../src/Application.vala"
				if (vala_lint_application_auto_fix) {
#line 1379 "Application.c"
					ValaLintFixer* _tmp131_;
					ValaLintFileData _tmp132_;
					GFile* _tmp133_;
#line 200 "../src/Application.vala"
					_tmp131_ = fixer;
#line 200 "../src/Application.vala"
					_tmp132_ = data;
#line 200 "../src/Application.vala"
					_tmp133_ = _tmp132_.file;
#line 200 "../src/Application.vala"
					vala_lint_fixer_apply_fixes_for_file (_tmp131_, _tmp133_, &mistakes, &_inner_error0_);
#line 200 "../src/Application.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "../src/Application.vala"
						_vala_iterable_unref0 (mistakes);
#line 1395 "Application.c"
						goto __catch4_g_error;
					}
				}
#line 202 "../src/Application.vala"
				_tmp134_ = data;
#line 202 "../src/Application.vala"
				_tmp135_ = _tmp134_.mistakes;
#line 202 "../src/Application.vala"
				_tmp136_ = mistakes;
#line 202 "../src/Application.vala"
				vala_collection_add_all ((ValaCollection*) _tmp135_, (ValaCollection*) _tmp136_);
#line 197 "../src/Application.vala"
				_vala_iterable_unref0 (mistakes);
#line 1409 "Application.c"
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				gchar* _tmp137_;
				gchar* _tmp138_;
				GError* _tmp139_;
				const gchar* _tmp140_;
				ValaLintFileData _tmp141_;
				GFile* _tmp142_;
				gchar* _tmp143_;
				gchar* _tmp144_;
#line 197 "../src/Application.vala"
				e = _inner_error0_;
#line 197 "../src/Application.vala"
				_inner_error0_ = NULL;
#line 204 "../src/Application.vala"
				_tmp137_ = g_strconcat (_ ("Error: %s while linting file %s"), "\n", NULL);
#line 204 "../src/Application.vala"
				_tmp138_ = _tmp137_;
#line 204 "../src/Application.vala"
				_tmp139_ = e;
#line 204 "../src/Application.vala"
				_tmp140_ = _tmp139_->message;
#line 204 "../src/Application.vala"
				_tmp141_ = data;
#line 204 "../src/Application.vala"
				_tmp142_ = _tmp141_.file;
#line 204 "../src/Application.vala"
				_tmp143_ = g_file_get_path (_tmp142_);
#line 204 "../src/Application.vala"
				_tmp144_ = _tmp143_;
#line 204 "../src/Application.vala"
				g_critical (_tmp138_, _tmp140_, _tmp144_);
#line 204 "../src/Application.vala"
				_g_free0 (_tmp144_);
#line 204 "../src/Application.vala"
				_g_free0 (_tmp138_);
#line 197 "../src/Application.vala"
				_g_error_free0 (e);
#line 1451 "Application.c"
			}
			__finally4:
#line 197 "../src/Application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1456 "Application.c"
				gint _tmp145_ = -1;
#line 197 "../src/Application.vala"
				vala_lint_file_data_destroy (&data);
#line 197 "../src/Application.vala"
				_g_object_unref0 (fixer);
#line 197 "../src/Application.vala"
				_g_object_unref0 (linter);
#line 197 "../src/Application.vala"
				_vala_iterable_unref0 (file_data_list);
#line 197 "../src/Application.vala"
				_g_free0 (contents);
#line 197 "../src/Application.vala"
				_g_free0 (fallback_path);
#line 197 "../src/Application.vala"
				_g_free0 (ignore_filepath);
#line 197 "../src/Application.vala"
				_g_free0 (ignore_root);
#line 197 "../src/Application.vala"
				ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 197 "../src/Application.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 197 "../src/Application.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/Application.vala"
				g_clear_error (&_inner_error0_);
#line 197 "../src/Application.vala"
				return _tmp145_;
#line 1484 "Application.c"
			}
#line 196 "../src/Application.vala"
			vala_lint_file_data_destroy (&data);
#line 1488 "Application.c"
		}
	}
#line 209 "../src/Application.vala"
	has_errors = FALSE;
#line 210 "../src/Application.vala"
	if (vala_lint_application_json_output) {
#line 1495 "Application.c"
		ValaArrayList* _tmp146_;
#line 211 "../src/Application.vala"
		_tmp146_ = file_data_list;
#line 211 "../src/Application.vala"
		has_errors = vala_lint_application_print_mistakes_json (self, _tmp146_);
#line 1501 "Application.c"
	} else {
		ValaArrayList* _tmp147_;
#line 213 "../src/Application.vala"
		_tmp147_ = file_data_list;
#line 213 "../src/Application.vala"
		has_errors = vala_lint_application_print_mistakes (self, _tmp147_);
#line 1508 "Application.c"
	}
#line 216 "../src/Application.vala"
	if (vala_lint_application_exit_with_zero) {
#line 216 "../src/Application.vala"
		_tmp148_ = TRUE;
#line 1514 "Application.c"
	} else {
#line 216 "../src/Application.vala"
		_tmp148_ = !has_errors;
#line 1518 "Application.c"
	}
#line 216 "../src/Application.vala"
	if (_tmp148_) {
#line 217 "../src/Application.vala"
		result = 0;
#line 217 "../src/Application.vala"
		_g_object_unref0 (fixer);
#line 217 "../src/Application.vala"
		_g_object_unref0 (linter);
#line 217 "../src/Application.vala"
		_vala_iterable_unref0 (file_data_list);
#line 217 "../src/Application.vala"
		_g_free0 (contents);
#line 217 "../src/Application.vala"
		_g_free0 (fallback_path);
#line 217 "../src/Application.vala"
		_g_free0 (ignore_filepath);
#line 217 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 217 "../src/Application.vala"
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 217 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 217 "../src/Application.vala"
		return result;
#line 1544 "Application.c"
	} else {
#line 219 "../src/Application.vala"
		result = 1;
#line 219 "../src/Application.vala"
		_g_object_unref0 (fixer);
#line 219 "../src/Application.vala"
		_g_object_unref0 (linter);
#line 219 "../src/Application.vala"
		_vala_iterable_unref0 (file_data_list);
#line 219 "../src/Application.vala"
		_g_free0 (contents);
#line 219 "../src/Application.vala"
		_g_free0 (fallback_path);
#line 219 "../src/Application.vala"
		_g_free0 (ignore_filepath);
#line 219 "../src/Application.vala"
		_g_free0 (ignore_root);
#line 219 "../src/Application.vala"
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 219 "../src/Application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 219 "../src/Application.vala"
		return result;
#line 1568 "Application.c"
	}
	{
		ValaArrayList* _file_data_list = NULL;
		ValaArrayList* _tmp149_;
		gint _file_data_size = 0;
		ValaArrayList* _tmp150_;
		gint _tmp151_;
		gint _tmp152_;
		gint _file_data_index = 0;
#line 222 "../src/Application.vala"
		_tmp149_ = file_data_list;
#line 222 "../src/Application.vala"
		_file_data_list = _tmp149_;
#line 222 "../src/Application.vala"
		_tmp150_ = _file_data_list;
#line 222 "../src/Application.vala"
		_tmp151_ = vala_collection_get_size ((ValaCollection*) _tmp150_);
#line 222 "../src/Application.vala"
		_tmp152_ = _tmp151_;
#line 222 "../src/Application.vala"
		_file_data_size = _tmp152_;
#line 222 "../src/Application.vala"
		_file_data_index = -1;
#line 222 "../src/Application.vala"
		while (TRUE) {
#line 1594 "Application.c"
			gint _tmp153_;
			gint _tmp154_;
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp155_;
			gpointer _tmp156_;
			ValaLintFileData* _tmp157_;
			ValaLintFileData _tmp158_;
			ValaLintFileData _tmp159_ = {0};
			ValaLintFileData _tmp160_;
#line 222 "../src/Application.vala"
			_file_data_index = _file_data_index + 1;
#line 222 "../src/Application.vala"
			_tmp153_ = _file_data_index;
#line 222 "../src/Application.vala"
			_tmp154_ = _file_data_size;
#line 222 "../src/Application.vala"
			if (!(_tmp153_ < _tmp154_)) {
#line 222 "../src/Application.vala"
				break;
#line 1614 "Application.c"
			}
#line 222 "../src/Application.vala"
			_tmp155_ = _file_data_list;
#line 222 "../src/Application.vala"
			_tmp156_ = vala_list_get ((ValaList*) _tmp155_, _file_data_index);
#line 222 "../src/Application.vala"
			_tmp157_ = (ValaLintFileData*) _tmp156_;
#line 222 "../src/Application.vala"
			_tmp158_ = *_tmp157_;
#line 222 "../src/Application.vala"
			vala_lint_file_data_copy (&_tmp158_, &_tmp159_);
#line 222 "../src/Application.vala"
			_tmp160_ = _tmp159_;
#line 222 "../src/Application.vala"
			_vala_lint_file_data_free0 (_tmp157_);
#line 222 "../src/Application.vala"
			file_data = _tmp160_;
#line 1632 "Application.c"
			{
				ValaArrayList* _mistake_list = NULL;
				ValaLintFileData _tmp161_;
				ValaArrayList* _tmp162_;
				gint _mistake_size = 0;
				ValaArrayList* _tmp163_;
				gint _tmp164_;
				gint _tmp165_;
				gint _mistake_index = 0;
#line 223 "../src/Application.vala"
				_tmp161_ = file_data;
#line 223 "../src/Application.vala"
				_tmp162_ = _tmp161_.mistakes;
#line 223 "../src/Application.vala"
				_mistake_list = _tmp162_;
#line 223 "../src/Application.vala"
				_tmp163_ = _mistake_list;
#line 223 "../src/Application.vala"
				_tmp164_ = vala_collection_get_size ((ValaCollection*) _tmp163_);
#line 223 "../src/Application.vala"
				_tmp165_ = _tmp164_;
#line 223 "../src/Application.vala"
				_mistake_size = _tmp165_;
#line 223 "../src/Application.vala"
				_mistake_index = -1;
#line 223 "../src/Application.vala"
				while (TRUE) {
#line 1660 "Application.c"
					gint _tmp166_;
					gint _tmp167_;
					ValaLintFormatMistake* mistake = NULL;
					ValaArrayList* _tmp168_;
					gpointer _tmp169_;
					ValaLintFormatMistake* _tmp170_;
					ValaLintCheck* _tmp171_;
					ValaLintConfigState _tmp172_;
					ValaLintConfigState _tmp173_;
#line 223 "../src/Application.vala"
					_mistake_index = _mistake_index + 1;
#line 223 "../src/Application.vala"
					_tmp166_ = _mistake_index;
#line 223 "../src/Application.vala"
					_tmp167_ = _mistake_size;
#line 223 "../src/Application.vala"
					if (!(_tmp166_ < _tmp167_)) {
#line 223 "../src/Application.vala"
						break;
#line 1680 "Application.c"
					}
#line 223 "../src/Application.vala"
					_tmp168_ = _mistake_list;
#line 223 "../src/Application.vala"
					_tmp169_ = vala_list_get ((ValaList*) _tmp168_, _mistake_index);
#line 223 "../src/Application.vala"
					mistake = (ValaLintFormatMistake*) _tmp169_;
#line 224 "../src/Application.vala"
					_tmp170_ = mistake;
#line 224 "../src/Application.vala"
					_tmp171_ = (*_tmp170_).check;
#line 224 "../src/Application.vala"
					_tmp172_ = vala_lint_check_get_state (_tmp171_);
#line 224 "../src/Application.vala"
					_tmp173_ = _tmp172_;
#line 224 "../src/Application.vala"
					if (_tmp173_ == VALA_LINT_CONFIG_STATE_ERROR) {
#line 225 "../src/Application.vala"
						result = 1;
#line 225 "../src/Application.vala"
						__vala_ValaLintFormatMistake_free0 (mistake);
#line 225 "../src/Application.vala"
						vala_lint_file_data_destroy (&file_data);
#line 225 "../src/Application.vala"
						_g_object_unref0 (fixer);
#line 225 "../src/Application.vala"
						_g_object_unref0 (linter);
#line 225 "../src/Application.vala"
						_vala_iterable_unref0 (file_data_list);
#line 225 "../src/Application.vala"
						_g_free0 (contents);
#line 225 "../src/Application.vala"
						_g_free0 (fallback_path);
#line 225 "../src/Application.vala"
						_g_free0 (ignore_filepath);
#line 225 "../src/Application.vala"
						_g_free0 (ignore_root);
#line 225 "../src/Application.vala"
						ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 225 "../src/Application.vala"
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 225 "../src/Application.vala"
						return result;
#line 1724 "Application.c"
					}
#line 223 "../src/Application.vala"
					__vala_ValaLintFormatMistake_free0 (mistake);
#line 1728 "Application.c"
				}
			}
#line 222 "../src/Application.vala"
			vala_lint_file_data_destroy (&file_data);
#line 1733 "Application.c"
		}
	}
#line 230 "../src/Application.vala"
	result = 0;
#line 230 "../src/Application.vala"
	_g_object_unref0 (fixer);
#line 230 "../src/Application.vala"
	_g_object_unref0 (linter);
#line 230 "../src/Application.vala"
	_vala_iterable_unref0 (file_data_list);
#line 230 "../src/Application.vala"
	_g_free0 (contents);
#line 230 "../src/Application.vala"
	_g_free0 (fallback_path);
#line 230 "../src/Application.vala"
	_g_free0 (ignore_filepath);
#line 230 "../src/Application.vala"
	_g_free0 (ignore_root);
#line 230 "../src/Application.vala"
	ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
#line 230 "../src/Application.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 230 "../src/Application.vala"
	return result;
#line 1758 "Application.c"
}

static ValaLintFormatMistake*
_vala_lint_format_mistake_dup (ValaLintFormatMistake* self)
{
	ValaLintFormatMistake* dup;
#line 260 "../src/Application.vala"
	dup = g_new0 (ValaLintFormatMistake, 1);
#line 260 "../src/Application.vala"
	vala_lint_format_mistake_copy (self, dup);
#line 260 "../src/Application.vala"
	return dup;
#line 1771 "Application.c"
}

static ValaArrayList*
vala_lint_application_get_files (ValaLintApplication* self,
                                 GApplicationCommandLine* command_line,
                                 gchar** patterns,
                                 gint patterns_length1,
                                 gchar** ignore_patterns,
                                 gint ignore_patterns_length1,
                                 GError** error)
{
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp19_;
	ValaArrayList* _tmp20_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result;
#line 233 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/Application.vala"
	g_return_val_if_fail (command_line != NULL, NULL);
#line 1796 "Application.c"
	{
		gchar** pattern_collection = NULL;
		gint pattern_collection_length1 = 0;
		gint _pattern_collection_size_ = 0;
		gint pattern_it = 0;
#line 236 "../src/Application.vala"
		pattern_collection = ignore_patterns;
#line 236 "../src/Application.vala"
		pattern_collection_length1 = ignore_patterns_length1;
#line 236 "../src/Application.vala"
		for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
#line 1808 "Application.c"
			gchar* _tmp0_;
			gchar* pattern = NULL;
#line 236 "../src/Application.vala"
			_tmp0_ = g_strdup (pattern_collection[pattern_it]);
#line 236 "../src/Application.vala"
			pattern = _tmp0_;
#line 1815 "Application.c"
			{
				const gchar* _tmp1_;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
#line 237 "../src/Application.vala"
				_tmp1_ = vala_lint_application_ignore_pattern_list;
#line 237 "../src/Application.vala"
				_tmp2_ = pattern;
#line 237 "../src/Application.vala"
				_tmp3_ = g_strconcat ("|", _tmp2_, NULL);
#line 237 "../src/Application.vala"
				_tmp4_ = _tmp3_;
#line 237 "../src/Application.vala"
				_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 237 "../src/Application.vala"
				_g_free0 (vala_lint_application_ignore_pattern_list);
#line 237 "../src/Application.vala"
				vala_lint_application_ignore_pattern_list = _tmp5_;
#line 237 "../src/Application.vala"
				_g_free0 (_tmp4_);
#line 236 "../src/Application.vala"
				_g_free0 (pattern);
#line 1840 "Application.c"
			}
		}
	}
#line 240 "../src/Application.vala"
	_tmp6_ = vala_lint_application_ignore_pattern_list;
#line 240 "../src/Application.vala"
	g_debug ("Application.vala:240: Ignore pattern list: %s", _tmp6_);
#line 241 "../src/Application.vala"
	_tmp7_ = vala_lint_application_ignore_pattern_list;
#line 241 "../src/Application.vala"
	_tmp8_ = strlen (_tmp7_);
#line 241 "../src/Application.vala"
	_tmp9_ = _tmp8_;
#line 241 "../src/Application.vala"
	if (_tmp9_ > 0) {
#line 1856 "Application.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 242 "../src/Application.vala"
		_tmp10_ = vala_lint_application_ignore_pattern_list;
#line 242 "../src/Application.vala"
		_tmp11_ = vala_lint_application_ignore_pattern_list;
#line 242 "../src/Application.vala"
		_tmp12_ = strlen (_tmp11_);
#line 242 "../src/Application.vala"
		_tmp13_ = _tmp12_;
#line 242 "../src/Application.vala"
		_tmp14_ = string_slice (_tmp10_, (glong) 1, (glong) _tmp13_);
#line 242 "../src/Application.vala"
		_tmp15_ = _tmp14_;
#line 242 "../src/Application.vala"
		_tmp16_ = g_strconcat ("+(", _tmp15_, NULL);
#line 242 "../src/Application.vala"
		_tmp17_ = _tmp16_;
#line 242 "../src/Application.vala"
		_tmp18_ = g_strconcat (_tmp17_, ")", NULL);
#line 242 "../src/Application.vala"
		_g_free0 (vala_lint_application_ignore_pattern_list);
#line 242 "../src/Application.vala"
		vala_lint_application_ignore_pattern_list = _tmp18_;
#line 242 "../src/Application.vala"
		_g_free0 (_tmp17_);
#line 242 "../src/Application.vala"
		_g_free0 (_tmp15_);
#line 1892 "Application.c"
	}
#line 245 "../src/Application.vala"
	_tmp19_ = g_direct_equal;
#line 245 "../src/Application.vala"
	_tmp20_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp19_);
#line 245 "../src/Application.vala"
	_result_ = _tmp20_;
#line 1900 "Application.c"
	{
		gchar** pattern_collection = NULL;
		gint pattern_collection_length1 = 0;
		gint _pattern_collection_size_ = 0;
		gint pattern_it = 0;
#line 246 "../src/Application.vala"
		pattern_collection = patterns;
#line 246 "../src/Application.vala"
		pattern_collection_length1 = patterns_length1;
#line 246 "../src/Application.vala"
		for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
#line 1912 "Application.c"
			gchar* _tmp21_;
			gchar* pattern = NULL;
#line 246 "../src/Application.vala"
			_tmp21_ = g_strdup (pattern_collection[pattern_it]);
#line 246 "../src/Application.vala"
			pattern = _tmp21_;
#line 1919 "Application.c"
			{
				glob_t matcher = {0};
				const gchar* _tmp22_;
				glob_t _tmp26_;
				gchar** _tmp27_;
				gint _tmp27__length1;
#line 247 "../src/Application.vala"
				memset (&matcher, 0, sizeof (glob_t));
#line 249 "../src/Application.vala"
				_tmp22_ = pattern;
#line 249 "../src/Application.vala"
				if (glob (_tmp22_, 0, NULL, &matcher) != 0) {
#line 1932 "Application.c"
					gchar* _tmp23_;
					gchar* _tmp24_;
					const gchar* _tmp25_;
#line 250 "../src/Application.vala"
					_tmp23_ = g_strconcat (_ ("No files found for pattern: %s"), "\n", NULL);
#line 250 "../src/Application.vala"
					_tmp24_ = _tmp23_;
#line 250 "../src/Application.vala"
					_tmp25_ = pattern;
#line 250 "../src/Application.vala"
					g_application_command_line_print (command_line, _tmp24_, _tmp25_);
#line 250 "../src/Application.vala"
					_g_free0 (_tmp24_);
#line 251 "../src/Application.vala"
					globfree (&matcher);
#line 251 "../src/Application.vala"
					_g_free0 (pattern);
#line 251 "../src/Application.vala"
					continue;
#line 1952 "Application.c"
				}
#line 254 "../src/Application.vala"
				_tmp26_ = matcher;
#line 254 "../src/Application.vala"
				_tmp27_ = _tmp26_.gl_pathv;
#line 254 "../src/Application.vala"
				_tmp27__length1 = _vala_array_length (_tmp26_.gl_pathv);
#line 1960 "Application.c"
				{
					gchar** path_collection = NULL;
					gint path_collection_length1 = 0;
					gint _path_collection_size_ = 0;
					gint path_it = 0;
#line 254 "../src/Application.vala"
					path_collection = _tmp27_;
#line 254 "../src/Application.vala"
					path_collection_length1 = _tmp27__length1;
#line 254 "../src/Application.vala"
					for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 1972 "Application.c"
						gchar* _tmp28_;
						gchar* path = NULL;
#line 254 "../src/Application.vala"
						_tmp28_ = g_strdup (path_collection[path_it]);
#line 254 "../src/Application.vala"
						path = _tmp28_;
#line 1979 "Application.c"
						{
							GFile* file = NULL;
							const gchar* _tmp29_;
							GFile* _tmp30_;
							GFileType file_type = 0;
							GFile* _tmp31_;
#line 255 "../src/Application.vala"
							_tmp29_ = path;
#line 255 "../src/Application.vala"
							_tmp30_ = g_file_new_for_path (_tmp29_);
#line 255 "../src/Application.vala"
							file = _tmp30_;
#line 256 "../src/Application.vala"
							_tmp31_ = file;
#line 256 "../src/Application.vala"
							file_type = g_file_query_file_type (_tmp31_, G_FILE_QUERY_INFO_NONE, NULL);
#line 258 "../src/Application.vala"
							switch (file_type) {
#line 258 "../src/Application.vala"
								case G_FILE_TYPE_REGULAR:
#line 2000 "Application.c"
								{
									ValaArrayList* _tmp32_;
									GFile* _tmp33_;
									const gchar* _tmp34_;
									GEqualFunc _tmp35_;
									ValaArrayList* _tmp36_;
									ValaArrayList* _tmp37_;
									ValaLintFileData _tmp38_ = {0};
#line 260 "../src/Application.vala"
									_tmp32_ = _result_;
#line 260 "../src/Application.vala"
									_tmp33_ = file;
#line 260 "../src/Application.vala"
									_tmp34_ = path;
#line 260 "../src/Application.vala"
									_tmp35_ = g_direct_equal;
#line 260 "../src/Application.vala"
									_tmp36_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp35_);
#line 260 "../src/Application.vala"
									_tmp37_ = _tmp36_;
#line 260 "../src/Application.vala"
									_g_object_unref0 (_tmp38_.file);
#line 260 "../src/Application.vala"
									_tmp38_.file = _tmp33_;
#line 260 "../src/Application.vala"
									_g_free0 (_tmp38_.name);
#line 260 "../src/Application.vala"
									_tmp38_.name = _tmp34_;
#line 260 "../src/Application.vala"
									_vala_iterable_unref0 (_tmp38_.mistakes);
#line 260 "../src/Application.vala"
									_tmp38_.mistakes = _tmp37_;
#line 260 "../src/Application.vala"
									vala_collection_add ((ValaCollection*) _tmp32_, &_tmp38_);
#line 260 "../src/Application.vala"
									_vala_iterable_unref0 (_tmp37_);
#line 261 "../src/Application.vala"
									break;
#line 2039 "Application.c"
								}
#line 258 "../src/Application.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 2043 "Application.c"
								{
									GFile* _tmp39_;
									GFile* _tmp40_;
									ValaArrayList* _tmp41_ = NULL;
									GFile* _tmp42_;
									ValaArrayList* _tmp43_;
#line 264 "../src/Application.vala"
									_tmp39_ = file;
#line 264 "../src/Application.vala"
									_tmp40_ = _g_object_ref0 (_tmp39_);
#line 264 "../src/Application.vala"
									_g_object_unref0 (vala_lint_application_root_dir);
#line 264 "../src/Application.vala"
									vala_lint_application_root_dir = _tmp40_;
#line 265 "../src/Application.vala"
									_tmp42_ = file;
#line 265 "../src/Application.vala"
									_tmp43_ = vala_lint_application_get_files_from_directory (self, _tmp42_, &_inner_error0_);
#line 265 "../src/Application.vala"
									_tmp41_ = _tmp43_;
#line 265 "../src/Application.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "../src/Application.vala"
										g_propagate_error (error, _inner_error0_);
#line 265 "../src/Application.vala"
										_g_object_unref0 (file);
#line 265 "../src/Application.vala"
										_g_free0 (path);
#line 265 "../src/Application.vala"
										globfree (&matcher);
#line 265 "../src/Application.vala"
										_g_free0 (pattern);
#line 265 "../src/Application.vala"
										_vala_iterable_unref0 (_result_);
#line 265 "../src/Application.vala"
										return NULL;
#line 2080 "Application.c"
									}
									{
										ValaArrayList* _f_list = NULL;
										gint _f_size = 0;
										ValaArrayList* _tmp44_;
										gint _tmp45_;
										gint _tmp46_;
										gint _f_index = 0;
#line 265 "../src/Application.vala"
										_f_list = _tmp41_;
#line 265 "../src/Application.vala"
										_tmp44_ = _f_list;
#line 265 "../src/Application.vala"
										_tmp45_ = vala_collection_get_size ((ValaCollection*) _tmp44_);
#line 265 "../src/Application.vala"
										_tmp46_ = _tmp45_;
#line 265 "../src/Application.vala"
										_f_size = _tmp46_;
#line 265 "../src/Application.vala"
										_f_index = -1;
#line 265 "../src/Application.vala"
										while (TRUE) {
#line 2103 "Application.c"
											gint _tmp47_;
											gint _tmp48_;
											GFile* f = NULL;
											ValaArrayList* _tmp49_;
											gpointer _tmp50_;
											gchar* name = NULL;
											const gchar* _tmp51_;
											GFile* _tmp52_;
											GFile* _tmp53_;
											gchar* _tmp54_;
											gchar* _tmp55_;
											gchar* _tmp56_;
											gchar* _tmp57_;
											ValaArrayList* _tmp58_;
											GFile* _tmp59_;
											const gchar* _tmp60_;
											GEqualFunc _tmp61_;
											ValaArrayList* _tmp62_;
											ValaArrayList* _tmp63_;
											ValaLintFileData _tmp64_ = {0};
#line 265 "../src/Application.vala"
											_f_index = _f_index + 1;
#line 265 "../src/Application.vala"
											_tmp47_ = _f_index;
#line 265 "../src/Application.vala"
											_tmp48_ = _f_size;
#line 265 "../src/Application.vala"
											if (!(_tmp47_ < _tmp48_)) {
#line 265 "../src/Application.vala"
												break;
#line 2134 "Application.c"
											}
#line 265 "../src/Application.vala"
											_tmp49_ = _f_list;
#line 265 "../src/Application.vala"
											_tmp50_ = vala_list_get ((ValaList*) _tmp49_, _f_index);
#line 265 "../src/Application.vala"
											f = (GFile*) _tmp50_;
#line 266 "../src/Application.vala"
											_tmp51_ = path;
#line 266 "../src/Application.vala"
											_tmp52_ = file;
#line 266 "../src/Application.vala"
											_tmp53_ = f;
#line 266 "../src/Application.vala"
											_tmp54_ = g_file_get_relative_path (_tmp52_, _tmp53_);
#line 266 "../src/Application.vala"
											_tmp55_ = _tmp54_;
#line 266 "../src/Application.vala"
											_tmp56_ = g_strconcat (_tmp51_, _tmp55_, NULL);
#line 266 "../src/Application.vala"
											_tmp57_ = _tmp56_;
#line 266 "../src/Application.vala"
											_g_free0 (_tmp55_);
#line 266 "../src/Application.vala"
											name = _tmp57_;
#line 267 "../src/Application.vala"
											_tmp58_ = _result_;
#line 267 "../src/Application.vala"
											_tmp59_ = f;
#line 267 "../src/Application.vala"
											_tmp60_ = name;
#line 267 "../src/Application.vala"
											_tmp61_ = g_direct_equal;
#line 267 "../src/Application.vala"
											_tmp62_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp61_);
#line 267 "../src/Application.vala"
											_tmp63_ = _tmp62_;
#line 267 "../src/Application.vala"
											_g_object_unref0 (_tmp64_.file);
#line 267 "../src/Application.vala"
											_tmp64_.file = _tmp59_;
#line 267 "../src/Application.vala"
											_g_free0 (_tmp64_.name);
#line 267 "../src/Application.vala"
											_tmp64_.name = _tmp60_;
#line 267 "../src/Application.vala"
											_vala_iterable_unref0 (_tmp64_.mistakes);
#line 267 "../src/Application.vala"
											_tmp64_.mistakes = _tmp63_;
#line 267 "../src/Application.vala"
											vala_collection_add ((ValaCollection*) _tmp58_, &_tmp64_);
#line 267 "../src/Application.vala"
											_vala_iterable_unref0 (_tmp63_);
#line 265 "../src/Application.vala"
											_g_free0 (name);
#line 265 "../src/Application.vala"
											_g_object_unref0 (f);
#line 2192 "Application.c"
										}
									}
#line 269 "../src/Application.vala"
									_vala_iterable_unref0 (_tmp41_);
#line 269 "../src/Application.vala"
									break;
#line 2199 "Application.c"
								}
								default:
								{
#line 272 "../src/Application.vala"
									break;
#line 2205 "Application.c"
								}
							}
#line 254 "../src/Application.vala"
							_g_object_unref0 (file);
#line 254 "../src/Application.vala"
							_g_free0 (path);
#line 2212 "Application.c"
						}
					}
				}
#line 246 "../src/Application.vala"
				globfree (&matcher);
#line 246 "../src/Application.vala"
				_g_free0 (pattern);
#line 2220 "Application.c"
			}
		}
	}
#line 277 "../src/Application.vala"
	result = _result_;
#line 277 "../src/Application.vala"
	return result;
#line 2228 "Application.c"
}

static ValaArrayList*
vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                GFile* dir,
                                                GError** error)
{
	ValaArrayList* files = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	GFileEnumerator* _tmp3_;
	GFileInfo* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result;
#line 280 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 280 "../src/Application.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 281 "../src/Application.vala"
	_tmp0_ = g_direct_equal;
#line 281 "../src/Application.vala"
	_tmp1_ = vala_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
#line 281 "../src/Application.vala"
	files = _tmp1_;
#line 282 "../src/Application.vala"
	_tmp2_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN "," G_FILE_ATTRIBUTE_STANDARD_TYPE, 0, NULL, &_inner_error0_);
#line 282 "../src/Application.vala"
	enumerator = _tmp2_;
#line 282 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/Application.vala"
		g_propagate_error (error, _inner_error0_);
#line 282 "../src/Application.vala"
		_vala_iterable_unref0 (files);
#line 282 "../src/Application.vala"
		return NULL;
#line 2268 "Application.c"
	}
#line 287 "../src/Application.vala"
	_tmp3_ = enumerator;
#line 287 "../src/Application.vala"
	_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 287 "../src/Application.vala"
	info = _tmp4_;
#line 287 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/Application.vala"
		g_propagate_error (error, _inner_error0_);
#line 287 "../src/Application.vala"
		_g_object_unref0 (enumerator);
#line 287 "../src/Application.vala"
		_vala_iterable_unref0 (files);
#line 287 "../src/Application.vala"
		return NULL;
#line 2286 "Application.c"
	}
#line 288 "../src/Application.vala"
	while (TRUE) {
#line 2290 "Application.c"
		GFileInfo* _tmp5_;
		gchar* child_name = NULL;
		GFileInfo* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* child_file = NULL;
		const gchar* _tmp9_;
		GFile* _tmp10_;
		gchar* rel_path = NULL;
		GFile* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GFileInfo* _tmp15_;
		GFileInfo* _tmp30_ = NULL;
		GFileEnumerator* _tmp31_;
		GFileInfo* _tmp32_;
		GFileInfo* _tmp33_;
#line 288 "../src/Application.vala"
		_tmp5_ = info;
#line 288 "../src/Application.vala"
		if (!(_tmp5_ != NULL)) {
#line 288 "../src/Application.vala"
			break;
#line 2315 "Application.c"
		}
#line 289 "../src/Application.vala"
		_tmp6_ = info;
#line 289 "../src/Application.vala"
		_tmp7_ = g_file_info_get_name (_tmp6_);
#line 289 "../src/Application.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 289 "../src/Application.vala"
		child_name = _tmp8_;
#line 290 "../src/Application.vala"
		_tmp9_ = child_name;
#line 290 "../src/Application.vala"
		_tmp10_ = g_file_resolve_relative_path (dir, _tmp9_);
#line 290 "../src/Application.vala"
		child_file = _tmp10_;
#line 291 "../src/Application.vala"
		_tmp11_ = vala_lint_application_root_dir;
#line 291 "../src/Application.vala"
		_tmp12_ = child_file;
#line 291 "../src/Application.vala"
		_tmp13_ = g_file_get_relative_path (_tmp11_, _tmp12_);
#line 291 "../src/Application.vala"
		rel_path = _tmp13_;
#line 292 "../src/Application.vala"
		_tmp15_ = info;
#line 292 "../src/Application.vala"
		if (!g_file_info_get_is_hidden (_tmp15_)) {
#line 2343 "Application.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 293 "../src/Application.vala"
			_tmp16_ = vala_lint_application_ignore_pattern_list;
#line 293 "../src/Application.vala"
			_tmp17_ = rel_path;
#line 293 "../src/Application.vala"
			_tmp14_ = fnmatch (_tmp16_, _tmp17_, vala_lint_application_fnmatch_flags) != 0;
#line 2352 "Application.c"
		} else {
#line 292 "../src/Application.vala"
			_tmp14_ = FALSE;
#line 2356 "Application.c"
		}
#line 292 "../src/Application.vala"
		if (_tmp14_) {
#line 2360 "Application.c"
			GFileInfo* _tmp18_;
#line 295 "../src/Application.vala"
			_tmp18_ = info;
#line 295 "../src/Application.vala"
			if (g_file_info_get_file_type (_tmp18_) == G_FILE_TYPE_DIRECTORY) {
#line 2366 "Application.c"
				ValaArrayList* sub_files = NULL;
				GFile* _tmp19_;
				ValaArrayList* _tmp20_;
				ValaArrayList* _tmp21_;
				ValaArrayList* _tmp22_;
#line 296 "../src/Application.vala"
				_tmp19_ = child_file;
#line 296 "../src/Application.vala"
				_tmp20_ = vala_lint_application_get_files_from_directory (self, _tmp19_, &_inner_error0_);
#line 296 "../src/Application.vala"
				sub_files = _tmp20_;
#line 296 "../src/Application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../src/Application.vala"
					g_propagate_error (error, _inner_error0_);
#line 296 "../src/Application.vala"
					_g_free0 (rel_path);
#line 296 "../src/Application.vala"
					_g_object_unref0 (child_file);
#line 296 "../src/Application.vala"
					_g_free0 (child_name);
#line 296 "../src/Application.vala"
					_g_object_unref0 (info);
#line 296 "../src/Application.vala"
					_g_object_unref0 (enumerator);
#line 296 "../src/Application.vala"
					_vala_iterable_unref0 (files);
#line 296 "../src/Application.vala"
					return NULL;
#line 2396 "Application.c"
				}
#line 297 "../src/Application.vala"
				_tmp21_ = files;
#line 297 "../src/Application.vala"
				_tmp22_ = sub_files;
#line 297 "../src/Application.vala"
				vala_collection_add_all ((ValaCollection*) _tmp21_, (ValaCollection*) _tmp22_);
#line 295 "../src/Application.vala"
				_vala_iterable_unref0 (sub_files);
#line 2406 "Application.c"
			} else {
				gboolean _tmp23_ = FALSE;
				GFileInfo* _tmp24_;
#line 298 "../src/Application.vala"
				_tmp24_ = info;
#line 298 "../src/Application.vala"
				if (g_file_info_get_file_type (_tmp24_) == G_FILE_TYPE_REGULAR) {
#line 2414 "Application.c"
					const gchar* _tmp25_;
#line 299 "../src/Application.vala"
					_tmp25_ = child_name;
#line 299 "../src/Application.vala"
					_tmp23_ = g_str_has_suffix (_tmp25_, ".vala");
#line 2420 "Application.c"
				} else {
#line 298 "../src/Application.vala"
					_tmp23_ = FALSE;
#line 2424 "Application.c"
				}
#line 298 "../src/Application.vala"
				if (_tmp23_) {
#line 2428 "Application.c"
					ValaArrayList* _tmp26_;
					GFile* _tmp27_;
#line 301 "../src/Application.vala"
					_tmp26_ = files;
#line 301 "../src/Application.vala"
					_tmp27_ = child_file;
#line 301 "../src/Application.vala"
					vala_collection_add ((ValaCollection*) _tmp26_, _tmp27_);
#line 2437 "Application.c"
				} else {
					const gchar* _tmp28_;
#line 303 "../src/Application.vala"
					_tmp28_ = child_name;
#line 303 "../src/Application.vala"
					g_debug ("Application.vala:303: %s ignored - not regular Vala file", _tmp28_);
#line 2444 "Application.c"
				}
			}
		} else {
			const gchar* _tmp29_;
#line 306 "../src/Application.vala"
			_tmp29_ = rel_path;
#line 306 "../src/Application.vala"
			g_debug ("Application.vala:306: %s ignored - hidden or matches ignore pattern", _tmp29_);
#line 2453 "Application.c"
		}
#line 309 "../src/Application.vala"
		_tmp31_ = enumerator;
#line 309 "../src/Application.vala"
		_tmp32_ = g_file_enumerator_next_file (_tmp31_, NULL, &_inner_error0_);
#line 309 "../src/Application.vala"
		_tmp30_ = _tmp32_;
#line 309 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "../src/Application.vala"
			g_propagate_error (error, _inner_error0_);
#line 309 "../src/Application.vala"
			_g_free0 (rel_path);
#line 309 "../src/Application.vala"
			_g_object_unref0 (child_file);
#line 309 "../src/Application.vala"
			_g_free0 (child_name);
#line 309 "../src/Application.vala"
			_g_object_unref0 (info);
#line 309 "../src/Application.vala"
			_g_object_unref0 (enumerator);
#line 309 "../src/Application.vala"
			_vala_iterable_unref0 (files);
#line 309 "../src/Application.vala"
			return NULL;
#line 2479 "Application.c"
		}
#line 309 "../src/Application.vala"
		_tmp33_ = _tmp30_;
#line 309 "../src/Application.vala"
		_tmp30_ = NULL;
#line 309 "../src/Application.vala"
		_g_object_unref0 (info);
#line 309 "../src/Application.vala"
		info = _tmp33_;
#line 288 "../src/Application.vala"
		_g_object_unref0 (_tmp30_);
#line 288 "../src/Application.vala"
		_g_free0 (rel_path);
#line 288 "../src/Application.vala"
		_g_object_unref0 (child_file);
#line 288 "../src/Application.vala"
		_g_free0 (child_name);
#line 2497 "Application.c"
	}
#line 312 "../src/Application.vala"
	result = files;
#line 312 "../src/Application.vala"
	_g_object_unref0 (info);
#line 312 "../src/Application.vala"
	_g_object_unref0 (enumerator);
#line 312 "../src/Application.vala"
	return result;
#line 2507 "Application.c"
}

static gboolean
vala_lint_application_print_mistakes (ValaLintApplication* self,
                                      ValaArrayList* file_data_list)
{
	gint num_errors = 0;
	gint num_warnings = 0;
	const gchar* _tmp78_ = NULL;
	const gchar* _tmp79_ = NULL;
	gchar* summary = NULL;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gboolean result;
#line 315 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 315 "../src/Application.vala"
	g_return_val_if_fail (file_data_list != NULL, FALSE);
#line 316 "../src/Application.vala"
	num_errors = 0;
#line 317 "../src/Application.vala"
	num_warnings = 0;
#line 2534 "Application.c"
	{
		ValaArrayList* _file_data_list = NULL;
		gint _file_data_size = 0;
		ValaArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _file_data_index = 0;
#line 319 "../src/Application.vala"
		_file_data_list = file_data_list;
#line 319 "../src/Application.vala"
		_tmp0_ = _file_data_list;
#line 319 "../src/Application.vala"
		_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
#line 319 "../src/Application.vala"
		_tmp2_ = _tmp1_;
#line 319 "../src/Application.vala"
		_file_data_size = _tmp2_;
#line 319 "../src/Application.vala"
		_file_data_index = -1;
#line 319 "../src/Application.vala"
		while (TRUE) {
#line 2556 "Application.c"
			gint _tmp3_;
			gint _tmp4_;
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp5_;
			gpointer _tmp6_;
			ValaLintFileData* _tmp7_;
			ValaLintFileData _tmp8_;
			ValaLintFileData _tmp9_ = {0};
			ValaLintFileData _tmp10_;
			ValaLintFileData _tmp11_;
			ValaArrayList* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 319 "../src/Application.vala"
			_file_data_index = _file_data_index + 1;
#line 319 "../src/Application.vala"
			_tmp3_ = _file_data_index;
#line 319 "../src/Application.vala"
			_tmp4_ = _file_data_size;
#line 319 "../src/Application.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 319 "../src/Application.vala"
				break;
#line 2580 "Application.c"
			}
#line 319 "../src/Application.vala"
			_tmp5_ = _file_data_list;
#line 319 "../src/Application.vala"
			_tmp6_ = vala_list_get ((ValaList*) _tmp5_, _file_data_index);
#line 319 "../src/Application.vala"
			_tmp7_ = (ValaLintFileData*) _tmp6_;
#line 319 "../src/Application.vala"
			_tmp8_ = *_tmp7_;
#line 319 "../src/Application.vala"
			vala_lint_file_data_copy (&_tmp8_, &_tmp9_);
#line 319 "../src/Application.vala"
			_tmp10_ = _tmp9_;
#line 319 "../src/Application.vala"
			_vala_lint_file_data_free0 (_tmp7_);
#line 319 "../src/Application.vala"
			file_data = _tmp10_;
#line 320 "../src/Application.vala"
			_tmp11_ = file_data;
#line 320 "../src/Application.vala"
			_tmp12_ = _tmp11_.mistakes;
#line 320 "../src/Application.vala"
			_tmp13_ = vala_collection_get_is_empty ((ValaCollection*) _tmp12_);
#line 320 "../src/Application.vala"
			_tmp14_ = _tmp13_;
#line 320 "../src/Application.vala"
			if (!_tmp14_) {
#line 2608 "Application.c"
				GApplicationCommandLine* _tmp15_;
				ValaLintFileData _tmp16_;
				const gchar* _tmp17_;
#line 321 "../src/Application.vala"
				_tmp15_ = self->priv->application_command_line;
#line 321 "../src/Application.vala"
				_tmp16_ = file_data;
#line 321 "../src/Application.vala"
				_tmp17_ = _tmp16_.name;
#line 321 "../src/Application.vala"
				g_application_command_line_print (_tmp15_, "\x001b[1m\x001b[4m" "%s" "\x001b[0m\n", _tmp17_);
#line 2620 "Application.c"
				{
					ValaArrayList* _mistake_list = NULL;
					ValaLintFileData _tmp18_;
					ValaArrayList* _tmp19_;
					gint _mistake_size = 0;
					ValaArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _mistake_index = 0;
#line 323 "../src/Application.vala"
					_tmp18_ = file_data;
#line 323 "../src/Application.vala"
					_tmp19_ = _tmp18_.mistakes;
#line 323 "../src/Application.vala"
					_mistake_list = _tmp19_;
#line 323 "../src/Application.vala"
					_tmp20_ = _mistake_list;
#line 323 "../src/Application.vala"
					_tmp21_ = vala_collection_get_size ((ValaCollection*) _tmp20_);
#line 323 "../src/Application.vala"
					_tmp22_ = _tmp21_;
#line 323 "../src/Application.vala"
					_mistake_size = _tmp22_;
#line 323 "../src/Application.vala"
					_mistake_index = -1;
#line 323 "../src/Application.vala"
					while (TRUE) {
#line 2648 "Application.c"
						gint _tmp23_;
						gint _tmp24_;
						ValaLintFormatMistake mistake = {0};
						ValaArrayList* _tmp25_;
						gpointer _tmp26_;
						ValaLintFormatMistake* _tmp27_;
						ValaLintFormatMistake _tmp28_;
						ValaLintFormatMistake _tmp29_ = {0};
						ValaLintFormatMistake _tmp30_;
						ValaLintFormatMistake _tmp31_;
						ValaLintCheck* _tmp32_;
						ValaLintConfigState _tmp33_;
						ValaLintConfigState _tmp34_;
						gchar* color_state = NULL;
						gchar* _tmp37_;
						gchar* mistakes_end = NULL;
						gchar* _tmp38_;
						const gchar* _tmp44_;
						ValaLintFormatMistake _tmp45_;
						ValaLintCheck* _tmp46_;
						ValaLintConfigState _tmp47_;
						ValaLintConfigState _tmp48_;
						gchar* _tmp49_;
						GApplicationCommandLine* _tmp50_;
						const gchar* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						ValaLintFormatMistake _tmp56_;
						ValaSourceLocation _tmp57_;
						ValaLintFormatMistake _tmp58_;
						ValaSourceLocation _tmp59_;
						const gchar* _tmp60_;
						ValaLintFormatMistake _tmp61_;
						ValaLintCheck* _tmp62_;
						ValaLintConfigState _tmp63_;
						ValaLintConfigState _tmp64_;
						gchar* _tmp65_;
						gchar* _tmp66_;
						ValaLintFormatMistake _tmp67_;
						const gchar* _tmp68_;
						ValaLintFormatMistake _tmp69_;
						ValaLintCheck* _tmp70_;
						const gchar* _tmp71_;
						const gchar* _tmp72_;
#line 323 "../src/Application.vala"
						_mistake_index = _mistake_index + 1;
#line 323 "../src/Application.vala"
						_tmp23_ = _mistake_index;
#line 323 "../src/Application.vala"
						_tmp24_ = _mistake_size;
#line 323 "../src/Application.vala"
						if (!(_tmp23_ < _tmp24_)) {
#line 323 "../src/Application.vala"
							break;
#line 2705 "Application.c"
						}
#line 323 "../src/Application.vala"
						_tmp25_ = _mistake_list;
#line 323 "../src/Application.vala"
						_tmp26_ = vala_list_get ((ValaList*) _tmp25_, _mistake_index);
#line 323 "../src/Application.vala"
						_tmp27_ = (ValaLintFormatMistake*) _tmp26_;
#line 323 "../src/Application.vala"
						_tmp28_ = *_tmp27_;
#line 323 "../src/Application.vala"
						vala_lint_format_mistake_copy (&_tmp28_, &_tmp29_);
#line 323 "../src/Application.vala"
						_tmp30_ = _tmp29_;
#line 323 "../src/Application.vala"
						__vala_ValaLintFormatMistake_free0 (_tmp27_);
#line 323 "../src/Application.vala"
						mistake = _tmp30_;
#line 324 "../src/Application.vala"
						_tmp31_ = mistake;
#line 324 "../src/Application.vala"
						_tmp32_ = _tmp31_.check;
#line 324 "../src/Application.vala"
						_tmp33_ = vala_lint_check_get_state (_tmp32_);
#line 324 "../src/Application.vala"
						_tmp34_ = _tmp33_;
#line 324 "../src/Application.vala"
						switch (_tmp34_) {
#line 324 "../src/Application.vala"
							case VALA_LINT_CONFIG_STATE_ERROR:
#line 2735 "Application.c"
							{
								gint _tmp35_;
#line 326 "../src/Application.vala"
								_tmp35_ = num_errors;
#line 326 "../src/Application.vala"
								num_errors = _tmp35_ + 1;
#line 327 "../src/Application.vala"
								break;
#line 2744 "Application.c"
							}
#line 324 "../src/Application.vala"
							case VALA_LINT_CONFIG_STATE_WARN:
#line 2748 "Application.c"
							{
								gint _tmp36_;
#line 330 "../src/Application.vala"
								_tmp36_ = num_warnings;
#line 330 "../src/Application.vala"
								num_warnings = _tmp36_ + 1;
#line 331 "../src/Application.vala"
								break;
#line 2757 "Application.c"
							}
							default:
							{
#line 334 "../src/Application.vala"
								break;
#line 2763 "Application.c"
							}
						}
#line 337 "../src/Application.vala"
						_tmp37_ = g_strdup ("%-5s");
#line 337 "../src/Application.vala"
						color_state = _tmp37_;
#line 338 "../src/Application.vala"
						_tmp38_ = g_strdup ("");
#line 338 "../src/Application.vala"
						mistakes_end = _tmp38_;
#line 339 "../src/Application.vala"
						if (vala_lint_application_print_mistakes_end) {
#line 2776 "Application.c"
							ValaLintFormatMistake _tmp39_;
							ValaSourceLocation _tmp40_;
							ValaLintFormatMistake _tmp41_;
							ValaSourceLocation _tmp42_;
							gchar* _tmp43_;
#line 340 "../src/Application.vala"
							_tmp39_ = mistake;
#line 340 "../src/Application.vala"
							_tmp40_ = _tmp39_.end;
#line 340 "../src/Application.vala"
							_tmp41_ = mistake;
#line 340 "../src/Application.vala"
							_tmp42_ = _tmp41_.end;
#line 340 "../src/Application.vala"
							_tmp43_ = g_strdup_printf ("-%5i.%-3i", _tmp40_.line, _tmp42_.column);
#line 340 "../src/Application.vala"
							_g_free0 (mistakes_end);
#line 340 "../src/Application.vala"
							mistakes_end = _tmp43_;
#line 2796 "Application.c"
						}
#line 343 "../src/Application.vala"
						_tmp44_ = color_state;
#line 343 "../src/Application.vala"
						_tmp45_ = mistake;
#line 343 "../src/Application.vala"
						_tmp46_ = _tmp45_.check;
#line 343 "../src/Application.vala"
						_tmp47_ = vala_lint_check_get_state (_tmp46_);
#line 343 "../src/Application.vala"
						_tmp48_ = _tmp47_;
#line 343 "../src/Application.vala"
						_tmp49_ = vala_lint_application_apply_color_for_state (self, _tmp44_, _tmp48_);
#line 343 "../src/Application.vala"
						_g_free0 (color_state);
#line 343 "../src/Application.vala"
						color_state = _tmp49_;
#line 345 "../src/Application.vala"
						_tmp50_ = self->priv->application_command_line;
#line 345 "../src/Application.vala"
						_tmp51_ = color_state;
#line 345 "../src/Application.vala"
						_tmp52_ = g_strconcat ("\x001b[0m%5i.%-3i %s  ", _tmp51_, NULL);
#line 345 "../src/Application.vala"
						_tmp53_ = _tmp52_;
#line 345 "../src/Application.vala"
						_tmp54_ = g_strconcat (_tmp53_, "   %-45s   \033[2m%s\033[0m\n", NULL);
#line 345 "../src/Application.vala"
						_tmp55_ = _tmp54_;
#line 345 "../src/Application.vala"
						_tmp56_ = mistake;
#line 345 "../src/Application.vala"
						_tmp57_ = _tmp56_.begin;
#line 345 "../src/Application.vala"
						_tmp58_ = mistake;
#line 345 "../src/Application.vala"
						_tmp59_ = _tmp58_.begin;
#line 345 "../src/Application.vala"
						_tmp60_ = mistakes_end;
#line 345 "../src/Application.vala"
						_tmp61_ = mistake;
#line 345 "../src/Application.vala"
						_tmp62_ = _tmp61_.check;
#line 345 "../src/Application.vala"
						_tmp63_ = vala_lint_check_get_state (_tmp62_);
#line 345 "../src/Application.vala"
						_tmp64_ = _tmp63_;
#line 345 "../src/Application.vala"
						_tmp65_ = vala_lint_config_state_to_string (_tmp64_);
#line 345 "../src/Application.vala"
						_tmp66_ = _tmp65_;
#line 345 "../src/Application.vala"
						_tmp67_ = mistake;
#line 345 "../src/Application.vala"
						_tmp68_ = _tmp67_.mistake;
#line 345 "../src/Application.vala"
						_tmp69_ = mistake;
#line 345 "../src/Application.vala"
						_tmp70_ = _tmp69_.check;
#line 345 "../src/Application.vala"
						_tmp71_ = vala_lint_check_get_title (_tmp70_);
#line 345 "../src/Application.vala"
						_tmp72_ = _tmp71_;
#line 345 "../src/Application.vala"
						g_application_command_line_print (_tmp50_, _tmp55_, _tmp57_.line, _tmp59_.column, _tmp60_, _tmp66_, _tmp68_, _tmp72_);
#line 345 "../src/Application.vala"
						_g_free0 (_tmp66_);
#line 345 "../src/Application.vala"
						_g_free0 (_tmp55_);
#line 345 "../src/Application.vala"
						_g_free0 (_tmp53_);
#line 323 "../src/Application.vala"
						_g_free0 (mistakes_end);
#line 323 "../src/Application.vala"
						_g_free0 (color_state);
#line 323 "../src/Application.vala"
						vala_lint_format_mistake_destroy (&mistake);
#line 2874 "Application.c"
					}
				}
			}
#line 319 "../src/Application.vala"
			vala_lint_file_data_destroy (&file_data);
#line 2880 "Application.c"
		}
	}
#line 358 "../src/Application.vala"
	if ((num_errors + num_warnings) == 0) {
#line 2885 "Application.c"
		GApplicationCommandLine* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
#line 359 "../src/Application.vala"
		_tmp73_ = self->priv->application_command_line;
#line 359 "../src/Application.vala"
		_tmp74_ = g_strconcat ("\033[1;32m", _ ("No mistakes found"), NULL);
#line 359 "../src/Application.vala"
		_tmp75_ = _tmp74_;
#line 359 "../src/Application.vala"
		_tmp76_ = g_strconcat (_tmp75_, "\033[0m\n", NULL);
#line 359 "../src/Application.vala"
		_tmp77_ = _tmp76_;
#line 359 "../src/Application.vala"
		g_application_command_line_print (_tmp73_, "%s", _tmp77_);
#line 359 "../src/Application.vala"
		_g_free0 (_tmp77_);
#line 359 "../src/Application.vala"
		_g_free0 (_tmp75_);
#line 360 "../src/Application.vala"
		result = FALSE;
#line 360 "../src/Application.vala"
		return result;
#line 2911 "Application.c"
	}
#line 365 "../src/Application.vala"
	if (num_errors == 1) {
#line 365 "../src/Application.vala"
		_tmp78_ = _ ("error");
#line 2917 "Application.c"
	} else {
#line 365 "../src/Application.vala"
		_tmp78_ = _ ("errors");
#line 2921 "Application.c"
	}
#line 367 "../src/Application.vala"
	if (num_warnings == 1) {
#line 367 "../src/Application.vala"
		_tmp79_ = _ ("warning");
#line 2927 "Application.c"
	} else {
#line 367 "../src/Application.vala"
		_tmp79_ = _ ("warnings");
#line 2931 "Application.c"
	}
#line 363 "../src/Application.vala"
	_tmp80_ = g_strconcat ("\n", _ ("%d %s, %d %s"), NULL);
#line 363 "../src/Application.vala"
	_tmp81_ = _tmp80_;
#line 363 "../src/Application.vala"
	_tmp82_ = g_strconcat (_tmp81_, "\n", NULL);
#line 363 "../src/Application.vala"
	_tmp83_ = _tmp82_;
#line 363 "../src/Application.vala"
	_tmp84_ = g_strdup_printf (_tmp83_, num_errors, _tmp78_, num_warnings, _tmp79_);
#line 363 "../src/Application.vala"
	_tmp85_ = _tmp84_;
#line 363 "../src/Application.vala"
	_g_free0 (_tmp83_);
#line 363 "../src/Application.vala"
	_g_free0 (_tmp81_);
#line 363 "../src/Application.vala"
	summary = _tmp85_;
#line 369 "../src/Application.vala"
	if (num_errors > 0) {
#line 2953 "Application.c"
		GApplicationCommandLine* _tmp86_;
		const gchar* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
#line 370 "../src/Application.vala"
		_tmp86_ = self->priv->application_command_line;
#line 370 "../src/Application.vala"
		_tmp87_ = summary;
#line 370 "../src/Application.vala"
		_tmp88_ = vala_lint_application_apply_color_for_state (self, _tmp87_, VALA_LINT_CONFIG_STATE_ERROR);
#line 370 "../src/Application.vala"
		_tmp89_ = _tmp88_;
#line 370 "../src/Application.vala"
		g_application_command_line_print (_tmp86_, "%s", _tmp89_);
#line 370 "../src/Application.vala"
		_g_free0 (_tmp89_);
#line 2970 "Application.c"
	} else {
		GApplicationCommandLine* _tmp90_;
		const gchar* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
#line 372 "../src/Application.vala"
		_tmp90_ = self->priv->application_command_line;
#line 372 "../src/Application.vala"
		_tmp91_ = summary;
#line 372 "../src/Application.vala"
		_tmp92_ = vala_lint_application_apply_color_for_state (self, _tmp91_, VALA_LINT_CONFIG_STATE_WARN);
#line 372 "../src/Application.vala"
		_tmp93_ = _tmp92_;
#line 372 "../src/Application.vala"
		g_application_command_line_print (_tmp90_, "%s", _tmp93_);
#line 372 "../src/Application.vala"
		_g_free0 (_tmp93_);
#line 2988 "Application.c"
	}
#line 375 "../src/Application.vala"
	result = num_errors > 0;
#line 375 "../src/Application.vala"
	_g_free0 (summary);
#line 375 "../src/Application.vala"
	return result;
#line 2996 "Application.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 434 "../src/Application.vala"
	g_boxed_free (json_node_get_type (), self);
#line 3004 "Application.c"
}

static gboolean
vala_lint_application_print_mistakes_json (ValaLintApplication* self,
                                           ValaArrayList* file_data_list)
{
	gint num_errors = 0;
	gint num_warnings = 0;
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp78_;
	JsonBuilder* _tmp79_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp80_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp81_;
	JsonNode* _tmp82_;
	JsonGenerator* _tmp83_;
	JsonNode* _tmp84_;
	GApplicationCommandLine* _tmp85_;
	JsonGenerator* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gboolean result;
#line 378 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 378 "../src/Application.vala"
	g_return_val_if_fail (file_data_list != NULL, FALSE);
#line 379 "../src/Application.vala"
	num_errors = 0;
#line 380 "../src/Application.vala"
	num_warnings = 0;
#line 381 "../src/Application.vala"
	_tmp0_ = json_builder_new ();
#line 381 "../src/Application.vala"
	builder = _tmp0_;
#line 382 "../src/Application.vala"
	_tmp1_ = builder;
#line 382 "../src/Application.vala"
	json_builder_begin_object (_tmp1_);
#line 383 "../src/Application.vala"
	_tmp2_ = builder;
#line 383 "../src/Application.vala"
	json_builder_set_member_name (_tmp2_, "mistakes");
#line 384 "../src/Application.vala"
	_tmp3_ = builder;
#line 384 "../src/Application.vala"
	json_builder_begin_array (_tmp3_);
#line 3056 "Application.c"
	{
		ValaArrayList* _file_data_list = NULL;
		gint _file_data_size = 0;
		ValaArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _file_data_index = 0;
#line 386 "../src/Application.vala"
		_file_data_list = file_data_list;
#line 386 "../src/Application.vala"
		_tmp4_ = _file_data_list;
#line 386 "../src/Application.vala"
		_tmp5_ = vala_collection_get_size ((ValaCollection*) _tmp4_);
#line 386 "../src/Application.vala"
		_tmp6_ = _tmp5_;
#line 386 "../src/Application.vala"
		_file_data_size = _tmp6_;
#line 386 "../src/Application.vala"
		_file_data_index = -1;
#line 386 "../src/Application.vala"
		while (TRUE) {
#line 3078 "Application.c"
			gint _tmp7_;
			gint _tmp8_;
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp9_;
			gpointer _tmp10_;
			ValaLintFileData* _tmp11_;
			ValaLintFileData _tmp12_;
			ValaLintFileData _tmp13_ = {0};
			ValaLintFileData _tmp14_;
			ValaLintFileData _tmp15_;
			ValaArrayList* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 386 "../src/Application.vala"
			_file_data_index = _file_data_index + 1;
#line 386 "../src/Application.vala"
			_tmp7_ = _file_data_index;
#line 386 "../src/Application.vala"
			_tmp8_ = _file_data_size;
#line 386 "../src/Application.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 386 "../src/Application.vala"
				break;
#line 3102 "Application.c"
			}
#line 386 "../src/Application.vala"
			_tmp9_ = _file_data_list;
#line 386 "../src/Application.vala"
			_tmp10_ = vala_list_get ((ValaList*) _tmp9_, _file_data_index);
#line 386 "../src/Application.vala"
			_tmp11_ = (ValaLintFileData*) _tmp10_;
#line 386 "../src/Application.vala"
			_tmp12_ = *_tmp11_;
#line 386 "../src/Application.vala"
			vala_lint_file_data_copy (&_tmp12_, &_tmp13_);
#line 386 "../src/Application.vala"
			_tmp14_ = _tmp13_;
#line 386 "../src/Application.vala"
			_vala_lint_file_data_free0 (_tmp11_);
#line 386 "../src/Application.vala"
			file_data = _tmp14_;
#line 387 "../src/Application.vala"
			_tmp15_ = file_data;
#line 387 "../src/Application.vala"
			_tmp16_ = _tmp15_.mistakes;
#line 387 "../src/Application.vala"
			_tmp17_ = vala_collection_get_is_empty ((ValaCollection*) _tmp16_);
#line 387 "../src/Application.vala"
			_tmp18_ = _tmp17_;
#line 387 "../src/Application.vala"
			if (!_tmp18_) {
#line 3130 "Application.c"
				{
					ValaArrayList* _mistake_list = NULL;
					ValaLintFileData _tmp19_;
					ValaArrayList* _tmp20_;
					gint _mistake_size = 0;
					ValaArrayList* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gint _mistake_index = 0;
#line 388 "../src/Application.vala"
					_tmp19_ = file_data;
#line 388 "../src/Application.vala"
					_tmp20_ = _tmp19_.mistakes;
#line 388 "../src/Application.vala"
					_mistake_list = _tmp20_;
#line 388 "../src/Application.vala"
					_tmp21_ = _mistake_list;
#line 388 "../src/Application.vala"
					_tmp22_ = vala_collection_get_size ((ValaCollection*) _tmp21_);
#line 388 "../src/Application.vala"
					_tmp23_ = _tmp22_;
#line 388 "../src/Application.vala"
					_mistake_size = _tmp23_;
#line 388 "../src/Application.vala"
					_mistake_index = -1;
#line 388 "../src/Application.vala"
					while (TRUE) {
#line 3158 "Application.c"
						gint _tmp24_;
						gint _tmp25_;
						ValaLintFormatMistake mistake = {0};
						ValaArrayList* _tmp26_;
						gpointer _tmp27_;
						ValaLintFormatMistake* _tmp28_;
						ValaLintFormatMistake _tmp29_;
						ValaLintFormatMistake _tmp30_ = {0};
						ValaLintFormatMistake _tmp31_;
						ValaLintFormatMistake _tmp32_;
						ValaLintCheck* _tmp33_;
						ValaLintConfigState _tmp34_;
						ValaLintConfigState _tmp35_;
						JsonBuilder* _tmp38_;
						JsonBuilder* _tmp39_;
						JsonBuilder* _tmp40_;
						ValaLintFileData _tmp41_;
						const gchar* _tmp42_;
						JsonBuilder* _tmp43_;
						JsonBuilder* _tmp44_;
						ValaLintFormatMistake _tmp45_;
						ValaSourceLocation _tmp46_;
						JsonBuilder* _tmp47_;
						JsonBuilder* _tmp48_;
						ValaLintFormatMistake _tmp49_;
						ValaSourceLocation _tmp50_;
						JsonBuilder* _tmp59_;
						JsonBuilder* _tmp60_;
						ValaLintFormatMistake _tmp61_;
						ValaLintCheck* _tmp62_;
						ValaLintConfigState _tmp63_;
						ValaLintConfigState _tmp64_;
						gchar* _tmp65_;
						gchar* _tmp66_;
						JsonBuilder* _tmp67_;
						JsonBuilder* _tmp68_;
						ValaLintFormatMistake _tmp69_;
						const gchar* _tmp70_;
						JsonBuilder* _tmp71_;
						JsonBuilder* _tmp72_;
						ValaLintFormatMistake _tmp73_;
						ValaLintCheck* _tmp74_;
						const gchar* _tmp75_;
						const gchar* _tmp76_;
						JsonBuilder* _tmp77_;
#line 388 "../src/Application.vala"
						_mistake_index = _mistake_index + 1;
#line 388 "../src/Application.vala"
						_tmp24_ = _mistake_index;
#line 388 "../src/Application.vala"
						_tmp25_ = _mistake_size;
#line 388 "../src/Application.vala"
						if (!(_tmp24_ < _tmp25_)) {
#line 388 "../src/Application.vala"
							break;
#line 3214 "Application.c"
						}
#line 388 "../src/Application.vala"
						_tmp26_ = _mistake_list;
#line 388 "../src/Application.vala"
						_tmp27_ = vala_list_get ((ValaList*) _tmp26_, _mistake_index);
#line 388 "../src/Application.vala"
						_tmp28_ = (ValaLintFormatMistake*) _tmp27_;
#line 388 "../src/Application.vala"
						_tmp29_ = *_tmp28_;
#line 388 "../src/Application.vala"
						vala_lint_format_mistake_copy (&_tmp29_, &_tmp30_);
#line 388 "../src/Application.vala"
						_tmp31_ = _tmp30_;
#line 388 "../src/Application.vala"
						__vala_ValaLintFormatMistake_free0 (_tmp28_);
#line 388 "../src/Application.vala"
						mistake = _tmp31_;
#line 389 "../src/Application.vala"
						_tmp32_ = mistake;
#line 389 "../src/Application.vala"
						_tmp33_ = _tmp32_.check;
#line 389 "../src/Application.vala"
						_tmp34_ = vala_lint_check_get_state (_tmp33_);
#line 389 "../src/Application.vala"
						_tmp35_ = _tmp34_;
#line 389 "../src/Application.vala"
						switch (_tmp35_) {
#line 389 "../src/Application.vala"
							case VALA_LINT_CONFIG_STATE_ERROR:
#line 3244 "Application.c"
							{
								gint _tmp36_;
#line 391 "../src/Application.vala"
								_tmp36_ = num_errors;
#line 391 "../src/Application.vala"
								num_errors = _tmp36_ + 1;
#line 392 "../src/Application.vala"
								break;
#line 3253 "Application.c"
							}
#line 389 "../src/Application.vala"
							case VALA_LINT_CONFIG_STATE_WARN:
#line 3257 "Application.c"
							{
								gint _tmp37_;
#line 395 "../src/Application.vala"
								_tmp37_ = num_warnings;
#line 395 "../src/Application.vala"
								num_warnings = _tmp37_ + 1;
#line 396 "../src/Application.vala"
								break;
#line 3266 "Application.c"
							}
							default:
							{
#line 399 "../src/Application.vala"
								break;
#line 3272 "Application.c"
							}
						}
#line 402 "../src/Application.vala"
						_tmp38_ = builder;
#line 402 "../src/Application.vala"
						json_builder_begin_object (_tmp38_);
#line 403 "../src/Application.vala"
						_tmp39_ = builder;
#line 403 "../src/Application.vala"
						json_builder_set_member_name (_tmp39_, "filename");
#line 404 "../src/Application.vala"
						_tmp40_ = builder;
#line 404 "../src/Application.vala"
						_tmp41_ = file_data;
#line 404 "../src/Application.vala"
						_tmp42_ = _tmp41_.name;
#line 404 "../src/Application.vala"
						json_builder_add_string_value (_tmp40_, _tmp42_);
#line 405 "../src/Application.vala"
						_tmp43_ = builder;
#line 405 "../src/Application.vala"
						json_builder_set_member_name (_tmp43_, "line");
#line 406 "../src/Application.vala"
						_tmp44_ = builder;
#line 406 "../src/Application.vala"
						_tmp45_ = mistake;
#line 406 "../src/Application.vala"
						_tmp46_ = _tmp45_.begin;
#line 406 "../src/Application.vala"
						json_builder_add_int_value (_tmp44_, (gint64) _tmp46_.line);
#line 407 "../src/Application.vala"
						_tmp47_ = builder;
#line 407 "../src/Application.vala"
						json_builder_set_member_name (_tmp47_, "column");
#line 408 "../src/Application.vala"
						_tmp48_ = builder;
#line 408 "../src/Application.vala"
						_tmp49_ = mistake;
#line 408 "../src/Application.vala"
						_tmp50_ = _tmp49_.begin;
#line 408 "../src/Application.vala"
						json_builder_add_int_value (_tmp48_, (gint64) _tmp50_.column);
#line 409 "../src/Application.vala"
						if (vala_lint_application_print_mistakes_end) {
#line 3317 "Application.c"
							JsonBuilder* _tmp51_;
							JsonBuilder* _tmp52_;
							ValaLintFormatMistake _tmp53_;
							ValaSourceLocation _tmp54_;
							JsonBuilder* _tmp55_;
							JsonBuilder* _tmp56_;
							ValaLintFormatMistake _tmp57_;
							ValaSourceLocation _tmp58_;
#line 410 "../src/Application.vala"
							_tmp51_ = builder;
#line 410 "../src/Application.vala"
							json_builder_set_member_name (_tmp51_, "endLine");
#line 411 "../src/Application.vala"
							_tmp52_ = builder;
#line 411 "../src/Application.vala"
							_tmp53_ = mistake;
#line 411 "../src/Application.vala"
							_tmp54_ = _tmp53_.end;
#line 411 "../src/Application.vala"
							json_builder_add_int_value (_tmp52_, (gint64) _tmp54_.line);
#line 412 "../src/Application.vala"
							_tmp55_ = builder;
#line 412 "../src/Application.vala"
							json_builder_set_member_name (_tmp55_, "endColumn");
#line 413 "../src/Application.vala"
							_tmp56_ = builder;
#line 413 "../src/Application.vala"
							_tmp57_ = mistake;
#line 413 "../src/Application.vala"
							_tmp58_ = _tmp57_.end;
#line 413 "../src/Application.vala"
							json_builder_add_int_value (_tmp56_, (gint64) _tmp58_.column);
#line 3350 "Application.c"
						}
#line 415 "../src/Application.vala"
						_tmp59_ = builder;
#line 415 "../src/Application.vala"
						json_builder_set_member_name (_tmp59_, "level");
#line 416 "../src/Application.vala"
						_tmp60_ = builder;
#line 416 "../src/Application.vala"
						_tmp61_ = mistake;
#line 416 "../src/Application.vala"
						_tmp62_ = _tmp61_.check;
#line 416 "../src/Application.vala"
						_tmp63_ = vala_lint_check_get_state (_tmp62_);
#line 416 "../src/Application.vala"
						_tmp64_ = _tmp63_;
#line 416 "../src/Application.vala"
						_tmp65_ = vala_lint_config_state_to_string (_tmp64_);
#line 416 "../src/Application.vala"
						_tmp66_ = _tmp65_;
#line 416 "../src/Application.vala"
						json_builder_add_string_value (_tmp60_, _tmp66_);
#line 416 "../src/Application.vala"
						_g_free0 (_tmp66_);
#line 417 "../src/Application.vala"
						_tmp67_ = builder;
#line 417 "../src/Application.vala"
						json_builder_set_member_name (_tmp67_, "message");
#line 418 "../src/Application.vala"
						_tmp68_ = builder;
#line 418 "../src/Application.vala"
						_tmp69_ = mistake;
#line 418 "../src/Application.vala"
						_tmp70_ = _tmp69_.mistake;
#line 418 "../src/Application.vala"
						json_builder_add_string_value (_tmp68_, _tmp70_);
#line 419 "../src/Application.vala"
						_tmp71_ = builder;
#line 419 "../src/Application.vala"
						json_builder_set_member_name (_tmp71_, "ruleId");
#line 420 "../src/Application.vala"
						_tmp72_ = builder;
#line 420 "../src/Application.vala"
						_tmp73_ = mistake;
#line 420 "../src/Application.vala"
						_tmp74_ = _tmp73_.check;
#line 420 "../src/Application.vala"
						_tmp75_ = vala_lint_check_get_title (_tmp74_);
#line 420 "../src/Application.vala"
						_tmp76_ = _tmp75_;
#line 420 "../src/Application.vala"
						json_builder_add_string_value (_tmp72_, _tmp76_);
#line 421 "../src/Application.vala"
						_tmp77_ = builder;
#line 421 "../src/Application.vala"
						json_builder_end_object (_tmp77_);
#line 388 "../src/Application.vala"
						vala_lint_format_mistake_destroy (&mistake);
#line 3408 "Application.c"
					}
				}
			}
#line 386 "../src/Application.vala"
			vala_lint_file_data_destroy (&file_data);
#line 3414 "Application.c"
		}
	}
#line 425 "../src/Application.vala"
	_tmp78_ = builder;
#line 425 "../src/Application.vala"
	json_builder_end_array (_tmp78_);
#line 426 "../src/Application.vala"
	_tmp79_ = builder;
#line 426 "../src/Application.vala"
	json_builder_end_object (_tmp79_);
#line 428 "../src/Application.vala"
	_tmp80_ = json_generator_new ();
#line 428 "../src/Application.vala"
	generator = _tmp80_;
#line 429 "../src/Application.vala"
	_tmp81_ = builder;
#line 429 "../src/Application.vala"
	_tmp82_ = json_builder_get_root (_tmp81_);
#line 429 "../src/Application.vala"
	root = _tmp82_;
#line 430 "../src/Application.vala"
	_tmp83_ = generator;
#line 430 "../src/Application.vala"
	_tmp84_ = root;
#line 430 "../src/Application.vala"
	json_generator_set_root (_tmp83_, _tmp84_);
#line 431 "../src/Application.vala"
	_tmp85_ = self->priv->application_command_line;
#line 431 "../src/Application.vala"
	_tmp86_ = generator;
#line 431 "../src/Application.vala"
	_tmp87_ = json_generator_to_data (_tmp86_, NULL);
#line 431 "../src/Application.vala"
	_tmp88_ = _tmp87_;
#line 431 "../src/Application.vala"
	g_application_command_line_print (_tmp85_, "%s\n", _tmp88_);
#line 431 "../src/Application.vala"
	_g_free0 (_tmp88_);
#line 433 "../src/Application.vala"
	if ((num_errors + num_warnings) == 0) {
#line 434 "../src/Application.vala"
		result = FALSE;
#line 434 "../src/Application.vala"
		__vala_JsonNode_free0 (root);
#line 434 "../src/Application.vala"
		_g_object_unref0 (generator);
#line 434 "../src/Application.vala"
		_g_object_unref0 (builder);
#line 434 "../src/Application.vala"
		return result;
#line 3465 "Application.c"
	}
#line 437 "../src/Application.vala"
	result = num_errors > 0;
#line 437 "../src/Application.vala"
	__vala_JsonNode_free0 (root);
#line 437 "../src/Application.vala"
	_g_object_unref0 (generator);
#line 437 "../src/Application.vala"
	_g_object_unref0 (builder);
#line 437 "../src/Application.vala"
	return result;
#line 3477 "Application.c"
}

static gchar*
vala_lint_application_apply_color_for_state (ValaLintApplication* self,
                                             const gchar* str,
                                             ValaLintConfigState state)
{
	gchar* result;
#line 440 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 440 "../src/Application.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 441 "../src/Application.vala"
	switch (state) {
#line 441 "../src/Application.vala"
		case VALA_LINT_CONFIG_STATE_ERROR:
#line 3494 "Application.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 443 "../src/Application.vala"
			_tmp0_ = g_strconcat ("\033[1;31m", str, NULL);
#line 443 "../src/Application.vala"
			_tmp1_ = _tmp0_;
#line 443 "../src/Application.vala"
			_tmp2_ = g_strconcat (_tmp1_, "\033[0m", NULL);
#line 443 "../src/Application.vala"
			_tmp3_ = _tmp2_;
#line 443 "../src/Application.vala"
			_g_free0 (_tmp1_);
#line 443 "../src/Application.vala"
			result = _tmp3_;
#line 443 "../src/Application.vala"
			return result;
#line 3514 "Application.c"
		}
#line 441 "../src/Application.vala"
		case VALA_LINT_CONFIG_STATE_WARN:
#line 3518 "Application.c"
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 446 "../src/Application.vala"
			_tmp4_ = g_strconcat ("\033[1;33m", str, NULL);
#line 446 "../src/Application.vala"
			_tmp5_ = _tmp4_;
#line 446 "../src/Application.vala"
			_tmp6_ = g_strconcat (_tmp5_, "\033[0m", NULL);
#line 446 "../src/Application.vala"
			_tmp7_ = _tmp6_;
#line 446 "../src/Application.vala"
			_g_free0 (_tmp5_);
#line 446 "../src/Application.vala"
			result = _tmp7_;
#line 446 "../src/Application.vala"
			return result;
#line 3538 "Application.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 449 "../src/Application.vala"
			_tmp8_ = g_strdup (str);
#line 449 "../src/Application.vala"
			result = _tmp8_;
#line 449 "../src/Application.vala"
			return result;
#line 3549 "Application.c"
		}
	}
}

static gint
vala_lint_application_main (gchar** args,
                            gint args_length1)
{
	ValaLintApplication* _tmp0_;
	ValaLintApplication* _tmp1_;
	gint _tmp2_;
	gint result;
#line 454 "../src/Application.vala"
	_tmp0_ = vala_lint_application_new ();
#line 454 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 454 "../src/Application.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
#line 454 "../src/Application.vala"
	_g_object_unref0 (_tmp1_);
#line 454 "../src/Application.vala"
	result = _tmp2_;
#line 454 "../src/Application.vala"
	return result;
#line 3574 "Application.c"
}

int
main (int argc,
      char ** argv)
{
#line 453 "../src/Application.vala"
	return vala_lint_application_main (argv, argc);
#line 3583 "Application.c"
}

static void
vala_lint_application_class_init (ValaLintApplicationClass * klass,
                                  gpointer klass_data)
{
	gchar* _tmp0_;
#line 22 "../src/Application.vala"
	vala_lint_application_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &ValaLintApplication_private_offset);
#line 22 "../src/Application.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) vala_lint_application_real_command_line;
#line 22 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = vala_lint_application_finalize;
#line 33 "../src/Application.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/Application.vala"
	vala_lint_application_ignore_pattern_list = _tmp0_;
#line 3603 "Application.c"
}

static void
vala_lint_application_instance_init (ValaLintApplication * self,
                                     gpointer klass)
{
#line 22 "../src/Application.vala"
	self->priv = vala_lint_application_get_instance_private (self);
#line 3612 "Application.c"
}

static void
vala_lint_application_finalize (GObject * obj)
{
	ValaLintApplication * self;
#line 22 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_APPLICATION, ValaLintApplication);
#line 37 "../src/Application.vala"
	_g_object_unref0 (self->priv->application_command_line);
#line 22 "../src/Application.vala"
	G_OBJECT_CLASS (vala_lint_application_parent_class)->finalize (obj);
#line 3625 "Application.c"
}

static GType
vala_lint_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintApplication), 0, (GInstanceInitFunc) vala_lint_application_instance_init, NULL };
	GType vala_lint_application_type_id;
	vala_lint_application_type_id = g_type_register_static (g_application_get_type (), "ValaLintApplication", &g_define_type_info, 0);
	ValaLintApplication_private_offset = g_type_add_instance_private (vala_lint_application_type_id, sizeof (ValaLintApplicationPrivate));
	return vala_lint_application_type_id;
}

GType
vala_lint_application_get_type (void)
{
	static volatile gsize vala_lint_application_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_application_type_id__once)) {
		GType vala_lint_application_type_id;
		vala_lint_application_type_id = vala_lint_application_get_type_once ();
		g_once_init_leave (&vala_lint_application_type_id__once, vala_lint_application_type_id);
	}
	return vala_lint_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

